// TJC implementation of procedure compileproc_assign_default_arg
package tjc;
import tcl.lang.*;

public class CompileprocAssignDefaultArgCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "name index default_symbol");
        }
        setVarScalar(interp, "name", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "default_symbol", objv[3], compiledLocals, 2);
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $index
                TclObject[] objv0 = TJC.grabObjv(interp, 4);
                TclObject tmp1;
                try {
                    // Arg 0 constant: string
                    objv0[0] = const0;
                    // Arg 1 constant: is
                    objv0[1] = const1;
                    // Arg 2 constant: integer
                    objv0[2] = const2;
                    // Arg 3 variable: $index
                    tmp1 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 4);
                }
            } // End Invoke: string
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("index ");
                        tmp6 = getVarScalar(interp, "index", compiledLocals, 1);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append(" is not an integer");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$index < 1} ...
            // Binary operator: $index < 1
            TclObject tmp8 = getVarScalar(interp, "index", compiledLocals, 1);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp9, tmp10);
            // End Binary operator: <
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("index ");
                        tmp13 = getVarScalar(interp, "index", compiledLocals, 1);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append(" must be greater than 0");
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const4, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: emitter_indent_level +1
            TclObject[] objv15 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv15[0] = const5;
                // Arg 1 constant: +1
                objv15[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv15, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv15, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set sp ...
            TclObject tmp16;
            StringBuffer sbtmp17 = new StringBuffer(64);
            sbtmp17.append("\n");
            { // Invoke: emitter_indent
                TclObject[] objv18 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv18[0] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv18, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv18, 1);
                }
            } // End Invoke: emitter_indent
            tmp16 = interp.getResult();
            sbtmp17.append(tmp16.toString());
            tmp16 = TclString.newInstance(sbtmp17);
            setVarScalar(interp, "sp", tmp16, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: emitter_indent_level -1
            TclObject[] objv19 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv19[0] = const5;
                // Arg 1 constant: -1
                objv19[1] = const8;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv19, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv19, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set value "..."
            TclObject tmp20;
            StringBuffer sbtmp21 = new StringBuffer(64);
            tmp20 = getVarScalar(interp, "sp", compiledLocals, 4);
            sbtmp21.append(tmp20.toString());
            sbtmp21.append("((objv.length <= ");
            tmp20 = getVarScalar(interp, "index", compiledLocals, 1);
            sbtmp21.append(tmp20.toString());
            sbtmp21.append(") ? ");
            tmp20 = getVarScalar(interp, "default_symbol", compiledLocals, 2);
            sbtmp21.append(tmp20.toString());
            sbtmp21.append(" : objv");
            sbtmp21.append("[");
            tmp20 = getVarScalar(interp, "index", compiledLocals, 1);
            sbtmp21.append(tmp20.toString());
            sbtmp21.append("]");
            sbtmp21.append(")");
            tmp20 = TclString.newInstance(sbtmp21);
            setVarScalar(interp, "value", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv22 = TJC.grabObjv(interp, 1);
            TclObject tmp23;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... {} $name true $value false
                    TclObject[] objv24 = TJC.grabObjv(interp, 6);
                    TclObject tmp25;
                    try {
                        // Arg 0 constant: ...
                        objv24[0] = const9;
                        // Arg 1 constant: {}
                        objv24[1] = const4;
                        // Arg 2 variable: $name
                        tmp25 = getVarScalar(interp, "name", compiledLocals, 0);
                        tmp25.preserve();
                        objv24[2] = tmp25;
                        // Arg 3 constant: true
                        objv24[3] = const10;
                        // Arg 4 variable: $value
                        tmp25 = getVarScalar(interp, "value", compiledLocals, 5);
                        tmp25.preserve();
                        objv24[4] = tmp25;
                        // Arg 5 constant: false
                        objv24[5] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv24, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        tmp25 = objv24[2];
                        if ( tmp25 != null ) {
                            tmp25.release();
                        }
                        tmp25 = objv24[4];
                        if ( tmp25 != null ) {
                            tmp25.release();
                        }
                        TJC.releaseObjv(interp, objv24, 6);
                    }
                } // End Invoke: ...
                tmp23 = interp.getResult();
                tmp23.preserve();
                objv22[0] = tmp23;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv22, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv22, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp26 = getVarScalar(interp, "buffer", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp26);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_assign_default_arg");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_indent_level");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("+1");
        TclInteger.get(interp, const6);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_indent");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(-1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_set_variable");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("true");
        TclBoolean.get(interp, const10);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("false");
        TclBoolean.get(interp, const11);
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "compileproc_set_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "name",
        "index",
        "default_symbol",
        "buffer",
        "sp",
        "value"
    };
} // end class CompileprocAssignDefaultArgCmd

