// TJC implementation of procedure compileproc_can_inline_command
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! $_compileproc(...)
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,inline_commands", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                TclObject tmp4;
                try {
                    // Arg 0 constant: info
                    objv3[0] = const1;
                    // Arg 1 constant: exists
                    objv3[1] = const2;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("_compileproc_ckeys(");
                    tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(",info_key)");
                    tmp4 = TclString.newInstance(sbtmp5);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp9;
            { // Invoke: lindex $... 1
                TclObject tmp10;
                StringBuffer sbtmp11 = new StringBuffer(64);
                tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp11.append(tmp10.toString());
                sbtmp11.append(",info_key");
                tmp10 = getVarArray(interp, "_compileproc_ckeys", sbtmp11.toString(), compiledLocals, 2);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cmdname == "_UNKNOWN"
            TclObject tmp12 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            boolean tmp13 = tmp12.toString().equals("_UNKNOWN");
            ExprValue tmp14 = evs0;
            tmp14.setIntValue(tmp13);
            // End Binary operator: ==
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $cmdname {::append} - {append} ... {::global} - {global} ... {::incr} - {incr} ... {::lappend} - {lappend} ... {::lindex} - {lindex} ... {::list} - {list} ... {::llength} - {llength} ... {::set} - {set} ... {::string} - {string} ... default ...
            TclObject tmp16 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            String tmp17 = tmp16.toString();
            int tmp17_length = tmp17.length();
            char tmp17_first = '\n';
            if ( tmp17_length > 0 ) {
                tmp17_first = tmp17.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp17_length == 8 && tmp17_first == ':'
                    && tmp17.compareTo("::append") == 0 ) ||
                ( tmp17_length == 6 && tmp17_first == 'a'
                    && tmp17.compareTo("append") == 0 ) ) {
                // Pattern {append}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv18 = TJC.grabObjv(interp, 2);
                        TclObject tmp19;
                        try {
                            // Arg 0 constant: ...
                            objv18[0] = const3;
                            // Arg 1 variable: $key
                            tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp19.preserve();
                            objv18[1] = tmp19;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv18, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp19 = objv18[1];
                            if ( tmp19 != null ) {
                                tmp19.release();
                            }
                            TJC.releaseObjv(interp, objv18, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 8 && tmp17_first == ':'
                    && tmp17.compareTo("::global") == 0 ) ||
                ( tmp17_length == 6 && tmp17_first == 'g'
                    && tmp17.compareTo("global") == 0 ) ) {
                // Pattern {global}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv20 = TJC.grabObjv(interp, 2);
                        TclObject tmp21;
                        try {
                            // Arg 0 constant: ...
                            objv20[0] = const4;
                            // Arg 1 variable: $key
                            tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp21.preserve();
                            objv20[1] = tmp21;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv20, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp21 = objv20[1];
                            if ( tmp21 != null ) {
                                tmp21.release();
                            }
                            TJC.releaseObjv(interp, objv20, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 6 && tmp17_first == ':'
                    && tmp17.compareTo("::incr") == 0 ) ||
                ( tmp17_length == 4 && tmp17_first == 'i'
                    && tmp17.compareTo("incr") == 0 ) ) {
                // Pattern {incr}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv22 = TJC.grabObjv(interp, 2);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: ...
                            objv22[0] = const5;
                            // Arg 1 variable: $key
                            tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp23.preserve();
                            objv22[1] = tmp23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv22, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp23 = objv22[1];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 9 && tmp17_first == ':'
                    && tmp17.compareTo("::lappend") == 0 ) ||
                ( tmp17_length == 7 && tmp17_first == 'l'
                    && tmp17.compareTo("lappend") == 0 ) ) {
                // Pattern {lappend}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv24 = TJC.grabObjv(interp, 2);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: ...
                            objv24[0] = const6;
                            // Arg 1 variable: $key
                            tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp25.preserve();
                            objv24[1] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv24, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp25 = objv24[1];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 8 && tmp17_first == ':'
                    && tmp17.compareTo("::lindex") == 0 ) ||
                ( tmp17_length == 6 && tmp17_first == 'l'
                    && tmp17.compareTo("lindex") == 0 ) ) {
                // Pattern {lindex}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const7;
                            // Arg 1 variable: $key
                            tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv26, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 6 && tmp17_first == ':'
                    && tmp17.compareTo("::list") == 0 ) ||
                ( tmp17_length == 4 && tmp17_first == 'l'
                    && tmp17.compareTo("list") == 0 ) ) {
                // Pattern {list}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv28 = TJC.grabObjv(interp, 2);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: ...
                            objv28[0] = const8;
                            // Arg 1 variable: $key
                            tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp29.preserve();
                            objv28[1] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv28, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp29 = objv28[1];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 9 && tmp17_first == ':'
                    && tmp17.compareTo("::llength") == 0 ) ||
                ( tmp17_length == 7 && tmp17_first == 'l'
                    && tmp17.compareTo("llength") == 0 ) ) {
                // Pattern {llength}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv30 = TJC.grabObjv(interp, 2);
                        TclObject tmp31;
                        try {
                            // Arg 0 constant: ...
                            objv30[0] = const9;
                            // Arg 1 variable: $key
                            tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp31.preserve();
                            objv30[1] = tmp31;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv30, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp31 = objv30[1];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            TJC.releaseObjv(interp, objv30, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 5 && tmp17_first == ':'
                    && tmp17.compareTo("::set") == 0 ) ||
                ( tmp17_length == 3 && tmp17_first == 's'
                    && tmp17.compareTo("set") == 0 ) ) {
                // Pattern {set}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv32 = TJC.grabObjv(interp, 2);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: ...
                            objv32[0] = const10;
                            // Arg 1 variable: $key
                            tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv32, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( ( tmp17_length == 8 && tmp17_first == ':'
                    && tmp17.compareTo("::string") == 0 ) ||
                ( tmp17_length == 6 && tmp17_first == 's'
                    && tmp17.compareTo("string") == 0 ) ) {
                // Pattern {string}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv34 = TJC.grabObjv(interp, 2);
                        TclObject tmp35;
                        try {
                            // Arg 0 constant: ...
                            objv34[0] = const11;
                            // Arg 1 variable: $key
                            tmp35 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp35.preserve();
                            objv34[1] = tmp35;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv34, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            tmp35 = objv34[1];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            TJC.releaseObjv(interp, objv34, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_command");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_can_inline_command_append");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_can_inline_command_global");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_can_inline_command_incr");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_can_inline_command_lappend");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_can_inline_command_lindex");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_can_inline_command_list");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_can_inline_command_llength");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_can_inline_command_set");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_can_inline_command_string");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "compileproc_can_inline_command_append";
                break;
            }
            case 3: {
                cmdName = "compileproc_can_inline_command_global";
                break;
            }
            case 4: {
                cmdName = "compileproc_can_inline_command_incr";
                break;
            }
            case 5: {
                cmdName = "compileproc_can_inline_command_lappend";
                break;
            }
            case 6: {
                cmdName = "compileproc_can_inline_command_lindex";
                break;
            }
            case 7: {
                cmdName = "compileproc_can_inline_command_list";
                break;
            }
            case 8: {
                cmdName = "compileproc_can_inline_command_llength";
                break;
            }
            case 9: {
                cmdName = "compileproc_can_inline_command_set";
                break;
            }
            case 10: {
                cmdName = "compileproc_can_inline_command_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "cmdname"
    };
} // end class CompileprocCanInlineCommandCmd

