// TJC implementation of procedure compileproc_can_inline_command_global
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineCommandGlobalCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$num_args < 2} ...
            // Binary operator: $num_args < 2
            TclObject tmp6 = getVarScalar(interp, "num_args", compiledLocals, 3);
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp7, tmp8);
            // End Binary operator: <
            boolean tmp9 = ( tmp7.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: for {set i 1} {$i < $num_args} {incr i} ...
            { // Invoke: set i 1
                setVarScalar(interp, "i", const3, compiledLocals, 4);
            } // End Invoke: set
            for ( boolean skip15 = true ; true ; ) {
                if ( skip15 ) {
                    skip15 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 4);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp10 = getVarScalar(interp, "i", compiledLocals, 4);
                ExprValue tmp11 = evs0;
                TJC.exprInitValue(interp, tmp11, tmp10);
                TclObject tmp12 = getVarScalar(interp, "num_args", compiledLocals, 3);
                ExprValue tmp13 = evs1;
                TJC.exprInitValue(interp, tmp13, tmp12);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp11, tmp13);
                // End Binary operator: <
                boolean tmp14 = ( tmp11.getIntValue() != 0 );
                if ( ! tmp14 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp16;
                    { // Invoke: ... $key $i
                        TclObject[] objv17 = TJC.grabObjv(interp, 3);
                        TclObject tmp18;
                        try {
                            // Arg 0 constant: ...
                            objv17[0] = const4;
                            // Arg 1 variable: $key
                            tmp18 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp18.preserve();
                            objv17[1] = tmp18;
                            // Arg 2 variable: $i
                            tmp18 = getVarScalar(interp, "i", compiledLocals, 4);
                            tmp18.preserve();
                            objv17[2] = tmp18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv17, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp18 = objv17[1];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            tmp18 = objv17[2];
                            if ( tmp18 != null ) {
                                tmp18.release();
                            }
                            TJC.releaseObjv(interp, objv17, 3);
                        }
                    } // End Invoke: ...
                    tmp16 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp16, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set type [...]
                    TclObject tmp19;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp20 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp20 = TclList.index(interp, tmp20, 0);
                        if ( tmp20 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp20);
                        }
                    } // End Invoke: lindex
                    tmp19 = interp.getResult();
                    setVarScalar(interp, "type", tmp19, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: $type != "constant"
                    TclObject tmp21 = getVarScalar(interp, "type", compiledLocals, 6);
                    boolean tmp22 = ! tmp21.toString().equals("constant");
                    ExprValue tmp23 = evs0;
                    tmp23.setIntValue(tmp22);
                    // End Binary operator: !=
                    boolean tmp24 = ( tmp23.getIntValue() != 0 );
                    if ( tmp24 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set varname [...]
                    TclObject tmp25;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp26 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp26 = TclList.index(interp, tmp26, 1);
                        if ( tmp26 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp26);
                        }
                    } // End Invoke: lindex
                    tmp25 = interp.getResult();
                    setVarScalar(interp, "varname", tmp25, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set tail [...]
                    TclObject tmp27;
                    { // Invoke: namespace tail $varname
                        TclObject[] objv28 = TJC.grabObjv(interp, 3);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: namespace
                            objv28[0] = const5;
                            // Arg 1 constant: tail
                            objv28[1] = const6;
                            // Arg 2 variable: $varname
                            tmp29 = getVarScalar(interp, "varname", compiledLocals, 7);
                            tmp29.preserve();
                            objv28[2] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv28, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp29 = objv28[2];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 3);
                        }
                    } // End Invoke: namespace
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "tail", tmp27, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set vinfo [...]
                    TclObject tmp30;
                    { // Invoke: ... $tail
                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                        TclObject tmp32;
                        try {
                            // Arg 0 constant: ...
                            objv31[0] = const7;
                            // Arg 1 variable: $tail
                            tmp32 = getVarScalar(interp, "tail", compiledLocals, 8);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv31, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp32 = objv31[1];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 2);
                        }
                    } // End Invoke: ...
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp30, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] != "scalar"
                    { // Invoke: lindex $vinfo 0
                        TclObject tmp33 = getVarScalar(interp, "vinfo", compiledLocals, 9);
                        tmp33 = TclList.index(interp, tmp33, 0);
                        if ( tmp33 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp33);
                        }
                    } // End Invoke: lindex
                    TclObject tmp34 = interp.getResult();
                    boolean tmp35 = ! tmp34.toString().equals("scalar");
                    ExprValue tmp36 = evs0;
                    tmp36.setIntValue(tmp35);
                    // End Binary operator: !=
                    boolean tmp37 = ( tmp36.getIntValue() != 0 );
                    if ( tmp37 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const3);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_command_global");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tree");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_get_argument_tuple");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("namespace");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("tail");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_simple_variable");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 3: {
                cmdName = "namespace";
                break;
            }
            case 4: {
                cmdName = "descend_simple_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "tree",
        "num_args",
        "i",
        "tuple",
        "type",
        "varname",
        "tail",
        "vinfo"
    };
} // end class CompileprocCanInlineCommandGlobalCmd

