// TJC implementation of procedure compileproc_childkey_validate
package tjc;
import tcl.lang.*;

public class CompileprocChildkeyValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set children [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "children", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set expected_children [...]
            TclObject tmp3;
            { // Invoke: llength $children
                TclObject tmp4 = getVarScalar(interp, "children", compiledLocals, 2);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "expected_children", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_processed $...
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(",childkey_counter");
            tmp6 = getVarArray(interp, "_compileproc", sbtmp7.toString(), compiledLocals, 1);
            setVarScalar(interp, "num_processed", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $_compileproc(...) != $expected_children
            TclObject tmp8;
            StringBuffer sbtmp9 = new StringBuffer(64);
            tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp9.append(tmp8.toString());
            sbtmp9.append(",childkey_counter");
            tmp8 = getVarArray(interp, "_compileproc", sbtmp9.toString(), compiledLocals, 1);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp8);
            TclObject tmp11 = getVarScalar(interp, "expected_children", compiledLocals, 3);
            ExprValue tmp12 = evs1;
            TJC.exprInitValue(interp, tmp12, tmp11);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp12);
            // End Binary operator: !=
            boolean tmp13 = ( tmp10.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: error "..."
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: error
                        objv14[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp16 = new StringBuffer(64);
                        sbtmp16.append("expected ");
                        tmp15 = getVarScalar(interp, "expected_children", compiledLocals, 3);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append(" children, but processed ");
                        tmp15 = getVarScalar(interp, "num_processed", compiledLocals, 4);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append(" for key ");
                        tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append(", children are ");
                        sbtmp16.append("{");
                        tmp15 = getVarScalar(interp, "children", compiledLocals, 2);
                        sbtmp16.append(tmp15.toString());
                        sbtmp16.append("}");
                        tmp15 = TclString.newInstance(sbtmp16);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv14, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: error
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_childkey_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_key_children");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_key_children";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "children",
        "expected_children",
        "num_processed"
    };
} // end class CompileprocChildkeyValidateCmd

