// TJC implementation of procedure compileproc_command_cache_init_generate
package tjc;
import tcl.lang.*;

public class CompileprocCommandCacheInitGenerateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 0);
        } // End Invoke: global
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_command_cache", "_compileproc_command_cache", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists ...
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: ...
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            if ( tmp1.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp2, tmp1);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp2, tmp1);
            }
            // End Unary operator: !
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: return ""
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: emitter_indent_level
                TclObject[] objv4 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv4[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv4, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp5 = interp.getResult();
            ExprValue tmp6 = evs0;
            TJC.exprInitValue(interp, tmp6, tmp5);
            ExprValue tmp7 = evs1;
            tmp7.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp6, tmp7);
            // End Binary operator: !=
            boolean tmp8 = ( tmp6.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("expected enter indent level of 0, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv12 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv12[0] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv12, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv12, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp10 = interp.getResult();
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const3, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: emitter_indent_level +1
            TclObject[] objv13 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv13[0] = const4;
                // Arg 1 constant: +1
                objv13[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv13, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv13, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...]
            TclObject[] objv14 = TJC.grabObjv(interp, 1);
            TclObject tmp15;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv16[0] = const7;
                        // Arg 1 constant: ...
                        objv16[1] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv16, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: emitter_statement
                tmp15 = interp.getResult();
                tmp15.preserve();
                objv14[0] = tmp15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv14, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv14, 1);
            }
        } // End Invoke: append
        { // Invoke: set symbol_ids [...]
            TclObject tmp17;
            { // Invoke: list
                TclObject tmp18 = TclList.newInstance();
                interp.setResult(tmp18);
            } // End Invoke: list
            tmp17 = interp.getResult();
            setVarScalar(interp, "symbol_ids", tmp17, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: foreach cmdname $... key $... ...
            TclObject tmp19 = null;
            TclObject tmp20 = null;
            try {
                tmp19 = getVarArray(interp, "_compileproc_command_cache", "ordered_cmds", compiledLocals, 1);
                tmp19.preserve();
                tmp20 = getVarArray(interp, "_compileproc_command_cache", "ordered_keys", compiledLocals, 1);
                tmp20.preserve();
                final int tmp19_length = TclList.getLength(interp, tmp19);
                final int tmp20_length = TclList.getLength(interp, tmp20);
                int num_loops21, max_loops22 = 0;
                num_loops21 = tmp19_length;
                if ( num_loops21 > max_loops22 ) {
                    max_loops22 = num_loops21;
                }
                num_loops21 = tmp20_length;
                if ( num_loops21 > max_loops22 ) {
                    max_loops22 = num_loops21;
                }

                for ( int index23 = 0 ; index23 < max_loops22 ; index23++ ) {
                    TclObject tmp24 = null;
                    if ( index23 < tmp19_length ) {
                        tmp24 = TclList.index(interp, tmp19, index23);
                    }
                    TclObject tmp25 = null;
                    if ( index23 < tmp20_length ) {
                        tmp25 = TclList.index(interp, tmp20, index23);
                    }
                    try {
                        if ( tmp24 == null ) {
                            setVarScalar(interp, "cmdname", "", compiledLocals, 4);
                        } else {
                            setVarScalar(interp, "cmdname", tmp24, compiledLocals, 4);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmdname");
                    }
                    try {
                        if ( tmp25 == null ) {
                            setVarScalar(interp, "key", "", compiledLocals, 5);
                        } else {
                            setVarScalar(interp, "key", tmp25, compiledLocals, 5);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set symbol $...
                        TclObject tmp26;
                        tmp26 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp26 = getVarArray(interp, "_compileproc_command_cache", tmp26.toString(), compiledLocals, 1);
                        setVarScalar(interp, "symbol", tmp26, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: set cacheId [...]
                        TclObject tmp27;
                        { // Invoke: ... $symbol
                            TclObject[] objv28 = TJC.grabObjv(interp, 2);
                            TclObject tmp29;
                            try {
                                // Arg 0 constant: ...
                                objv28[0] = const9;
                                // Arg 1 variable: $symbol
                                tmp29 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                tmp29.preserve();
                                objv28[1] = tmp29;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv28, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp29 = objv28[1];
                                if ( tmp29 != null ) {
                                    tmp29.release();
                                }
                                TJC.releaseObjv(interp, objv28, 2);
                            }
                        } // End Invoke: ...
                        tmp27 = interp.getResult();
                        setVarScalar(interp, "cacheId", tmp27, compiledLocals, 7);
                    } // End Invoke: set
                    { // Invoke: lappend symbol_ids $cacheId
                        TclObject[] objv30 = TJC.grabObjv(interp, 1);
                        TclObject tmp31;
                        try {
                            // Arg 2 variable: $cacheId
                            tmp31 = getVarScalar(interp, "cacheId", compiledLocals, 7);
                            tmp31.preserve();
                            objv30[0] = tmp31;
                            interp.resetResult();
                            lappendVarScalar(interp, "symbol_ids", objv30, compiledLocals, 3);
                        } finally {
                            TJC.releaseObjvElems(interp, objv30, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: append buffer [...] [...]
                        TclObject[] objv32 = TJC.grabObjv(interp, 2);
                        TclObject tmp33;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv34 = TJC.grabObjv(interp, 2);
                                TclObject tmp35;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv34[0] = const7;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp36 = new StringBuffer(64);
                                    sbtmp36.append("WrappedCommand ");
                                    tmp35 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp36.append(tmp35.toString());
                                    tmp35 = TclString.newInstance(sbtmp36);
                                    tmp35.preserve();
                                    objv34[1] = tmp35;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv34, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp35 = objv34[1];
                                    if ( tmp35 != null ) {
                                        tmp35.release();
                                    }
                                    TJC.releaseObjv(interp, objv34, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp33 = interp.getResult();
                            tmp33.preserve();
                            objv32[0] = tmp33;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv37 = TJC.grabObjv(interp, 2);
                                TclObject tmp38;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv37[0] = const7;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp39 = new StringBuffer(64);
                                    sbtmp39.append("int ");
                                    tmp38 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp39.append(tmp38.toString());
                                    sbtmp39.append("_cmdEpoch");
                                    tmp38 = TclString.newInstance(sbtmp39);
                                    tmp38.preserve();
                                    objv37[1] = tmp38;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv37, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp38 = objv37[1];
                                    if ( tmp38 != null ) {
                                        tmp38.release();
                                    }
                                    TJC.releaseObjv(interp, objv37, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp33 = interp.getResult();
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv32, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv32, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp19 != null ) {
                    tmp19.release();
                }
                if ( tmp20 != null ) {
                    tmp20.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer ... [...] ...
            TclObject[] objv40 = TJC.grabObjv(interp, 3);
            TclObject tmp41;
            try {
                // Arg 2 constant: ...
                objv40[0] = const10;
                // Arg 3 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv42 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv42[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv42, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv42, 1);
                    }
                } // End Invoke: emitter_indent
                tmp41 = interp.getResult();
                tmp41.preserve();
                objv40[1] = tmp41;
                // Arg 4 constant: ...
                objv40[2] = const12;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv40, compiledLocals, 2);
            } finally {
                tmp41 = objv40[1];
                if ( tmp41 != null ) {
                    tmp41.release();
                }
                TJC.releaseObjv(interp, objv40, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv43 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv43[0] = const4;
                // Arg 1 constant: +1
                objv43[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv43, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv43, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...]
            TclObject[] objv44 = TJC.grabObjv(interp, 1);
            TclObject tmp45;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "String cmdName"
                    TclObject[] objv46 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv46[0] = const7;
                        // Arg 1 constant: "String cmdName"
                        objv46[1] = const13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv46, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv46, 2);
                    }
                } // End Invoke: emitter_statement
                tmp45 = interp.getResult();
                tmp45.preserve();
                objv44[0] = tmp45;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv44, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv44, 1);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] ...
            TclObject[] objv47 = TJC.grabObjv(interp, 2);
            TclObject tmp48;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv49 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv49[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv49, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv49, 1);
                    }
                } // End Invoke: emitter_indent
                tmp48 = interp.getResult();
                tmp48.preserve();
                objv47[0] = tmp48;
                // Arg 3 constant: ...
                objv47[1] = const14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv47, compiledLocals, 2);
            } finally {
                tmp48 = objv47[0];
                if ( tmp48 != null ) {
                    tmp48.release();
                }
                TJC.releaseObjv(interp, objv47, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv50 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv50[0] = const4;
                // Arg 1 constant: +1
                objv50[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv50, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv50, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set cacheId 0
            setVarScalar(interp, "cacheId", const15, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: append buffer [...] "..."
            TclObject[] objv51 = TJC.grabObjv(interp, 2);
            TclObject tmp52;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv53 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv53[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv53, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv53, 1);
                    }
                } // End Invoke: emitter_indent
                tmp52 = interp.getResult();
                tmp52.preserve();
                objv51[0] = tmp52;
                // Arg 3 word: "..."
                StringBuffer sbtmp54 = new StringBuffer(64);
                sbtmp54.append("case ");
                tmp52 = getVarScalar(interp, "cacheId", compiledLocals, 7);
                sbtmp54.append(tmp52.toString());
                sbtmp54.append(": ");
                sbtmp54.append("{");
                sbtmp54.append("\n");
                tmp52 = TclString.newInstance(sbtmp54);
                tmp52.preserve();
                objv51[1] = tmp52;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv51, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv51, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv55 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv55[0] = const4;
                // Arg 1 constant: +1
                objv55[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv55, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv55, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: foreach cmdname $... key $... cacheId $symbol_ids ...
            TclObject tmp56 = null;
            TclObject tmp57 = null;
            TclObject tmp58 = null;
            try {
                tmp56 = getVarArray(interp, "_compileproc_command_cache", "ordered_cmds", compiledLocals, 1);
                tmp56.preserve();
                tmp57 = getVarArray(interp, "_compileproc_command_cache", "ordered_keys", compiledLocals, 1);
                tmp57.preserve();
                tmp58 = getVarScalar(interp, "symbol_ids", compiledLocals, 3);
                tmp58.preserve();
                final int tmp56_length = TclList.getLength(interp, tmp56);
                final int tmp57_length = TclList.getLength(interp, tmp57);
                final int tmp58_length = TclList.getLength(interp, tmp58);
                int num_loops59, max_loops60 = 0;
                num_loops59 = tmp56_length;
                if ( num_loops59 > max_loops60 ) {
                    max_loops60 = num_loops59;
                }
                num_loops59 = tmp57_length;
                if ( num_loops59 > max_loops60 ) {
                    max_loops60 = num_loops59;
                }
                num_loops59 = tmp58_length;
                if ( num_loops59 > max_loops60 ) {
                    max_loops60 = num_loops59;
                }

                for ( int index61 = 0 ; index61 < max_loops60 ; index61++ ) {
                    TclObject tmp62 = null;
                    if ( index61 < tmp56_length ) {
                        tmp62 = TclList.index(interp, tmp56, index61);
                    }
                    TclObject tmp63 = null;
                    if ( index61 < tmp57_length ) {
                        tmp63 = TclList.index(interp, tmp57, index61);
                    }
                    TclObject tmp64 = null;
                    if ( index61 < tmp58_length ) {
                        tmp64 = TclList.index(interp, tmp58, index61);
                    }
                    try {
                        if ( tmp62 == null ) {
                            setVarScalar(interp, "cmdname", "", compiledLocals, 4);
                        } else {
                            setVarScalar(interp, "cmdname", tmp62, compiledLocals, 4);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmdname");
                    }
                    try {
                        if ( tmp63 == null ) {
                            setVarScalar(interp, "key", "", compiledLocals, 5);
                        } else {
                            setVarScalar(interp, "key", tmp63, compiledLocals, 5);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }
                    try {
                        if ( tmp64 == null ) {
                            setVarScalar(interp, "cacheId", "", compiledLocals, 7);
                        } else {
                            setVarScalar(interp, "cacheId", tmp64, compiledLocals, 7);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cacheId");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set symbol $...
                        TclObject tmp65;
                        tmp65 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp65 = getVarArray(interp, "_compileproc_command_cache", tmp65.toString(), compiledLocals, 1);
                        setVarScalar(interp, "symbol", tmp65, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] [...]
                        TclObject[] objv66 = TJC.grabObjv(interp, 2);
                        TclObject tmp67;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv68 = TJC.grabObjv(interp, 2);
                                TclObject tmp69;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv68[0] = const7;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp70 = new StringBuffer(64);
                                    tmp69 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp70.append(tmp69.toString());
                                    sbtmp70.append(" = TJC.INVALID_COMMAND_CACHE");
                                    tmp69 = TclString.newInstance(sbtmp70);
                                    tmp69.preserve();
                                    objv68[1] = tmp69;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv68, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp69 = objv68[1];
                                    if ( tmp69 != null ) {
                                        tmp69.release();
                                    }
                                    TJC.releaseObjv(interp, objv68, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp67 = interp.getResult();
                            tmp67.preserve();
                            objv66[0] = tmp67;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv71 = TJC.grabObjv(interp, 2);
                                TclObject tmp72;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv71[0] = const7;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp73 = new StringBuffer(64);
                                    tmp72 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp73.append(tmp72.toString());
                                    sbtmp73.append("_cmdEpoch = 0");
                                    tmp72 = TclString.newInstance(sbtmp73);
                                    tmp72.preserve();
                                    objv71[1] = tmp72;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv71, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp72 = objv71[1];
                                    if ( tmp72 != null ) {
                                        tmp72.release();
                                    }
                                    TJC.releaseObjv(interp, objv71, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp67 = interp.getResult();
                            tmp67.preserve();
                            objv66[1] = tmp67;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv66, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv66, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp56 != null ) {
                    tmp56.release();
                }
                if ( tmp57 != null ) {
                    tmp57.release();
                }
                if ( tmp58 != null ) {
                    tmp58.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer [...] [...]
            TclObject[] objv74 = TJC.grabObjv(interp, 2);
            TclObject tmp75;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv76 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv76[0] = const7;
                        // Arg 1 constant: ...
                        objv76[1] = const16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv76, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv76, 2);
                    }
                } // End Invoke: emitter_statement
                tmp75 = interp.getResult();
                tmp75.preserve();
                objv74[0] = tmp75;
                // Arg 3 command: [...]
                { // Invoke: emitter_statement "return"
                    TclObject[] objv77 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv77[0] = const7;
                        // Arg 1 constant: "return"
                        objv77[1] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv77, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv77, 2);
                    }
                } // End Invoke: emitter_statement
                tmp75 = interp.getResult();
                tmp75.preserve();
                objv74[1] = tmp75;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv74, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv74, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv78 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv78[0] = const4;
                // Arg 1 constant: -1
                objv78[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv78, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv78, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv79 = TJC.grabObjv(interp, 2);
            TclObject tmp80;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv81 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv81[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv81, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv81, 1);
                    }
                } // End Invoke: emitter_indent
                tmp80 = interp.getResult();
                tmp80.preserve();
                objv79[0] = tmp80;
                // Arg 3 constant: ...
                objv79[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv79, compiledLocals, 2);
            } finally {
                tmp80 = objv79[0];
                if ( tmp80 != null ) {
                    tmp80.release();
                }
                TJC.releaseObjv(interp, objv79, 2);
            }
        } // End Invoke: append
        { // Invoke: foreach cmdname $... key $... cacheId $symbol_ids ...
            TclObject tmp82 = null;
            TclObject tmp83 = null;
            TclObject tmp84 = null;
            try {
                tmp82 = getVarArray(interp, "_compileproc_command_cache", "ordered_cmds", compiledLocals, 1);
                tmp82.preserve();
                tmp83 = getVarArray(interp, "_compileproc_command_cache", "ordered_keys", compiledLocals, 1);
                tmp83.preserve();
                tmp84 = getVarScalar(interp, "symbol_ids", compiledLocals, 3);
                tmp84.preserve();
                final int tmp82_length = TclList.getLength(interp, tmp82);
                final int tmp83_length = TclList.getLength(interp, tmp83);
                final int tmp84_length = TclList.getLength(interp, tmp84);
                int num_loops85, max_loops86 = 0;
                num_loops85 = tmp82_length;
                if ( num_loops85 > max_loops86 ) {
                    max_loops86 = num_loops85;
                }
                num_loops85 = tmp83_length;
                if ( num_loops85 > max_loops86 ) {
                    max_loops86 = num_loops85;
                }
                num_loops85 = tmp84_length;
                if ( num_loops85 > max_loops86 ) {
                    max_loops86 = num_loops85;
                }

                for ( int index87 = 0 ; index87 < max_loops86 ; index87++ ) {
                    TclObject tmp88 = null;
                    if ( index87 < tmp82_length ) {
                        tmp88 = TclList.index(interp, tmp82, index87);
                    }
                    TclObject tmp89 = null;
                    if ( index87 < tmp83_length ) {
                        tmp89 = TclList.index(interp, tmp83, index87);
                    }
                    TclObject tmp90 = null;
                    if ( index87 < tmp84_length ) {
                        tmp90 = TclList.index(interp, tmp84, index87);
                    }
                    try {
                        if ( tmp88 == null ) {
                            setVarScalar(interp, "cmdname", "", compiledLocals, 4);
                        } else {
                            setVarScalar(interp, "cmdname", tmp88, compiledLocals, 4);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmdname");
                    }
                    try {
                        if ( tmp89 == null ) {
                            setVarScalar(interp, "key", "", compiledLocals, 5);
                        } else {
                            setVarScalar(interp, "key", tmp89, compiledLocals, 5);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }
                    try {
                        if ( tmp90 == null ) {
                            setVarScalar(interp, "cacheId", "", compiledLocals, 7);
                        } else {
                            setVarScalar(interp, "cacheId", tmp90, compiledLocals, 7);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cacheId");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set symbol $...
                        TclObject tmp91;
                        tmp91 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp91 = getVarArray(interp, "_compileproc_command_cache", tmp91.toString(), compiledLocals, 1);
                        setVarScalar(interp, "symbol", tmp91, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "case " $cacheId ...
                        TclObject[] objv92 = TJC.grabObjv(interp, 4);
                        TclObject tmp93;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv94 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv94[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv94, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv94, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp93 = interp.getResult();
                            tmp93.preserve();
                            objv92[0] = tmp93;
                            // Arg 3 constant: "case "
                            objv92[1] = const20;
                            // Arg 4 variable: $cacheId
                            tmp93 = getVarScalar(interp, "cacheId", compiledLocals, 7);
                            tmp93.preserve();
                            objv92[2] = tmp93;
                            // Arg 5 constant: ...
                            objv92[3] = const21;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv92, compiledLocals, 2);
                        } finally {
                            tmp93 = objv92[0];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            tmp93 = objv92[2];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            TJC.releaseObjv(interp, objv92, 4);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level +1
                        TclObject[] objv95 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv95[0] = const4;
                            // Arg 1 constant: +1
                            objv95[1] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv95, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv95, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: set jsym [...]
                        TclObject tmp96;
                        { // Invoke: ... $cmdname
                            TclObject[] objv97 = TJC.grabObjv(interp, 2);
                            TclObject tmp98;
                            try {
                                // Arg 0 constant: ...
                                objv97[0] = const22;
                                // Arg 1 variable: $cmdname
                                tmp98 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                                tmp98.preserve();
                                objv97[1] = tmp98;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv97, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp98 = objv97[1];
                                if ( tmp98 != null ) {
                                    tmp98.release();
                                }
                                TJC.releaseObjv(interp, objv97, 2);
                            }
                        } // End Invoke: ...
                        tmp96 = interp.getResult();
                        setVarScalar(interp, "jsym", tmp96, compiledLocals, 8);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] [...]
                        TclObject[] objv99 = TJC.grabObjv(interp, 2);
                        TclObject tmp100;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_statement "cmdName = $jsym"
                                TclObject[] objv101 = TJC.grabObjv(interp, 2);
                                TclObject tmp102;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv101[0] = const7;
                                    // Arg 1 word: "cmdName = $jsym"
                                    StringBuffer sbtmp103 = new StringBuffer(64);
                                    sbtmp103.append("cmdName = ");
                                    tmp102 = getVarScalar(interp, "jsym", compiledLocals, 8);
                                    sbtmp103.append(tmp102.toString());
                                    tmp102 = TclString.newInstance(sbtmp103);
                                    tmp102.preserve();
                                    objv101[1] = tmp102;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv101, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp102 = objv101[1];
                                    if ( tmp102 != null ) {
                                        tmp102.release();
                                    }
                                    TJC.releaseObjv(interp, objv101, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp100 = interp.getResult();
                            tmp100.preserve();
                            objv99[0] = tmp100;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_statement "break"
                                TclObject[] objv104 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv104[0] = const7;
                                    // Arg 1 constant: "break"
                                    objv104[1] = const23;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv104, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv104, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp100 = interp.getResult();
                            tmp100.preserve();
                            objv99[1] = tmp100;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv99, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv99, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level -1
                        TclObject[] objv105 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv105[0] = const4;
                            // Arg 1 constant: -1
                            objv105[1] = const18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv105, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv105, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] ...
                        TclObject[] objv106 = TJC.grabObjv(interp, 2);
                        TclObject tmp107;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv108 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv108[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv108, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv108, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp107 = interp.getResult();
                            tmp107.preserve();
                            objv106[0] = tmp107;
                            // Arg 3 constant: ...
                            objv106[1] = const19;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv106, compiledLocals, 2);
                        } finally {
                            tmp107 = objv106[0];
                            if ( tmp107 != null ) {
                                tmp107.release();
                            }
                            TJC.releaseObjv(interp, objv106, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp82 != null ) {
                    tmp82.release();
                }
                if ( tmp83 != null ) {
                    tmp83.release();
                }
                if ( tmp84 != null ) {
                    tmp84.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer [...] ...
            TclObject[] objv109 = TJC.grabObjv(interp, 2);
            TclObject tmp110;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv111 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv111[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv111, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv111, 1);
                    }
                } // End Invoke: emitter_indent
                tmp110 = interp.getResult();
                tmp110.preserve();
                objv109[0] = tmp110;
                // Arg 3 constant: ...
                objv109[1] = const24;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv109, compiledLocals, 2);
            } finally {
                tmp110 = objv109[0];
                if ( tmp110 != null ) {
                    tmp110.release();
                }
                TJC.releaseObjv(interp, objv109, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv112 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv112[0] = const4;
                // Arg 1 constant: +1
                objv112[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv112, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv112, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...]
            TclObject[] objv113 = TJC.grabObjv(interp, 1);
            TclObject tmp114;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv115 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv115[0] = const7;
                        // Arg 1 constant: ...
                        objv115[1] = const25;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv115, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv115, 2);
                    }
                } // End Invoke: emitter_statement
                tmp114 = interp.getResult();
                tmp114.preserve();
                objv113[0] = tmp114;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv113, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv113, 1);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv116 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv116[0] = const4;
                // Arg 1 constant: -1
                objv116[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv116, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv116, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv117 = TJC.grabObjv(interp, 2);
            TclObject tmp118;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv119 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv119[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv119, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv119, 1);
                    }
                } // End Invoke: emitter_indent
                tmp118 = interp.getResult();
                tmp118.preserve();
                objv117[0] = tmp118;
                // Arg 3 constant: ...
                objv117[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv117, compiledLocals, 2);
            } finally {
                tmp118 = objv117[0];
                if ( tmp118 != null ) {
                    tmp118.release();
                }
                TJC.releaseObjv(interp, objv117, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv120 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv120[0] = const4;
                // Arg 1 constant: -1
                objv120[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv120, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv120, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv121 = TJC.grabObjv(interp, 2);
            TclObject tmp122;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv123 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv123[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv123, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv123, 1);
                    }
                } // End Invoke: emitter_indent
                tmp122 = interp.getResult();
                tmp122.preserve();
                objv121[0] = tmp122;
                // Arg 3 constant: ...
                objv121[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv121, compiledLocals, 2);
            } finally {
                tmp122 = objv121[0];
                if ( tmp122 != null ) {
                    tmp122.release();
                }
                TJC.releaseObjv(interp, objv121, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] [...] [...] [...] [...] [...] [...] [...]
            TclObject[] objv124 = TJC.grabObjv(interp, 8);
            TclObject tmp125;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv126 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv126[0] = const7;
                        // Arg 1 constant: ...
                        objv126[1] = const26;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv126, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv126, 2);
                    }
                } // End Invoke: emitter_statement
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[0] = tmp125;
                // Arg 3 command: [...]
                { // Invoke: emitter_statement "int cmdEpoch"
                    TclObject[] objv127 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv127[0] = const7;
                        // Arg 1 constant: "int cmdEpoch"
                        objv127[1] = const27;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv127, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv127, 2);
                    }
                } // End Invoke: emitter_statement
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[1] = tmp125;
                // Arg 4 command: [...]
                { // Invoke: ... "lwcmd == null"
                    TclObject[] objv128 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: ...
                        objv128[0] = const28;
                        // Arg 1 constant: "lwcmd == null"
                        objv128[1] = const29;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv128, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv128, 2);
                    }
                } // End Invoke: ...
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[2] = tmp125;
                // Arg 5 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv129 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv129[0] = const7;
                        // Arg 1 constant: ...
                        objv129[1] = const30;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv129, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv129, 2);
                    }
                } // End Invoke: emitter_statement
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[3] = tmp125;
                // Arg 6 command: [...]
                { // Invoke: emitter_statement "cmdEpoch = 0"
                    TclObject[] objv130 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv130[0] = const7;
                        // Arg 1 constant: "cmdEpoch = 0"
                        objv130[1] = const31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv130, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv130, 2);
                    }
                } // End Invoke: emitter_statement
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[4] = tmp125;
                // Arg 7 command: [...]
                { // Invoke: ...
                    TclObject[] objv131 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv131[0] = const32;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                            ? cmdcache9.cmd : null), objv131, 0);
                        if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                            updateCmdCache(interp, 9);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv131, 1);
                    }
                } // End Invoke: ...
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[5] = tmp125;
                // Arg 8 command: [...]
                { // Invoke: emitter_statement ...
                    TclObject[] objv132 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_statement
                        objv132[0] = const7;
                        // Arg 1 constant: ...
                        objv132[1] = const33;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv132, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv132, 2);
                    }
                } // End Invoke: emitter_statement
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[6] = tmp125;
                // Arg 9 command: [...]
                { // Invoke: ...
                    TclObject[] objv133 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv133[0] = const34;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                            ? cmdcache10.cmd : null), objv133, 0);
                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                            updateCmdCache(interp, 10);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv133, 1);
                    }
                } // End Invoke: ...
                tmp125 = interp.getResult();
                tmp125.preserve();
                objv124[7] = tmp125;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv124, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv124, 8);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] ...
            TclObject[] objv134 = TJC.grabObjv(interp, 2);
            TclObject tmp135;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv136 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv136[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv136, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv136, 1);
                    }
                } // End Invoke: emitter_indent
                tmp135 = interp.getResult();
                tmp135.preserve();
                objv134[0] = tmp135;
                // Arg 3 constant: ...
                objv134[1] = const14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv134, compiledLocals, 2);
            } finally {
                tmp135 = objv134[0];
                if ( tmp135 != null ) {
                    tmp135.release();
                }
                TJC.releaseObjv(interp, objv134, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv137 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv137[0] = const4;
                // Arg 1 constant: +1
                objv137[1] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv137, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv137, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: foreach cmdname $... key $... cacheId $symbol_ids ...
            TclObject tmp138 = null;
            TclObject tmp139 = null;
            TclObject tmp140 = null;
            try {
                tmp138 = getVarArray(interp, "_compileproc_command_cache", "ordered_cmds", compiledLocals, 1);
                tmp138.preserve();
                tmp139 = getVarArray(interp, "_compileproc_command_cache", "ordered_keys", compiledLocals, 1);
                tmp139.preserve();
                tmp140 = getVarScalar(interp, "symbol_ids", compiledLocals, 3);
                tmp140.preserve();
                final int tmp138_length = TclList.getLength(interp, tmp138);
                final int tmp139_length = TclList.getLength(interp, tmp139);
                final int tmp140_length = TclList.getLength(interp, tmp140);
                int num_loops141, max_loops142 = 0;
                num_loops141 = tmp138_length;
                if ( num_loops141 > max_loops142 ) {
                    max_loops142 = num_loops141;
                }
                num_loops141 = tmp139_length;
                if ( num_loops141 > max_loops142 ) {
                    max_loops142 = num_loops141;
                }
                num_loops141 = tmp140_length;
                if ( num_loops141 > max_loops142 ) {
                    max_loops142 = num_loops141;
                }

                for ( int index143 = 0 ; index143 < max_loops142 ; index143++ ) {
                    TclObject tmp144 = null;
                    if ( index143 < tmp138_length ) {
                        tmp144 = TclList.index(interp, tmp138, index143);
                    }
                    TclObject tmp145 = null;
                    if ( index143 < tmp139_length ) {
                        tmp145 = TclList.index(interp, tmp139, index143);
                    }
                    TclObject tmp146 = null;
                    if ( index143 < tmp140_length ) {
                        tmp146 = TclList.index(interp, tmp140, index143);
                    }
                    try {
                        if ( tmp144 == null ) {
                            setVarScalar(interp, "cmdname", "", compiledLocals, 4);
                        } else {
                            setVarScalar(interp, "cmdname", tmp144, compiledLocals, 4);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cmdname");
                    }
                    try {
                        if ( tmp145 == null ) {
                            setVarScalar(interp, "key", "", compiledLocals, 5);
                        } else {
                            setVarScalar(interp, "key", tmp145, compiledLocals, 5);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "key");
                    }
                    try {
                        if ( tmp146 == null ) {
                            setVarScalar(interp, "cacheId", "", compiledLocals, 7);
                        } else {
                            setVarScalar(interp, "cacheId", tmp146, compiledLocals, 7);
                        }
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "cacheId");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set symbol $...
                        TclObject tmp147;
                        tmp147 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp147 = getVarArray(interp, "_compileproc_command_cache", tmp147.toString(), compiledLocals, 1);
                        setVarScalar(interp, "symbol", tmp147, compiledLocals, 6);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "..."
                        TclObject[] objv148 = TJC.grabObjv(interp, 2);
                        TclObject tmp149;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv150 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv150[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv150, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv150, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp149 = interp.getResult();
                            tmp149.preserve();
                            objv148[0] = tmp149;
                            // Arg 3 word: "..."
                            StringBuffer sbtmp151 = new StringBuffer(64);
                            sbtmp151.append("case ");
                            tmp149 = getVarScalar(interp, "cacheId", compiledLocals, 7);
                            sbtmp151.append(tmp149.toString());
                            sbtmp151.append(": ");
                            sbtmp151.append("{");
                            sbtmp151.append("\n");
                            tmp149 = TclString.newInstance(sbtmp151);
                            tmp149.preserve();
                            objv148[1] = tmp149;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv148, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv148, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level +1
                        TclObject[] objv152 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv152[0] = const4;
                            // Arg 1 constant: +1
                            objv152[1] = const6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv152, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv152, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] [...] [...]
                        TclObject[] objv153 = TJC.grabObjv(interp, 3);
                        TclObject tmp154;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_statement "$symbol = lwcmd"
                                TclObject[] objv155 = TJC.grabObjv(interp, 2);
                                TclObject tmp156;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv155[0] = const7;
                                    // Arg 1 word: "$symbol = lwcmd"
                                    StringBuffer sbtmp157 = new StringBuffer(64);
                                    tmp156 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp157.append(tmp156.toString());
                                    sbtmp157.append(" = lwcmd");
                                    tmp156 = TclString.newInstance(sbtmp157);
                                    tmp156.preserve();
                                    objv155[1] = tmp156;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv155, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp156 = objv155[1];
                                    if ( tmp156 != null ) {
                                        tmp156.release();
                                    }
                                    TJC.releaseObjv(interp, objv155, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp154 = interp.getResult();
                            tmp154.preserve();
                            objv153[0] = tmp154;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv158 = TJC.grabObjv(interp, 2);
                                TclObject tmp159;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv158[0] = const7;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp160 = new StringBuffer(64);
                                    tmp159 = getVarScalar(interp, "symbol", compiledLocals, 6);
                                    sbtmp160.append(tmp159.toString());
                                    sbtmp160.append("_cmdEpoch = cmdEpoch");
                                    tmp159 = TclString.newInstance(sbtmp160);
                                    tmp159.preserve();
                                    objv158[1] = tmp159;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv158, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp159 = objv158[1];
                                    if ( tmp159 != null ) {
                                        tmp159.release();
                                    }
                                    TJC.releaseObjv(interp, objv158, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp154 = interp.getResult();
                            tmp154.preserve();
                            objv153[1] = tmp154;
                            // Arg 4 command: [...]
                            { // Invoke: emitter_statement "break"
                                TclObject[] objv161 = TJC.grabObjv(interp, 2);
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv161[0] = const7;
                                    // Arg 1 constant: "break"
                                    objv161[1] = const23;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv161, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv161, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp154 = interp.getResult();
                            tmp154.preserve();
                            objv153[2] = tmp154;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv153, compiledLocals, 2);
                        } finally {
                            TJC.releaseObjvElems(interp, objv153, 3);
                        }
                    } // End Invoke: append
                    { // Invoke: emitter_indent_level -1
                        TclObject[] objv162 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: emitter_indent_level
                            objv162[0] = const4;
                            // Arg 1 constant: -1
                            objv162[1] = const18;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv162, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv162, 2);
                        }
                    } // End Invoke: emitter_indent_level
                    { // Invoke: append buffer [...] ...
                        TclObject[] objv163 = TJC.grabObjv(interp, 2);
                        TclObject tmp164;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv165 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv165[0] = const11;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv165, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv165, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp164 = interp.getResult();
                            tmp164.preserve();
                            objv163[0] = tmp164;
                            // Arg 3 constant: ...
                            objv163[1] = const19;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv163, compiledLocals, 2);
                        } finally {
                            tmp164 = objv163[0];
                            if ( tmp164 != null ) {
                                tmp164.release();
                            }
                            TJC.releaseObjv(interp, objv163, 2);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp138 != null ) {
                    tmp138.release();
                }
                if ( tmp139 != null ) {
                    tmp139.release();
                }
                if ( tmp140 != null ) {
                    tmp140.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: emitter_indent_level -1
            TclObject[] objv166 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv166[0] = const4;
                // Arg 1 constant: -1
                objv166[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv166, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv166, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv167 = TJC.grabObjv(interp, 2);
            TclObject tmp168;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv169 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv169[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv169, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv169, 1);
                    }
                } // End Invoke: emitter_indent
                tmp168 = interp.getResult();
                tmp168.preserve();
                objv167[0] = tmp168;
                // Arg 3 constant: ...
                objv167[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv167, compiledLocals, 2);
            } finally {
                tmp168 = objv167[0];
                if ( tmp168 != null ) {
                    tmp168.release();
                }
                TJC.releaseObjv(interp, objv167, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv170 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv170[0] = const4;
                // Arg 1 constant: -1
                objv170[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv170, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv170, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv171 = TJC.grabObjv(interp, 2);
            TclObject tmp172;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv173 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv173[0] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv173, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv173, 1);
                    }
                } // End Invoke: emitter_indent
                tmp172 = interp.getResult();
                tmp172.preserve();
                objv171[0] = tmp172;
                // Arg 3 constant: ...
                objv171[1] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv171, compiledLocals, 2);
            } finally {
                tmp172 = objv171[0];
                if ( tmp172 != null ) {
                    tmp172.release();
                }
                TJC.releaseObjv(interp, objv171, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv174 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv174[0] = const4;
                // Arg 1 constant: -1
                objv174[1] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv174, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv174, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: emitter_indent_level
                TclObject[] objv175 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv175[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv175, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv175, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp176 = interp.getResult();
            ExprValue tmp177 = evs0;
            TJC.exprInitValue(interp, tmp177, tmp176);
            ExprValue tmp178 = evs1;
            tmp178.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp177, tmp178);
            // End Binary operator: !=
            boolean tmp179 = ( tmp177.getIntValue() != 0 );
            if ( tmp179 ) {
                { // Invoke: error "..."
                    TclObject[] objv180 = TJC.grabObjv(interp, 2);
                    TclObject tmp181;
                    try {
                        // Arg 0 constant: error
                        objv180[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp182 = new StringBuffer(64);
                        sbtmp182.append("expected exit indent level of 0, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv183 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv183[0] = const4;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv183, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv183, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp181 = interp.getResult();
                        sbtmp182.append(tmp181.toString());
                        tmp181 = TclString.newInstance(sbtmp182);
                        tmp181.preserve();
                        objv180[1] = tmp181;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv180, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp181 = objv180[1];
                        if ( tmp181 != null ) {
                            tmp181.release();
                        }
                        TJC.releaseObjv(interp, objv180, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp184 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp184);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_cache_init_generate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc_command_cache(ordered_cmds)");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("+1");
        TclInteger.get(interp, const6);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_statement");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("int wcmd_cmdEpoch = 0");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_get_cache_id_from_symbol");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_indent");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("void updateCmdCache(Interp interp, int cacheId) throws TclException {\n");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("String cmdName");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("switch ( cacheId ) {\n");
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(0);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("wcmd_cmdEpoch = wcmd.cmdEpoch");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("return");
        const17.preserve(); const17.preserve();
        const18 = TclInteger.newInstance(-1);
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("}\n");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("case ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(": {\n");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("emitter_double_quote_tcl_string");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("break");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("default: {\n");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("throw new TclRuntimeError(\"default: cacheId \" + cacheId)");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName)");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("int cmdEpoch");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("emitter_container_if_start");
        const28.preserve(); const28.preserve();
        const29 = TclString.newInstance("lwcmd == null");
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("lwcmd = TJC.INVALID_COMMAND_CACHE");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("cmdEpoch = 0");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("emitter_container_if_else");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("cmdEpoch = lwcmd.cmdEpoch");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("emitter_container_if_end");
        const34.preserve(); const34.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "emitter_statement";
                break;
            }
            case 5: {
                cmdName = "compileproc_get_cache_id_from_symbol";
                break;
            }
            case 6: {
                cmdName = "emitter_indent";
                break;
            }
            case 7: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 8: {
                cmdName = "emitter_container_if_start";
                break;
            }
            case 9: {
                cmdName = "emitter_container_if_else";
                break;
            }
            case 10: {
                cmdName = "emitter_container_if_end";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc",
        "_compileproc_command_cache",
        "buffer",
        "symbol_ids",
        "cmdname",
        "key",
        "symbol",
        "cacheId",
        "jsym"
    };
} // end class CompileprocCommandCacheInitGenerateCmd

