// TJC implementation of procedure compileproc_emit_argument
package tjc;
import tcl.lang.*;

public class CompileprocEmitArgumentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 19, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 3 || objv.length > 5) {
            throw new TclNumArgsException(interp, 1, objv, "key i ?declare_flag? ?symbol_name?");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "i", objv[2], compiledLocals, 1);
        setVarScalar(interp, "declare_flag", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        setVarScalar(interp, "symbol_name", 
            ((objv.length <= 4) ? const1 : objv[4]), compiledLocals, 3);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 4);
        } // End Invoke: global
        { // Invoke: if {$declare_flag} ... else ...
            TclObject tmp0 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set declare "TclObject "
                    setVarScalar(interp, "declare", const2, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set declare ""
                    setVarScalar(interp, "declare", const1, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set types $...
            TclObject tmp2;
            StringBuffer sbtmp3 = new StringBuffer(64);
            tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp3.append(tmp2.toString());
            sbtmp3.append(",types");
            tmp2 = getVarArray(interp, "_compileproc_key_info", sbtmp3.toString(), compiledLocals, 4);
            setVarScalar(interp, "types", tmp2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set values $...
            TclObject tmp4;
            StringBuffer sbtmp5 = new StringBuffer(64);
            tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp5.append(tmp4.toString());
            sbtmp5.append(",values");
            tmp4 = getVarArray(interp, "_compileproc_key_info", sbtmp5.toString(), compiledLocals, 4);
            setVarScalar(interp, "values", tmp4, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set num_args $...
            TclObject tmp6;
            StringBuffer sbtmp7 = new StringBuffer(64);
            tmp6 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp7.append(tmp6.toString());
            sbtmp7.append(",num_args");
            tmp6 = getVarArray(interp, "_compileproc_key_info", sbtmp7.toString(), compiledLocals, 4);
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set symbol ""
            setVarScalar(interp, "symbol", const1, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: () || ()
            // Binary operator: $i < 0
            TclObject tmp8 = getVarScalar(interp, "i", compiledLocals, 1);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp9, tmp10);
            // End Binary operator: <
            if (!tmp9.getBooleanValue(interp)) {
            // Binary operator: $i >= $num_args
            TclObject tmp11 = getVarScalar(interp, "i", compiledLocals, 1);
            ExprValue tmp12 = evs1;
            TJC.exprInitValue(interp, tmp12, tmp11);
            TclObject tmp13 = getVarScalar(interp, "num_args", compiledLocals, 8);
            ExprValue tmp14 = evs2;
            TJC.exprInitValue(interp, tmp14, tmp13);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp12, tmp14);
            // End Binary operator: >=
            tmp9.setIntValue(tmp12.getBooleanValue(interp));
            } else {
            tmp9.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp15 = ( tmp9.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: error "..."
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    TclObject tmp17;
                    try {
                        // Arg 0 constant: error
                        objv16[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp18 = new StringBuffer(64);
                        sbtmp18.append("command argument index ");
                        tmp17 = getVarScalar(interp, "i", compiledLocals, 1);
                        sbtmp18.append(tmp17.toString());
                        sbtmp18.append(" is out of range : num_args is ");
                        tmp17 = getVarScalar(interp, "num_args", compiledLocals, 8);
                        sbtmp18.append(tmp17.toString());
                        tmp17 = TclString.newInstance(sbtmp18);
                        tmp17.preserve();
                        objv16[1] = tmp17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv16, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp17 = objv16[1];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: error
            } else {
                { // Invoke: set type [...]
                    TclObject tmp19;
                    { // Invoke: lindex $types $i
                        TclObject tmp20 = null;
                        TclObject tmp21;
                        try {
                            tmp20 = getVarScalar(interp, "types", compiledLocals, 6);
                            tmp20.preserve();
                            tmp21 = getVarScalar(interp, "i", compiledLocals, 1);
                            TJC.lindexNonconst(interp, tmp20, tmp21);
                        } finally {
                            if ( tmp20 != null ) {
                                tmp20.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp19 = interp.getResult();
                    setVarScalar(interp, "type", tmp19, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: switch -exact -- $type {constant} ... {variable} ... {command} ... {word} ... default ...
                    TclObject tmp22 = getVarScalar(interp, "type", compiledLocals, 11);
                    String tmp23 = tmp22.toString();
                    int tmp23_length = tmp23.length();
                    char tmp23_first = '\n';
                    if ( tmp23_length > 0 ) {
                        tmp23_first = tmp23.charAt(0);
                    }
                    if ( tmp23_length == 8 && tmp23_first == 'c'
                            && tmp23.compareTo("constant") == 0 ) {
                        // Pattern {constant}
                        { // Invoke: set str [...]
                            TclObject tmp24;
                            { // Invoke: lindex $values $i
                                TclObject tmp25 = null;
                                TclObject tmp26;
                                try {
                                    tmp25 = getVarScalar(interp, "values", compiledLocals, 7);
                                    tmp25.preserve();
                                    tmp26 = getVarScalar(interp, "i", compiledLocals, 1);
                                    TJC.lindexNonconst(interp, tmp25, tmp26);
                                } finally {
                                    if ( tmp25 != null ) {
                                        tmp25.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp24 = interp.getResult();
                            setVarScalar(interp, "str", tmp24, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set ident [...]
                            TclObject tmp27;
                            { // Invoke: ... $str
                                TclObject[] objv28 = TJC.grabObjv(interp, 2);
                                TclObject tmp29;
                                try {
                                    // Arg 0 constant: ...
                                    objv28[0] = const4;
                                    // Arg 1 variable: $str
                                    tmp29 = getVarScalar(interp, "str", compiledLocals, 12);
                                    tmp29.preserve();
                                    objv28[1] = tmp29;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv28, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp29 = objv28[1];
                                    if ( tmp29 != null ) {
                                        tmp29.release();
                                    }
                                    TJC.releaseObjv(interp, objv28, 2);
                                }
                            } // End Invoke: ...
                            tmp27 = interp.getResult();
                            setVarScalar(interp, "ident", tmp27, compiledLocals, 13);
                        } // End Invoke: set
                        { // Invoke: set symbol $ident
                            TclObject tmp30;
                            tmp30 = getVarScalar(interp, "ident", compiledLocals, 13);
                            setVarScalar(interp, "symbol", tmp30, compiledLocals, 10);
                        } // End Invoke: set
                    } else if ( tmp23_length == 8 && tmp23_first == 'v'
                            && tmp23.compareTo("variable") == 0 ) {
                        // Pattern {variable}
                        { // Invoke: set vinfo [...]
                            TclObject tmp31;
                            { // Invoke: lindex $values $i
                                TclObject tmp32 = null;
                                TclObject tmp33;
                                try {
                                    tmp32 = getVarScalar(interp, "values", compiledLocals, 7);
                                    tmp32.preserve();
                                    tmp33 = getVarScalar(interp, "i", compiledLocals, 1);
                                    TJC.lindexNonconst(interp, tmp32, tmp33);
                                } finally {
                                    if ( tmp32 != null ) {
                                        tmp32.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp31 = interp.getResult();
                            setVarScalar(interp, "vinfo", tmp31, compiledLocals, 14);
                        } // End Invoke: set
                        { // Invoke: if {$symbol_name == {}} ... else ...
                            // Binary operator: $symbol_name == ""
                            TclObject tmp34 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                            ExprValue tmp35 = evs0;
                            TJC.exprEqualsEmptyString(tmp35, tmp34, false);
                            // End Binary operator: ==
                            boolean tmp36 = ( tmp35.getIntValue() != 0 );
                            if ( tmp36 ) {
                                { // Invoke: set tmpsymbol [...]
                                    TclObject tmp37;
                                    { // Invoke: ...
                                        TclObject[] objv38 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv38[0] = const5;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv38, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv38, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp37 = interp.getResult();
                                    setVarScalar(interp, "tmpsymbol", tmp37, compiledLocals, 15);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set tmpsymbol $symbol_name
                                    TclObject tmp39;
                                    tmp39 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                                    setVarScalar(interp, "tmpsymbol", tmp39, compiledLocals, 15);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set symbol $tmpsymbol
                            TclObject tmp40;
                            tmp40 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                            setVarScalar(interp, "symbol", tmp40, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv41 = TJC.grabObjv(interp, 1);
                            TclObject tmp42;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol $vinfo $declare_flag
                                    TclObject[] objv43 = TJC.grabObjv(interp, 4);
                                    TclObject tmp44;
                                    try {
                                        // Arg 0 constant: ...
                                        objv43[0] = const6;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp44 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                        tmp44.preserve();
                                        objv43[1] = tmp44;
                                        // Arg 2 variable: $vinfo
                                        tmp44 = getVarScalar(interp, "vinfo", compiledLocals, 14);
                                        tmp44.preserve();
                                        objv43[2] = tmp44;
                                        // Arg 3 variable: $declare_flag
                                        tmp44 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                                        tmp44.preserve();
                                        objv43[3] = tmp44;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv43, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp44 = objv43[1];
                                        if ( tmp44 != null ) {
                                            tmp44.release();
                                        }
                                        tmp44 = objv43[2];
                                        if ( tmp44 != null ) {
                                            tmp44.release();
                                        }
                                        tmp44 = objv43[3];
                                        if ( tmp44 != null ) {
                                            tmp44.release();
                                        }
                                        TJC.releaseObjv(interp, objv43, 4);
                                    }
                                } // End Invoke: ...
                                tmp42 = interp.getResult();
                                tmp42.preserve();
                                objv41[0] = tmp42;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv41, compiledLocals, 9);
                            } finally {
                                TJC.releaseObjvElems(interp, objv41, 1);
                            }
                        } // End Invoke: append
                    } else if ( tmp23_length == 7 && tmp23_first == 'c'
                            && tmp23.compareTo("command") == 0 ) {
                        // Pattern {command}
                        { // Invoke: set ckeys [...]
                            TclObject tmp45;
                            { // Invoke: lindex $values $i
                                TclObject tmp46 = null;
                                TclObject tmp47;
                                try {
                                    tmp46 = getVarScalar(interp, "values", compiledLocals, 7);
                                    tmp46.preserve();
                                    tmp47 = getVarScalar(interp, "i", compiledLocals, 1);
                                    TJC.lindexNonconst(interp, tmp46, tmp47);
                                } finally {
                                    if ( tmp46 != null ) {
                                        tmp46.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp45 = interp.getResult();
                            setVarScalar(interp, "ckeys", tmp45, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: if ... ...
                            { // Invoke: ... $ckeys
                                TclObject[] objv48 = TJC.grabObjv(interp, 2);
                                TclObject tmp49;
                                try {
                                    // Arg 0 constant: ...
                                    objv48[0] = const7;
                                    // Arg 1 variable: $ckeys
                                    tmp49 = getVarScalar(interp, "ckeys", compiledLocals, 16);
                                    tmp49.preserve();
                                    objv48[1] = tmp49;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv48, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp49 = objv48[1];
                                    if ( tmp49 != null ) {
                                        tmp49.release();
                                    }
                                    TJC.releaseObjv(interp, objv48, 2);
                                }
                            } // End Invoke: ...
                            TclObject tmp50 = interp.getResult();
                            ExprValue tmp51 = evs0;
                            TJC.exprInitValue(interp, tmp51, tmp50);
                            boolean tmp52 = tmp51.getBooleanValue(interp);
                            if ( tmp52 ) {
                                { // Invoke: error "..."
                                    TclObject[] objv53 = TJC.grabObjv(interp, 2);
                                    TclObject tmp54;
                                    try {
                                        // Arg 0 constant: error
                                        objv53[0] = const3;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp55 = new StringBuffer(64);
                                        sbtmp55.append("unexpected empty nested command for key ");
                                        tmp54 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp55.append(tmp54.toString());
                                        tmp54 = TclString.newInstance(sbtmp55);
                                        tmp54.preserve();
                                        objv53[1] = tmp54;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv53, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp54 = objv53[1];
                                        if ( tmp54 != null ) {
                                            tmp54.release();
                                        }
                                        TJC.releaseObjv(interp, objv53, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                        { // Invoke: if {$symbol_name == {}} ... else ...
                            // Binary operator: $symbol_name == ""
                            TclObject tmp56 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                            ExprValue tmp57 = evs0;
                            TJC.exprEqualsEmptyString(tmp57, tmp56, false);
                            // End Binary operator: ==
                            boolean tmp58 = ( tmp57.getIntValue() != 0 );
                            if ( tmp58 ) {
                                { // Invoke: set tmpsymbol [...]
                                    TclObject tmp59;
                                    { // Invoke: ...
                                        TclObject[] objv60 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv60[0] = const5;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv60, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv60, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp59 = interp.getResult();
                                    setVarScalar(interp, "tmpsymbol", tmp59, compiledLocals, 15);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set tmpsymbol $symbol_name
                                    TclObject tmp61;
                                    tmp61 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                                    setVarScalar(interp, "tmpsymbol", tmp61, compiledLocals, 15);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set symbol $tmpsymbol
                            TclObject tmp62;
                            tmp62 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                            setVarScalar(interp, "symbol", tmp62, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: foreach ckey $ckeys ...
                            TclObject tmp63 = null;
                            try {
                                tmp63 = getVarScalar(interp, "ckeys", compiledLocals, 16);
                                tmp63.preserve();
                                final int tmp63_length = TclList.getLength(interp, tmp63);

                                for ( int index64 = 0 ; index64 < tmp63_length ; index64++ ) {
                                    TclObject tmp65 = TclList.index(interp, tmp63, index64);
                                    try {
                                        setVarScalar(interp, "ckey", tmp65, compiledLocals, 17);
                                    } catch (TclException ex) {
                                        TJC.foreachVarErr(interp, "ckey");
                                    }

                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: append buffer [...]
                                        TclObject[] objv66 = TJC.grabObjv(interp, 1);
                                        TclObject tmp67;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: ... $ckey
                                                TclObject[] objv68 = TJC.grabObjv(interp, 2);
                                                TclObject tmp69;
                                                try {
                                                    // Arg 0 constant: ...
                                                    objv68[0] = const8;
                                                    // Arg 1 variable: $ckey
                                                    tmp69 = getVarScalar(interp, "ckey", compiledLocals, 17);
                                                    tmp69.preserve();
                                                    objv68[1] = tmp69;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                        ? cmdcache6.cmd : null), objv68, 0);
                                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                        updateCmdCache(interp, 6);
                                                    }
                                                } finally {
                                                    tmp69 = objv68[1];
                                                    if ( tmp69 != null ) {
                                                        tmp69.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv68, 2);
                                                }
                                            } // End Invoke: ...
                                            tmp67 = interp.getResult();
                                            tmp67.preserve();
                                            objv66[0] = tmp67;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv66, compiledLocals, 9);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv66, 1);
                                        }
                                    } // End Invoke: append
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else if (type == TCL.CONTINUE) {
                                            continue;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }
                            } finally {
                                if ( tmp63 != null ) {
                                    tmp63.release();
                                }
                            }
                        } // End Invoke: foreach
                        { // Invoke: append buffer [...] $declare $tmpsymbol ...
                            TclObject[] objv70 = TJC.grabObjv(interp, 4);
                            TclObject tmp71;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv72 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv72[0] = const9;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv72, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv72, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp71 = interp.getResult();
                                tmp71.preserve();
                                objv70[0] = tmp71;
                                // Arg 3 variable: $declare
                                tmp71 = getVarScalar(interp, "declare", compiledLocals, 5);
                                tmp71.preserve();
                                objv70[1] = tmp71;
                                // Arg 4 variable: $tmpsymbol
                                tmp71 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                tmp71.preserve();
                                objv70[2] = tmp71;
                                // Arg 5 constant: ...
                                objv70[3] = const10;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv70, compiledLocals, 9);
                            } finally {
                                tmp71 = objv70[0];
                                if ( tmp71 != null ) {
                                    tmp71.release();
                                }
                                tmp71 = objv70[1];
                                if ( tmp71 != null ) {
                                    tmp71.release();
                                }
                                tmp71 = objv70[2];
                                if ( tmp71 != null ) {
                                    tmp71.release();
                                }
                                TJC.releaseObjv(interp, objv70, 4);
                            }
                        } // End Invoke: append
                    } else if ( tmp23_length == 4 && tmp23_first == 'w'
                            && tmp23.compareTo("word") == 0 ) {
                        // Pattern {word}
                        { // Invoke: set winfo [...]
                            TclObject tmp73;
                            { // Invoke: lindex $values $i
                                TclObject tmp74 = null;
                                TclObject tmp75;
                                try {
                                    tmp74 = getVarScalar(interp, "values", compiledLocals, 7);
                                    tmp74.preserve();
                                    tmp75 = getVarScalar(interp, "i", compiledLocals, 1);
                                    TJC.lindexNonconst(interp, tmp74, tmp75);
                                } finally {
                                    if ( tmp74 != null ) {
                                        tmp74.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp73 = interp.getResult();
                            setVarScalar(interp, "winfo", tmp73, compiledLocals, 18);
                        } // End Invoke: set
                        { // Invoke: if {$symbol_name == {}} ... else ...
                            // Binary operator: $symbol_name == ""
                            TclObject tmp76 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                            ExprValue tmp77 = evs0;
                            TJC.exprEqualsEmptyString(tmp77, tmp76, false);
                            // End Binary operator: ==
                            boolean tmp78 = ( tmp77.getIntValue() != 0 );
                            if ( tmp78 ) {
                                { // Invoke: set tmpsymbol [...]
                                    TclObject tmp79;
                                    { // Invoke: ...
                                        TclObject[] objv80 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: ...
                                            objv80[0] = const5;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv80, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv80, 1);
                                        }
                                    } // End Invoke: ...
                                    tmp79 = interp.getResult();
                                    setVarScalar(interp, "tmpsymbol", tmp79, compiledLocals, 15);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set tmpsymbol $symbol_name
                                    TclObject tmp81;
                                    tmp81 = getVarScalar(interp, "symbol_name", compiledLocals, 3);
                                    setVarScalar(interp, "tmpsymbol", tmp81, compiledLocals, 15);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: set symbol $tmpsymbol
                            TclObject tmp82;
                            tmp82 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                            setVarScalar(interp, "symbol", tmp82, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: append buffer [...]
                            TclObject[] objv83 = TJC.grabObjv(interp, 1);
                            TclObject tmp84;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol $winfo $declare_flag
                                    TclObject[] objv85 = TJC.grabObjv(interp, 4);
                                    TclObject tmp86;
                                    try {
                                        // Arg 0 constant: ...
                                        objv85[0] = const11;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp86 = getVarScalar(interp, "tmpsymbol", compiledLocals, 15);
                                        tmp86.preserve();
                                        objv85[1] = tmp86;
                                        // Arg 2 variable: $winfo
                                        tmp86 = getVarScalar(interp, "winfo", compiledLocals, 18);
                                        tmp86.preserve();
                                        objv85[2] = tmp86;
                                        // Arg 3 variable: $declare_flag
                                        tmp86 = getVarScalar(interp, "declare_flag", compiledLocals, 2);
                                        tmp86.preserve();
                                        objv85[3] = tmp86;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv85, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp86 = objv85[1];
                                        if ( tmp86 != null ) {
                                            tmp86.release();
                                        }
                                        tmp86 = objv85[2];
                                        if ( tmp86 != null ) {
                                            tmp86.release();
                                        }
                                        tmp86 = objv85[3];
                                        if ( tmp86 != null ) {
                                            tmp86.release();
                                        }
                                        TJC.releaseObjv(interp, objv85, 4);
                                    }
                                } // End Invoke: ...
                                tmp84 = interp.getResult();
                                tmp84.preserve();
                                objv83[0] = tmp84;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv83, compiledLocals, 9);
                            } finally {
                                TJC.releaseObjvElems(interp, objv83, 1);
                            }
                        } // End Invoke: append
                    } else {
                        // Pattern default
                        { // Invoke: error "..."
                            TclObject[] objv87 = TJC.grabObjv(interp, 2);
                            TclObject tmp88;
                            try {
                                // Arg 0 constant: error
                                objv87[0] = const3;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp89 = new StringBuffer(64);
                                sbtmp89.append("unknown type ");
                                sbtmp89.append("\"");
                                tmp88 = getVarScalar(interp, "type", compiledLocals, 11);
                                sbtmp89.append(tmp88.toString());
                                sbtmp89.append("\"");
                                tmp88 = TclString.newInstance(sbtmp89);
                                tmp88.preserve();
                                objv87[1] = tmp88;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv87, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp88 = objv87[1];
                                if ( tmp88 != null ) {
                                    tmp88.release();
                                }
                                TJC.releaseObjv(interp, objv87, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: switch
            }
        } // End Invoke: if
        { // Invoke: if {$symbol == ""} ...
            // Binary operator: $symbol == ""
            TclObject tmp90 = getVarScalar(interp, "symbol", compiledLocals, 10);
            ExprValue tmp91 = evs0;
            TJC.exprEqualsEmptyString(tmp91, tmp90, false);
            // End Binary operator: ==
            boolean tmp92 = ( tmp91.getIntValue() != 0 );
            if ( tmp92 ) {
                { // Invoke: error "empty symbol"
                    TclObject[] objv93 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv93[0] = const3;
                        // Arg 1 constant: "empty symbol"
                        objv93[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv93, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv93, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $type $symbol $buffer
                TclObject tmp94 = TclList.newInstance();
                TclObject tmp95;
                try {
                    tmp95 = getVarScalar(interp, "type", compiledLocals, 11);
                    TclList.append(interp, tmp94, tmp95);
                    tmp95 = getVarScalar(interp, "symbol", compiledLocals, 10);
                    TclList.append(interp, tmp94, tmp95);
                    tmp95 = getVarScalar(interp, "buffer", compiledLocals, 9);
                    TclList.append(interp, tmp94, tmp95);
                } catch (TclException ex) {
                    tmp94.release();
                    throw ex;
                }
                interp.setResult(tmp94);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_argument");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("TclObject ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_constant_cache_get");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_tmpvar_next");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_emit_variable");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_is_empty_command");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_invoke");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("emitter_indent");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(" = interp.getResult();\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_word");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("empty symbol");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_constant_cache_get";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_variable";
                break;
            }
            case 5: {
                cmdName = "compileproc_is_empty_command";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_invoke";
                break;
            }
            case 7: {
                cmdName = "emitter_indent";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_word";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "i",
        "declare_flag",
        "symbol_name",
        "_compileproc_key_info",
        "declare",
        "types",
        "values",
        "num_args",
        "buffer",
        "symbol",
        "type",
        "str",
        "ident",
        "vinfo",
        "tmpsymbol",
        "ckeys",
        "ckey",
        "winfo"
    };
} // end class CompileprocEmitArgumentCmd

