// TJC implementation of procedure compileproc_emit_container
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                TclObject tmp1;
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp2 = new StringBuffer(64);
                    sbtmp2.append("_compileproc_ckeys(");
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp2.append(tmp1.toString());
                    sbtmp2.append(",info_key)");
                    tmp1 = TclString.newInstance(sbtmp2);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp3 = interp.getResult();
            ExprValue tmp4 = evs0;
            if ( tmp3.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp4, tmp3);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp4, tmp3);
            }
            // End Unary operator: !
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: error "..."
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 0 constant: error
                        objv6[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp8 = new StringBuffer(64);
                        sbtmp8.append("expected _compileproc_ckeys entry for container ");
                        tmp7 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp8.append(tmp7.toString());
                        tmp7 = TclString.newInstance(sbtmp8);
                        tmp7.preserve();
                        objv6[1] = tmp7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv6, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp7 = objv6[1];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp9;
            { // Invoke: lindex $... 1
                TclObject tmp10;
                StringBuffer sbtmp11 = new StringBuffer(64);
                tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp11.append(tmp10.toString());
                sbtmp11.append(",info_key");
                tmp10 = getVarArray(interp, "_compileproc_ckeys", sbtmp11.toString(), compiledLocals, 1);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp9, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cmdname == "_UNKNOWN"
            TclObject tmp12 = getVarScalar(interp, "cmdname", compiledLocals, 2);
            boolean tmp13 = tmp12.toString().equals("_UNKNOWN");
            ExprValue tmp14 = evs0;
            tmp14.setIntValue(tmp13);
            // End Binary operator: ==
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: error "..."
                    TclObject[] objv16 = TJC.grabObjv(interp, 2);
                    TclObject tmp17;
                    try {
                        // Arg 0 constant: error
                        objv16[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp18 = new StringBuffer(64);
                        sbtmp18.append("expected command name for ");
                        tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp18.append(tmp17.toString());
                        tmp17 = TclString.newInstance(sbtmp18);
                        tmp17.preserve();
                        objv16[1] = tmp17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv16, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp17 = objv16[1];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set tail [...]
            TclObject tmp19;
            { // Invoke: namespace tail $cmdname
                TclObject[] objv20 = TJC.grabObjv(interp, 3);
                TclObject tmp21;
                try {
                    // Arg 0 constant: namespace
                    objv20[0] = const3;
                    // Arg 1 constant: tail
                    objv20[1] = const4;
                    // Arg 2 variable: $cmdname
                    tmp21 = getVarScalar(interp, "cmdname", compiledLocals, 2);
                    tmp21.preserve();
                    objv20[2] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv20, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp21 = objv20[2];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 3);
                }
            } // End Invoke: namespace
            tmp19 = interp.getResult();
            setVarScalar(interp, "tail", tmp19, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: switch -exact -- $tail {catch} ... {expr} ... {for} ... {foreach} ... {if} ... {switch} ... {while} ... default ...
            TclObject tmp22 = getVarScalar(interp, "tail", compiledLocals, 3);
            String tmp23 = tmp22.toString();
            int tmp23_length = tmp23.length();
            char tmp23_first = '\n';
            if ( tmp23_length > 0 ) {
                tmp23_first = tmp23.charAt(0);
            }
            interp.resetResult();
            if ( tmp23_length == 5 && tmp23_first == 'c'
                    && tmp23.compareTo("catch") == 0 ) {
                // Pattern {catch}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv24 = TJC.grabObjv(interp, 2);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: ...
                            objv24[0] = const5;
                            // Arg 1 variable: $key
                            tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp25.preserve();
                            objv24[1] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv24, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp25 = objv24[1];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 4 && tmp23_first == 'e'
                    && tmp23.compareTo("expr") == 0 ) {
                // Pattern {expr}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const6;
                            // Arg 1 variable: $key
                            tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv26, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 3 && tmp23_first == 'f'
                    && tmp23.compareTo("for") == 0 ) {
                // Pattern {for}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv28 = TJC.grabObjv(interp, 2);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: ...
                            objv28[0] = const7;
                            // Arg 1 variable: $key
                            tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp29.preserve();
                            objv28[1] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv28, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp29 = objv28[1];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 7 && tmp23_first == 'f'
                    && tmp23.compareTo("foreach") == 0 ) {
                // Pattern {foreach}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv30 = TJC.grabObjv(interp, 2);
                        TclObject tmp31;
                        try {
                            // Arg 0 constant: ...
                            objv30[0] = const8;
                            // Arg 1 variable: $key
                            tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp31.preserve();
                            objv30[1] = tmp31;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv30, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp31 = objv30[1];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            TJC.releaseObjv(interp, objv30, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 2 && tmp23_first == 'i'
                    && tmp23.compareTo("if") == 0 ) {
                // Pattern {if}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv32 = TJC.grabObjv(interp, 2);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: ...
                            objv32[0] = const9;
                            // Arg 1 variable: $key
                            tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv32, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 6 && tmp23_first == 's'
                    && tmp23.compareTo("switch") == 0 ) {
                // Pattern {switch}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv34 = TJC.grabObjv(interp, 2);
                        TclObject tmp35;
                        try {
                            // Arg 0 constant: ...
                            objv34[0] = const10;
                            // Arg 1 variable: $key
                            tmp35 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp35.preserve();
                            objv34[1] = tmp35;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv34, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            tmp35 = objv34[1];
                            if ( tmp35 != null ) {
                                tmp35.release();
                            }
                            TJC.releaseObjv(interp, objv34, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp23_length == 5 && tmp23_first == 'w'
                    && tmp23.compareTo("while") == 0 ) {
                // Pattern {while}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv36 = TJC.grabObjv(interp, 2);
                        TclObject tmp37;
                        try {
                            // Arg 0 constant: ...
                            objv36[0] = const11;
                            // Arg 1 variable: $key
                            tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp37.preserve();
                            objv36[1] = tmp37;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv36, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            tmp37 = objv36[1];
                            if ( tmp37 != null ) {
                                tmp37.release();
                            }
                            TJC.releaseObjv(interp, objv36, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv38 = TJC.grabObjv(interp, 2);
                    TclObject tmp39;
                    try {
                        // Arg 0 constant: error
                        objv38[0] = const2;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp40 = new StringBuffer(64);
                        sbtmp40.append("expected a supported container command, got ");
                        sbtmp40.append("\"");
                        tmp39 = getVarScalar(interp, "tail", compiledLocals, 3);
                        sbtmp40.append(tmp39.toString());
                        sbtmp40.append("\"");
                        tmp39 = TclString.newInstance(sbtmp40);
                        tmp39.preserve();
                        objv38[1] = tmp39;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv38, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp39 = objv38[1];
                        if ( tmp39 != null ) {
                            tmp39.release();
                        }
                        TJC.releaseObjv(interp, objv38, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("namespace");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("tail");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_emit_container_catch");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_emit_container_expr");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_emit_container_for");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_container_foreach");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_container_if");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_emit_container_switch");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_container_while");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "namespace";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_container_catch";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_container_expr";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_container_for";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_container_foreach";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_container_if";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_container_switch";
                break;
            }
            case 10: {
                cmdName = "compileproc_emit_container_while";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc_ckeys",
        "cmdname",
        "tail"
    };
} // end class CompileprocEmitContainerCmd

