// TJC implementation of procedure compileproc_emit_container_expr
package tjc;
import tcl.lang.*;

public class CompileprocEmitContainerExprCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            if (!tmp3.getBooleanValue(interp)) {
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv4 = TJC.grabObjv(interp, 2);
                TclObject tmp5;
                try {
                    // Arg 0 constant: ...
                    objv4[0] = const2;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv4, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 2);
                }
            } // End Invoke: ...
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs1;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            tmp3.setIntValue(tmp7.getBooleanValue(interp));
            } else {
            tmp3.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp8 = ( tmp3.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: error "..."
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    TclObject tmp10;
                    try {
                        // Arg 0 constant: error
                        objv9[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp11 = new StringBuffer(64);
                        sbtmp11.append("NOT valid or NOT static for key ");
                        tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp11.append(tmp10.toString());
                        tmp10 = TclString.newInstance(sbtmp11);
                        tmp10.preserve();
                        objv9[1] = tmp10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv9, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp10 = objv9[1];
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv12 = TJC.grabObjv(interp, 1);
            TclObject tmp13;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $key
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    TclObject tmp15;
                    try {
                        // Arg 0 constant: ...
                        objv14[0] = const4;
                        // Arg 1 variable: $key
                        tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv14, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: ...
                tmp13 = interp.getResult();
                tmp13.preserve();
                objv12[0] = tmp13;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv12, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv12, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp16 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp16);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_container_expr");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_container_is_valid");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("descend_container_is_static");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_expr_evaluate_result_emit");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_is_valid";
                break;
            }
            case 2: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "compileproc_expr_evaluate_result_emit";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "buffer"
    };
} // end class CompileprocEmitContainerExprCmd

