// TJC implementation of procedure compileproc_emit_exprvalue_get
package tjc;
import tcl.lang.*;

public class CompileprocEmitExprvalueGetCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 4 || objv.length > 5) {
            throw new TclNumArgsException(interp, 1, objv, "symbol value_type value ?srep?");
        }
        setVarScalar(interp, "symbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "value_type", objv[2], compiledLocals, 1);
        setVarScalar(interp, "value", objv[3], compiledLocals, 2);
        setVarScalar(interp, "srep", 
            ((objv.length <= 4) ? const0 : objv[4]), compiledLocals, 3);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 4);
        } // End Invoke: global
        { // Invoke: switch -exact -- $value_type {int} - {double} - {boolean} - {TclObject} - {String} - {} ... default ...
            TclObject tmp0 = getVarScalar(interp, "value_type", compiledLocals, 1);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            if ( ( tmp1_length == 3 && tmp1_first == 'i'
                    && tmp1.compareTo("int") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'd'
                    && tmp1.compareTo("double") == 0 ) ||
                ( tmp1_length == 7 && tmp1_first == 'b'
                    && tmp1.compareTo("boolean") == 0 ) ||
                ( tmp1_length == 9 && tmp1_first == 'T'
                    && tmp1.compareTo("TclObject") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'S'
                    && tmp1.compareTo("String") == 0 ) ||
                ( tmp1_length == 0 ) ) {
                // Pattern {}
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    TclObject tmp3;
                    try {
                        // Arg 0 constant: error
                        objv2[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp4 = new StringBuffer(64);
                        sbtmp4.append("unsupported value_type ");
                        sbtmp4.append("\"");
                        tmp3 = getVarScalar(interp, "value_type", compiledLocals, 1);
                        sbtmp4.append(tmp3.toString());
                        sbtmp4.append("\"");
                        tmp3 = TclString.newInstance(sbtmp4);
                        tmp3.preserve();
                        objv2[1] = tmp3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp3 = objv2[1];
                        if ( tmp3 != null ) {
                            tmp3.release();
                        }
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: set buffer [...]
            TclObject tmp5;
            { // Invoke: emitter_indent
                TclObject[] objv6 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv6[0] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv6, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv6, 1);
                }
            } // End Invoke: emitter_indent
            tmp5 = interp.getResult();
            setVarScalar(interp, "buffer", tmp5, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: append buffer "ExprValue " $symbol " = "
            TclObject[] objv7 = TJC.grabObjv(interp, 3);
            TclObject tmp8;
            try {
                // Arg 2 constant: "ExprValue "
                objv7[0] = const3;
                // Arg 3 variable: $symbol
                tmp8 = getVarScalar(interp, "symbol", compiledLocals, 0);
                tmp8.preserve();
                objv7[1] = tmp8;
                // Arg 4 constant: " = "
                objv7[2] = const4;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv7, compiledLocals, 5);
            } finally {
                tmp8 = objv7[1];
                if ( tmp8 != null ) {
                    tmp8.release();
                }
                TJC.releaseObjv(interp, objv7, 3);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            // Unary operator: ! $_compileproc(...)
            TclObject tmp9 = getVarArray(interp, "_compileproc", "options,expr_value_stack", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            if ( tmp9.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp10, tmp9);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp10, tmp9);
            }
            // End Unary operator: !
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: $value_type == ""
                    TclObject tmp12 = getVarScalar(interp, "value_type", compiledLocals, 1);
                    ExprValue tmp13 = evs0;
                    TJC.exprEqualsEmptyString(tmp13, tmp12, false);
                    // End Binary operator: ==
                    if (tmp13.getBooleanValue(interp)) {
                    // Binary operator: $value == ""
                    TclObject tmp14 = getVarScalar(interp, "value", compiledLocals, 2);
                    ExprValue tmp15 = evs1;
                    TJC.exprEqualsEmptyString(tmp15, tmp14, false);
                    // End Binary operator: ==
                    tmp13.setIntValue(tmp15.getBooleanValue(interp));
                    } else {
                    tmp13.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp16 = ( tmp13.getIntValue() != 0 );
                    if ( tmp16 ) {
                        { // Invoke: append buffer ... ...
                            TclObject[] objv17 = TJC.grabObjv(interp, 2);
                            TclObject tmp18;
                            try {
                                // Arg 2 constant: ...
                                objv17[0] = const5;
                                // Arg 3 constant: ...
                                objv17[1] = const6;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv17, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjv(interp, objv17, 2);
                            }
                        } // End Invoke: append
                    } else {
                        // Binary operator: $srep == "__TJC_NONE"
                        TclObject tmp19 = getVarScalar(interp, "srep", compiledLocals, 3);
                        boolean tmp20 = tmp19.toString().equals("__TJC_NONE");
                        ExprValue tmp21 = evs0;
                        tmp21.setIntValue(tmp20);
                        // End Binary operator: ==
                        boolean tmp22 = ( tmp21.getIntValue() != 0 );
                        if ( tmp22 ) {
                            { // Invoke: append buffer ... $value ")" ...
                                TclObject[] objv23 = TJC.grabObjv(interp, 4);
                                TclObject tmp24;
                                try {
                                    // Arg 2 constant: ...
                                    objv23[0] = const7;
                                    // Arg 3 variable: $value
                                    tmp24 = getVarScalar(interp, "value", compiledLocals, 2);
                                    tmp24.preserve();
                                    objv23[1] = tmp24;
                                    // Arg 4 constant: ")"
                                    objv23[2] = const8;
                                    // Arg 5 constant: ...
                                    objv23[3] = const6;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv23, compiledLocals, 5);
                                } finally {
                                    tmp24 = objv23[1];
                                    if ( tmp24 != null ) {
                                        tmp24.release();
                                    }
                                    TJC.releaseObjv(interp, objv23, 4);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: append buffer ... $value ", " $srep ")" ...
                                TclObject[] objv25 = TJC.grabObjv(interp, 6);
                                TclObject tmp26;
                                try {
                                    // Arg 2 constant: ...
                                    objv25[0] = const7;
                                    // Arg 3 variable: $value
                                    tmp26 = getVarScalar(interp, "value", compiledLocals, 2);
                                    tmp26.preserve();
                                    objv25[1] = tmp26;
                                    // Arg 4 constant: ", "
                                    objv25[2] = const9;
                                    // Arg 5 variable: $srep
                                    tmp26 = getVarScalar(interp, "srep", compiledLocals, 3);
                                    tmp26.preserve();
                                    objv25[3] = tmp26;
                                    // Arg 6 constant: ")"
                                    objv25[4] = const8;
                                    // Arg 7 constant: ...
                                    objv25[5] = const6;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv25, compiledLocals, 5);
                                } finally {
                                    tmp26 = objv25[1];
                                    if ( tmp26 != null ) {
                                        tmp26.release();
                                    }
                                    tmp26 = objv25[3];
                                    if ( tmp26 != null ) {
                                        tmp26.release();
                                    }
                                    TJC.releaseObjv(interp, objv25, 6);
                                }
                            } // End Invoke: append
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: set stack_sym [...]
                    TclObject tmp27;
                    { // Invoke: ...
                        TclObject[] objv28 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv28[0] = const10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv28, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv28, 1);
                        }
                    } // End Invoke: ...
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "stack_sym", tmp27, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: ... $symbol $stack_sym
                    TclObject[] objv29 = TJC.grabObjv(interp, 3);
                    TclObject tmp30;
                    try {
                        // Arg 0 constant: ...
                        objv29[0] = const11;
                        // Arg 1 variable: $symbol
                        tmp30 = getVarScalar(interp, "symbol", compiledLocals, 0);
                        tmp30.preserve();
                        objv29[1] = tmp30;
                        // Arg 2 variable: $stack_sym
                        tmp30 = getVarScalar(interp, "stack_sym", compiledLocals, 6);
                        tmp30.preserve();
                        objv29[2] = tmp30;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv29, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp30 = objv29[1];
                        if ( tmp30 != null ) {
                            tmp30.release();
                        }
                        tmp30 = objv29[2];
                        if ( tmp30 != null ) {
                            tmp30.release();
                        }
                        TJC.releaseObjv(interp, objv29, 3);
                    }
                } // End Invoke: ...
                { // Invoke: append buffer $stack_sym ...
                    TclObject[] objv31 = TJC.grabObjv(interp, 2);
                    TclObject tmp32;
                    try {
                        // Arg 2 variable: $stack_sym
                        tmp32 = getVarScalar(interp, "stack_sym", compiledLocals, 6);
                        tmp32.preserve();
                        objv31[0] = tmp32;
                        // Arg 3 constant: ...
                        objv31[1] = const6;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv31, compiledLocals, 5);
                    } finally {
                        tmp32 = objv31[0];
                        if ( tmp32 != null ) {
                            tmp32.release();
                        }
                        TJC.releaseObjv(interp, objv31, 2);
                    }
                } // End Invoke: append
                { // Invoke: if ... ...
                    TclObject tmp33 = getVarArray(interp, "_compileproc", "options,expr_value_stack_null", compiledLocals, 4);
                    ExprValue tmp34 = evs0;
                    TJC.exprInitValue(interp, tmp34, tmp33);
                    boolean tmp35 = tmp34.getBooleanValue(interp);
                    if ( tmp35 ) {
                        { // Invoke: append buffer [...] $stack_sym " = null" ...
                            TclObject[] objv36 = TJC.grabObjv(interp, 4);
                            TclObject tmp37;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv38[0] = const2;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv38, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv38, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp37 = interp.getResult();
                                tmp37.preserve();
                                objv36[0] = tmp37;
                                // Arg 3 variable: $stack_sym
                                tmp37 = getVarScalar(interp, "stack_sym", compiledLocals, 6);
                                tmp37.preserve();
                                objv36[1] = tmp37;
                                // Arg 4 constant: " = null"
                                objv36[2] = const12;
                                // Arg 5 constant: ...
                                objv36[3] = const6;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv36, compiledLocals, 5);
                            } finally {
                                tmp37 = objv36[0];
                                if ( tmp37 != null ) {
                                    tmp37.release();
                                }
                                tmp37 = objv36[1];
                                if ( tmp37 != null ) {
                                    tmp37.release();
                                }
                                TJC.releaseObjv(interp, objv36, 4);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: if ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: $value_type == ""
                    TclObject tmp39 = getVarScalar(interp, "value_type", compiledLocals, 1);
                    ExprValue tmp40 = evs0;
                    TJC.exprEqualsEmptyString(tmp40, tmp39, false);
                    // End Binary operator: ==
                    if (tmp40.getBooleanValue(interp)) {
                    // Binary operator: $value == ""
                    TclObject tmp41 = getVarScalar(interp, "value", compiledLocals, 2);
                    ExprValue tmp42 = evs1;
                    TJC.exprEqualsEmptyString(tmp42, tmp41, false);
                    // End Binary operator: ==
                    tmp40.setIntValue(tmp42.getBooleanValue(interp));
                    } else {
                    tmp40.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp43 = ( tmp40.getIntValue() != 0 );
                    if ( tmp43 ) {
                    } else {
                        { // Invoke: if ... ... else ...
                            // Binary operator: () || ()
                            // Binary operator: $srep == "__TJC_NONE"
                            TclObject tmp44 = getVarScalar(interp, "srep", compiledLocals, 3);
                            boolean tmp45 = tmp44.toString().equals("__TJC_NONE");
                            ExprValue tmp46 = evs0;
                            tmp46.setIntValue(tmp45);
                            // End Binary operator: ==
                            if (!tmp46.getBooleanValue(interp)) {
                            // Binary operator: $srep == "null"
                            TclObject tmp47 = getVarScalar(interp, "srep", compiledLocals, 3);
                            boolean tmp48 = tmp47.toString().equals("null");
                            ExprValue tmp49 = evs1;
                            tmp49.setIntValue(tmp48);
                            // End Binary operator: ==
                            tmp46.setIntValue(tmp49.getBooleanValue(interp));
                            } else {
                            tmp46.setIntValue(1);
                            } // End if: !()
                            // End Binary operator: ||
                            boolean tmp50 = ( tmp46.getIntValue() != 0 );
                            if ( tmp50 ) {
                                { // Invoke: set args $value
                                    TclObject tmp51;
                                    tmp51 = getVarScalar(interp, "value", compiledLocals, 2);
                                    setVarScalar(interp, "args", tmp51, compiledLocals, 7);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set args "$value, $srep"
                                    TclObject tmp52;
                                    StringBuffer sbtmp53 = new StringBuffer(64);
                                    tmp52 = getVarScalar(interp, "value", compiledLocals, 2);
                                    sbtmp53.append(tmp52.toString());
                                    sbtmp53.append(", ");
                                    tmp52 = getVarScalar(interp, "srep", compiledLocals, 3);
                                    sbtmp53.append(tmp52.toString());
                                    tmp52 = TclString.newInstance(sbtmp53);
                                    setVarScalar(interp, "args", tmp52, compiledLocals, 7);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: append buffer [...]
                            TclObject[] objv54 = TJC.grabObjv(interp, 1);
                            TclObject tmp55;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv56 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv56[0] = const2;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv56, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv56, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp55 = interp.getResult();
                                tmp55.preserve();
                                objv54[0] = tmp55;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv54, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjvElems(interp, objv54, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: switch -exact -- $value_type {int} ... {double} ... {boolean} ... {TclObject} ... {String} ... {} ... default ...
                            TclObject tmp57 = getVarScalar(interp, "value_type", compiledLocals, 1);
                            String tmp58 = tmp57.toString();
                            int tmp58_length = tmp58.length();
                            char tmp58_first = '\n';
                            if ( tmp58_length > 0 ) {
                                tmp58_first = tmp58.charAt(0);
                            }
                            if ( tmp58_length == 3 && tmp58_first == 'i'
                                    && tmp58.compareTo("int") == 0 ) {
                                // Pattern {int}
                                { // Invoke: append buffer $symbol ".setIntValue(" $args ")"
                                    TclObject[] objv59 = TJC.grabObjv(interp, 4);
                                    TclObject tmp60;
                                    try {
                                        // Arg 2 variable: $symbol
                                        tmp60 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                        tmp60.preserve();
                                        objv59[0] = tmp60;
                                        // Arg 3 constant: ".setIntValue("
                                        objv59[1] = const13;
                                        // Arg 4 variable: $args
                                        tmp60 = getVarScalar(interp, "args", compiledLocals, 7);
                                        tmp60.preserve();
                                        objv59[2] = tmp60;
                                        // Arg 5 constant: ")"
                                        objv59[3] = const8;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv59, compiledLocals, 5);
                                    } finally {
                                        tmp60 = objv59[0];
                                        if ( tmp60 != null ) {
                                            tmp60.release();
                                        }
                                        tmp60 = objv59[2];
                                        if ( tmp60 != null ) {
                                            tmp60.release();
                                        }
                                        TJC.releaseObjv(interp, objv59, 4);
                                    }
                                } // End Invoke: append
                            } else if ( tmp58_length == 6 && tmp58_first == 'd'
                                    && tmp58.compareTo("double") == 0 ) {
                                // Pattern {double}
                                { // Invoke: append buffer $symbol ".setDoubleValue(" $args ")"
                                    TclObject[] objv61 = TJC.grabObjv(interp, 4);
                                    TclObject tmp62;
                                    try {
                                        // Arg 2 variable: $symbol
                                        tmp62 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                        tmp62.preserve();
                                        objv61[0] = tmp62;
                                        // Arg 3 constant: ".setDoubleValue("
                                        objv61[1] = const14;
                                        // Arg 4 variable: $args
                                        tmp62 = getVarScalar(interp, "args", compiledLocals, 7);
                                        tmp62.preserve();
                                        objv61[2] = tmp62;
                                        // Arg 5 constant: ")"
                                        objv61[3] = const8;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv61, compiledLocals, 5);
                                    } finally {
                                        tmp62 = objv61[0];
                                        if ( tmp62 != null ) {
                                            tmp62.release();
                                        }
                                        tmp62 = objv61[2];
                                        if ( tmp62 != null ) {
                                            tmp62.release();
                                        }
                                        TJC.releaseObjv(interp, objv61, 4);
                                    }
                                } // End Invoke: append
                            } else if ( tmp58_length == 7 && tmp58_first == 'b'
                                    && tmp58.compareTo("boolean") == 0 ) {
                                // Pattern {boolean}
                                { // Invoke: append buffer $symbol ".setIntValue(" $args ")"
                                    TclObject[] objv63 = TJC.grabObjv(interp, 4);
                                    TclObject tmp64;
                                    try {
                                        // Arg 2 variable: $symbol
                                        tmp64 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                        tmp64.preserve();
                                        objv63[0] = tmp64;
                                        // Arg 3 constant: ".setIntValue("
                                        objv63[1] = const13;
                                        // Arg 4 variable: $args
                                        tmp64 = getVarScalar(interp, "args", compiledLocals, 7);
                                        tmp64.preserve();
                                        objv63[2] = tmp64;
                                        // Arg 5 constant: ")"
                                        objv63[3] = const8;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv63, compiledLocals, 5);
                                    } finally {
                                        tmp64 = objv63[0];
                                        if ( tmp64 != null ) {
                                            tmp64.release();
                                        }
                                        tmp64 = objv63[2];
                                        if ( tmp64 != null ) {
                                            tmp64.release();
                                        }
                                        TJC.releaseObjv(interp, objv63, 4);
                                    }
                                } // End Invoke: append
                            } else if ( tmp58_length == 9 && tmp58_first == 'T'
                                    && tmp58.compareTo("TclObject") == 0 ) {
                                // Pattern {TclObject}
                                { // Invoke: if {$args ne $value} ...
                                    // Binary operator: $args ne $value
                                    TclObject tmp65 = getVarScalar(interp, "args", compiledLocals, 7);
                                    String tmp66 = tmp65.toString();
                                    TclObject tmp67 = getVarScalar(interp, "value", compiledLocals, 2);
                                    String tmp68 = tmp67.toString();
                                    boolean tmp69 = ! tmp66.equals(tmp68);
                                    ExprValue tmp70 = evs0;
                                    tmp70.setIntValue(tmp69);
                                    // End Binary operator: ne
                                    boolean tmp71 = ( tmp70.getIntValue() != 0 );
                                    if ( tmp71 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv72 = TJC.grabObjv(interp, 2);
                                            TclObject tmp73;
                                            try {
                                                // Arg 0 constant: error
                                                objv72[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp74 = new StringBuffer(64);
                                                sbtmp74.append("unexpected string rep ");
                                                sbtmp74.append("\"");
                                                tmp73 = getVarScalar(interp, "srep", compiledLocals, 3);
                                                sbtmp74.append(tmp73.toString());
                                                sbtmp74.append("\"");
                                                sbtmp74.append(" for TclObject type");
                                                tmp73 = TclString.newInstance(sbtmp74);
                                                tmp73.preserve();
                                                objv72[1] = tmp73;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv72, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp73 = objv72[1];
                                                if ( tmp73 != null ) {
                                                    tmp73.release();
                                                }
                                                TJC.releaseObjv(interp, objv72, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: append buffer "..."
                                    TclObject[] objv75 = TJC.grabObjv(interp, 1);
                                    TclObject tmp76;
                                    try {
                                        // Arg 2 word: "..."
                                        StringBuffer sbtmp77 = new StringBuffer(64);
                                        sbtmp77.append("TJC.exprInitValue(interp, ");
                                        tmp76 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                        sbtmp77.append(tmp76.toString());
                                        sbtmp77.append(", ");
                                        tmp76 = getVarScalar(interp, "value", compiledLocals, 2);
                                        sbtmp77.append(tmp76.toString());
                                        sbtmp77.append(")");
                                        tmp76 = TclString.newInstance(sbtmp77);
                                        tmp76.preserve();
                                        objv75[0] = tmp76;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv75, compiledLocals, 5);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv75, 1);
                                    }
                                } // End Invoke: append
                            } else if ( tmp58_length == 6 && tmp58_first == 'S'
                                    && tmp58.compareTo("String") == 0 ) {
                                // Pattern {String}
                                { // Invoke: if {$args ne $value} ...
                                    // Binary operator: $args ne $value
                                    TclObject tmp78 = getVarScalar(interp, "args", compiledLocals, 7);
                                    String tmp79 = tmp78.toString();
                                    TclObject tmp80 = getVarScalar(interp, "value", compiledLocals, 2);
                                    String tmp81 = tmp80.toString();
                                    boolean tmp82 = ! tmp79.equals(tmp81);
                                    ExprValue tmp83 = evs0;
                                    tmp83.setIntValue(tmp82);
                                    // End Binary operator: ne
                                    boolean tmp84 = ( tmp83.getIntValue() != 0 );
                                    if ( tmp84 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv85 = TJC.grabObjv(interp, 2);
                                            TclObject tmp86;
                                            try {
                                                // Arg 0 constant: error
                                                objv85[0] = const1;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp87 = new StringBuffer(64);
                                                sbtmp87.append("unexpected string rep ");
                                                sbtmp87.append("\"");
                                                tmp86 = getVarScalar(interp, "srep", compiledLocals, 3);
                                                sbtmp87.append(tmp86.toString());
                                                sbtmp87.append("\"");
                                                sbtmp87.append(" for String type");
                                                tmp86 = TclString.newInstance(sbtmp87);
                                                tmp86.preserve();
                                                objv85[1] = tmp86;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv85, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp86 = objv85[1];
                                                if ( tmp86 != null ) {
                                                    tmp86.release();
                                                }
                                                TJC.releaseObjv(interp, objv85, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: append buffer $symbol ".setStringValue(" $value ")"
                                    TclObject[] objv88 = TJC.grabObjv(interp, 4);
                                    TclObject tmp89;
                                    try {
                                        // Arg 2 variable: $symbol
                                        tmp89 = getVarScalar(interp, "symbol", compiledLocals, 0);
                                        tmp89.preserve();
                                        objv88[0] = tmp89;
                                        // Arg 3 constant: ".setStringValue("
                                        objv88[1] = const15;
                                        // Arg 4 variable: $value
                                        tmp89 = getVarScalar(interp, "value", compiledLocals, 2);
                                        tmp89.preserve();
                                        objv88[2] = tmp89;
                                        // Arg 5 constant: ")"
                                        objv88[3] = const8;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv88, compiledLocals, 5);
                                    } finally {
                                        tmp89 = objv88[0];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        tmp89 = objv88[2];
                                        if ( tmp89 != null ) {
                                            tmp89.release();
                                        }
                                        TJC.releaseObjv(interp, objv88, 4);
                                    }
                                } // End Invoke: append
                            } else if ( tmp58_length == 0 ) {
                                // Pattern {}
                                { // Invoke: error ...
                                    TclObject[] objv90 = TJC.grabObjv(interp, 2);
                                    try {
                                        // Arg 0 constant: error
                                        objv90[0] = const1;
                                        // Arg 1 constant: ...
                                        objv90[1] = const16;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv90, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv90, 2);
                                    }
                                } // End Invoke: error
                            } else {
                                // Pattern default
                                { // Invoke: error "..."
                                    TclObject[] objv91 = TJC.grabObjv(interp, 2);
                                    TclObject tmp92;
                                    try {
                                        // Arg 0 constant: error
                                        objv91[0] = const1;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp93 = new StringBuffer(64);
                                        sbtmp93.append("unmatched value_type ");
                                        sbtmp93.append("\"");
                                        tmp92 = getVarScalar(interp, "value_type", compiledLocals, 1);
                                        sbtmp93.append(tmp92.toString());
                                        sbtmp93.append("\"");
                                        tmp92 = TclString.newInstance(sbtmp93);
                                        tmp92.preserve();
                                        objv91[1] = tmp92;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                            ? cmdcache1.cmd : null), objv91, 0);
                                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                            updateCmdCache(interp, 1);
                                        }
                                    } finally {
                                        tmp92 = objv91[1];
                                        if ( tmp92 != null ) {
                                            tmp92.release();
                                        }
                                        TJC.releaseObjv(interp, objv91, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: switch
                        { // Invoke: append buffer ...
                            TclObject[] objv94 = TJC.grabObjv(interp, 1);
                            TclObject tmp95;
                            try {
                                // Arg 2 constant: ...
                                objv94[0] = const6;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv94, compiledLocals, 5);
                            } finally {
                                TJC.releaseObjv(interp, objv94, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp96 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp96);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_exprvalue_get");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("__TJC_NONE");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_indent");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("ExprValue ");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance(" = ");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("TJC.exprGetValue(interp)");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(";\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("TJC.exprGetValue(interp, ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(")");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(", ");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_expr_value_stack_get");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_expr_value_stack_alias");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(" = null");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(".setIntValue(");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(".setDoubleValue(");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance(".setStringValue(");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("unexpected empty string as value_type");
        const16.preserve(); const16.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "compileproc_expr_value_stack_get";
                break;
            }
            case 4: {
                cmdName = "compileproc_expr_value_stack_alias";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "symbol",
        "value_type",
        "value",
        "srep",
        "_compileproc",
        "buffer",
        "stack_sym",
        "args"
    };
} // end class CompileprocEmitExprvalueGetCmd

