// TJC implementation of procedure compileproc_emit_inline_command_global
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandGlobalCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: ...
                    objv0[0] = const1;
                    // Arg 1 variable: $key
                    tmp1 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: ...
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv5 = TJC.grabObjv(interp, 1);
                    TclObject tmp6;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_reset_result
                            TclObject[] objv7 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_reset_result
                                objv7[0] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv7, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv7, 1);
                            }
                        } // End Invoke: emitter_reset_result
                        tmp6 = interp.getResult();
                        tmp6.preserve();
                        objv5[0] = tmp6;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv5, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv5, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: set tree [...]
            TclObject tmp8;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv9 = TJC.grabObjv(interp, 3);
                TclObject tmp10;
                try {
                    // Arg 0 constant: descend_get_data
                    objv9[0] = const3;
                    // Arg 1 variable: $key
                    tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    // Arg 2 constant: tree
                    objv9[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv9, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 3);
                }
            } // End Invoke: descend_get_data
            tmp8 = interp.getResult();
            setVarScalar(interp, "tree", tmp8, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp11;
            { // Invoke: llength $tree
                TclObject tmp12 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp13 = TclList.getLength(interp, tmp12);
                interp.setResult(tmp13);
            } // End Invoke: llength
            tmp11 = interp.getResult();
            setVarScalar(interp, "num_args", tmp11, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            TclObject tmp14 = getVarArray(interp, "_compileproc", "options,cache_variables", compiledLocals, 1);
            ExprValue tmp15 = evs0;
            TJC.exprInitValue(interp, tmp15, tmp14);
            boolean tmp16 = tmp15.getBooleanValue(interp);
            if ( tmp16 ) {
                { // Invoke: set cache_variables 1
                    setVarScalar(interp, "cache_variables", const5, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set cache_variables 0
                    setVarScalar(interp, "cache_variables", const6, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: for {set i 1} {$i < $num_args} {incr i} ...
            { // Invoke: set i 1
                setVarScalar(interp, "i", const5, compiledLocals, 6);
            } // End Invoke: set
            for ( boolean skip22 = true ; true ; ) {
                if ( skip22 ) {
                    skip22 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 6);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp17 = getVarScalar(interp, "i", compiledLocals, 6);
                ExprValue tmp18 = evs0;
                TJC.exprInitValue(interp, tmp18, tmp17);
                TclObject tmp19 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp20 = evs1;
                TJC.exprInitValue(interp, tmp20, tmp19);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp18, tmp20);
                // End Binary operator: <
                boolean tmp21 = ( tmp18.getIntValue() != 0 );
                if ( ! tmp21 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set tuple [...]
                    TclObject tmp23;
                    { // Invoke: ... $key $i
                        TclObject[] objv24 = TJC.grabObjv(interp, 3);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: ...
                            objv24[0] = const7;
                            // Arg 1 variable: $key
                            tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp25.preserve();
                            objv24[1] = tmp25;
                            // Arg 2 variable: $i
                            tmp25 = getVarScalar(interp, "i", compiledLocals, 6);
                            tmp25.preserve();
                            objv24[2] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv24, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp25 = objv24[1];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            tmp25 = objv24[2];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 3);
                        }
                    } // End Invoke: ...
                    tmp23 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp23, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set varname [...]
                    TclObject tmp26;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp27 = getVarScalar(interp, "tuple", compiledLocals, 7);
                        tmp27 = TclList.index(interp, tmp27, 1);
                        if ( tmp27 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp27);
                        }
                    } // End Invoke: lindex
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "varname", tmp26, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set tail [...]
                    TclObject tmp28;
                    { // Invoke: namespace tail $varname
                        TclObject[] objv29 = TJC.grabObjv(interp, 3);
                        TclObject tmp30;
                        try {
                            // Arg 0 constant: namespace
                            objv29[0] = const8;
                            // Arg 1 constant: tail
                            objv29[1] = const9;
                            // Arg 2 variable: $varname
                            tmp30 = getVarScalar(interp, "varname", compiledLocals, 8);
                            tmp30.preserve();
                            objv29[2] = tmp30;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv29, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp30 = objv29[2];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            TJC.releaseObjv(interp, objv29, 3);
                        }
                    } // End Invoke: namespace
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "tail", tmp28, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: if {$cache_variables} ... else ...
                    TclObject tmp31 = getVarScalar(interp, "cache_variables", compiledLocals, 5);
                    boolean tmp32 = TJC.getBoolean(interp, tmp31);
                    if ( tmp32 ) {
                        { // Invoke: set cache_symbol [...]
                            TclObject tmp33;
                            { // Invoke: ... $tail
                                TclObject[] objv34 = TJC.grabObjv(interp, 2);
                                TclObject tmp35;
                                try {
                                    // Arg 0 constant: ...
                                    objv34[0] = const10;
                                    // Arg 1 variable: $tail
                                    tmp35 = getVarScalar(interp, "tail", compiledLocals, 9);
                                    tmp35.preserve();
                                    objv34[1] = tmp35;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv34, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    tmp35 = objv34[1];
                                    if ( tmp35 != null ) {
                                        tmp35.release();
                                    }
                                    TJC.releaseObjv(interp, objv34, 2);
                                }
                            } // End Invoke: ...
                            tmp33 = interp.getResult();
                            setVarScalar(interp, "cache_symbol", tmp33, compiledLocals, 10);
                        } // End Invoke: set
                        { // Invoke: set localIndex [...]
                            TclObject tmp36;
                            { // Invoke: ... $cache_symbol
                                TclObject[] objv37 = TJC.grabObjv(interp, 2);
                                TclObject tmp38;
                                try {
                                    // Arg 0 constant: ...
                                    objv37[0] = const11;
                                    // Arg 1 variable: $cache_symbol
                                    tmp38 = getVarScalar(interp, "cache_symbol", compiledLocals, 10);
                                    tmp38.preserve();
                                    objv37[1] = tmp38;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                        ? cmdcache7.cmd : null), objv37, 0);
                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                        updateCmdCache(interp, 7);
                                    }
                                } finally {
                                    tmp38 = objv37[1];
                                    if ( tmp38 != null ) {
                                        tmp38.release();
                                    }
                                    TJC.releaseObjv(interp, objv37, 2);
                                }
                            } // End Invoke: ...
                            tmp36 = interp.getResult();
                            setVarScalar(interp, "localIndex", tmp36, compiledLocals, 11);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set localIndex -1
                            setVarScalar(interp, "localIndex", const12, compiledLocals, 11);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append buffer [...]
                    TclObject[] objv39 = TJC.grabObjv(interp, 1);
                    TclObject tmp40;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $varname $tail $localIndex
                            TclObject[] objv41 = TJC.grabObjv(interp, 4);
                            TclObject tmp42;
                            try {
                                // Arg 0 constant: ...
                                objv41[0] = const13;
                                // Arg 1 variable: $varname
                                tmp42 = getVarScalar(interp, "varname", compiledLocals, 8);
                                tmp42.preserve();
                                objv41[1] = tmp42;
                                // Arg 2 variable: $tail
                                tmp42 = getVarScalar(interp, "tail", compiledLocals, 9);
                                tmp42.preserve();
                                objv41[2] = tmp42;
                                // Arg 3 variable: $localIndex
                                tmp42 = getVarScalar(interp, "localIndex", compiledLocals, 11);
                                tmp42.preserve();
                                objv41[3] = tmp42;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv41, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                tmp42 = objv41[1];
                                if ( tmp42 != null ) {
                                    tmp42.release();
                                }
                                tmp42 = objv41[2];
                                if ( tmp42 != null ) {
                                    tmp42.release();
                                }
                                tmp42 = objv41[3];
                                if ( tmp42 != null ) {
                                    tmp42.release();
                                }
                                TJC.releaseObjv(interp, objv41, 4);
                            }
                        } // End Invoke: ...
                        tmp40 = interp.getResult();
                        tmp40.preserve();
                        objv39[0] = tmp40;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv39, compiledLocals, 2);
                    } finally {
                        TJC.releaseObjvElems(interp, objv39, 1);
                    }
                } // End Invoke: append
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $buffer
            TclObject tmp43 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp43);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_global");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_omit_set_result");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_reset_result");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_get_data");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("tree");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(1);
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(0);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_get_argument_tuple");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("namespace");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("tail");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_variable_cache_lookup");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_get_variable_cache_id_from_symbol");
        const11.preserve(); const11.preserve();
        const12 = TclInteger.newInstance(-1);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("emitter_make_global_link_var");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 2: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 3: {
                cmdName = "descend_get_data";
                break;
            }
            case 4: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 5: {
                cmdName = "namespace";
                break;
            }
            case 6: {
                cmdName = "compileproc_variable_cache_lookup";
                break;
            }
            case 7: {
                cmdName = "compileproc_get_variable_cache_id_from_symbol";
                break;
            }
            case 8: {
                cmdName = "emitter_make_global_link_var";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "tree",
        "num_args",
        "cache_variables",
        "i",
        "tuple",
        "varname",
        "tail",
        "cache_symbol",
        "localIndex"
    };
} // end class CompileprocEmitInlineCommandGlobalCmd

