// TJC implementation of procedure compileproc_emit_inline_command_list_argument
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandListArgumentCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "key i listsymbol valuesymbol");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "i", objv[2], compiledLocals, 1);
        setVarScalar(interp, "listsymbol", objv[3], compiledLocals, 2);
        setVarScalar(interp, "valuesymbol", objv[4], compiledLocals, 3);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key $i false $valuesymbol
                TclObject[] objv1 = TJC.grabObjv(interp, 5);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $i
                    tmp2 = getVarScalar(interp, "i", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 constant: false
                    objv1[3] = const2;
                    // Arg 4 variable: $valuesymbol
                    tmp2 = getVarScalar(interp, "valuesymbol", compiledLocals, 3);
                    tmp2.preserve();
                    objv1[4] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[4];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 5);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set value_type [...]
            TclObject tmp3;
            { // Invoke: lindex $tuple 0
                TclObject tmp4 = getVarScalar(interp, "tuple", compiledLocals, 5);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "value_type", tmp3, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set value_symbol [...]
            TclObject tmp5;
            { // Invoke: lindex $tuple 1
                TclObject tmp6 = getVarScalar(interp, "tuple", compiledLocals, 5);
                tmp6 = TclList.index(interp, tmp6, 1);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "value_symbol", tmp5, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set value_buffer [...]
            TclObject tmp7;
            { // Invoke: lindex $tuple 2
                TclObject tmp8 = getVarScalar(interp, "tuple", compiledLocals, 5);
                tmp8 = TclList.index(interp, tmp8, 2);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "value_buffer", tmp7, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $value_type == "constant"
            TclObject tmp9 = getVarScalar(interp, "value_type", compiledLocals, 6);
            boolean tmp10 = tmp9.toString().equals("constant");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: ==
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set value $value_symbol
                    TclObject tmp13;
                    tmp13 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                    setVarScalar(interp, "value", tmp13, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: append buffer $value_buffer
                    TclObject[] objv14 = TJC.grabObjv(interp, 1);
                    TclObject tmp15;
                    try {
                        // Arg 2 variable: $value_buffer
                        tmp15 = getVarScalar(interp, "value_buffer", compiledLocals, 8);
                        tmp15.preserve();
                        objv14[0] = tmp15;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv14, compiledLocals, 4);
                    } finally {
                        TJC.releaseObjvElems(interp, objv14, 1);
                    }
                } // End Invoke: append
                { // Invoke: set value $value_symbol
                    TclObject tmp16;
                    tmp16 = getVarScalar(interp, "value_symbol", compiledLocals, 7);
                    setVarScalar(interp, "value", tmp16, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv17 = TJC.grabObjv(interp, 1);
            TclObject tmp18;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv19 = TJC.grabObjv(interp, 2);
                    TclObject tmp20;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv19[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp21 = new StringBuffer(64);
                        sbtmp21.append("TclList.append(interp, ");
                        tmp20 = getVarScalar(interp, "listsymbol", compiledLocals, 2);
                        sbtmp21.append(tmp20.toString());
                        sbtmp21.append(", ");
                        tmp20 = getVarScalar(interp, "value", compiledLocals, 9);
                        sbtmp21.append(tmp20.toString());
                        sbtmp21.append(")");
                        tmp20 = TclString.newInstance(sbtmp21);
                        tmp20.preserve();
                        objv19[1] = tmp20;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv19, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp20 = objv19[1];
                        if ( tmp20 != null ) {
                            tmp20.release();
                        }
                        TJC.releaseObjv(interp, objv19, 2);
                    }
                } // End Invoke: emitter_statement
                tmp18 = interp.getResult();
                tmp18.preserve();
                objv17[0] = tmp18;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv17, compiledLocals, 4);
            } finally {
                TJC.releaseObjvElems(interp, objv17, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp22 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp22);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_list_argument");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_emit_argument");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("false");
        TclBoolean.get(interp, const2);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_statement");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 2: {
                cmdName = "emitter_statement";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "i",
        "listsymbol",
        "valuesymbol",
        "buffer",
        "tuple",
        "value_type",
        "value_symbol",
        "value_buffer",
        "value"
    };
} // end class CompileprocEmitInlineCommandListArgumentCmd

