// TJC implementation of procedure compileproc_expr_evaluate_emit_ternary_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitTernaryOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 31, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "op_tuple");
        }
        setVarScalar(interp, "op_tuple", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set op_buffer ""
            setVarScalar(interp, "op_buffer", const0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set vtuple [...]
            TclObject tmp0;
            { // Invoke: lindex $op_tuple 1
                TclObject tmp1 = getVarScalar(interp, "op_tuple", compiledLocals, 0);
                tmp1 = TclList.index(interp, tmp1, 1);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "vtuple", tmp0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set op [...]
            TclObject tmp2;
            { // Invoke: lindex $vtuple 0
                TclObject tmp3 = getVarScalar(interp, "vtuple", compiledLocals, 4);
                tmp3 = TclList.index(interp, tmp3, 0);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "op", tmp2, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set values [...]
            TclObject tmp4;
            { // Invoke: lindex $vtuple 1
                TclObject tmp5 = getVarScalar(interp, "vtuple", compiledLocals, 4);
                tmp5 = TclList.index(interp, tmp5, 1);
                if ( tmp5 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp5);
                }
            } // End Invoke: lindex
            tmp4 = interp.getResult();
            setVarScalar(interp, "values", tmp4, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 3
            { // Invoke: llength $values
                TclObject tmp6 = getVarScalar(interp, "values", compiledLocals, 6);
                int tmp7 = TclList.getLength(interp, tmp6);
                interp.setResult(tmp7);
            } // End Invoke: llength
            TclObject tmp8 = interp.getResult();
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(3);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp9, tmp10);
            // End Binary operator: !=
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "..."
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    TclObject tmp13;
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp14 = new StringBuffer(64);
                        sbtmp14.append("values length should be 3, not ");
                        { // Invoke: llength $values
                            TclObject tmp15 = getVarScalar(interp, "values", compiledLocals, 6);
                            int tmp16 = TclList.getLength(interp, tmp15);
                            interp.setResult(tmp16);
                        } // End Invoke: llength
                        tmp13 = interp.getResult();
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append(", values_list was ");
                        sbtmp14.append("{");
                        tmp13 = getVarScalar(interp, "values", compiledLocals, 6);
                        sbtmp14.append(tmp13.toString());
                        sbtmp14.append("}");
                        tmp13 = TclString.newInstance(sbtmp14);
                        tmp13.preserve();
                        objv12[1] = tmp13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv12, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp13 = objv12[1];
                        if ( tmp13 != null ) {
                            tmp13.release();
                        }
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cond_tuple [...]
            TclObject tmp17;
            { // Invoke: lindex $values 0
                TclObject tmp18 = getVarScalar(interp, "values", compiledLocals, 6);
                tmp18 = TclList.index(interp, tmp18, 0);
                if ( tmp18 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp18);
                }
            } // End Invoke: lindex
            tmp17 = interp.getResult();
            setVarScalar(interp, "cond_tuple", tmp17, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set cond_eval_tuple [...]
            TclObject tmp19;
            { // Invoke: ... $cond_tuple
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                TclObject tmp21;
                try {
                    // Arg 0 constant: ...
                    objv20[0] = const2;
                    // Arg 1 variable: $cond_tuple
                    tmp21 = getVarScalar(interp, "cond_tuple", compiledLocals, 7);
                    tmp21.preserve();
                    objv20[1] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv20, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp21 = objv20[1];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: ...
            tmp19 = interp.getResult();
            setVarScalar(interp, "cond_eval_tuple", tmp19, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set cond_infostr [...]
            TclObject tmp22;
            { // Invoke: lindex $cond_eval_tuple 0
                TclObject tmp23 = getVarScalar(interp, "cond_eval_tuple", compiledLocals, 8);
                tmp23 = TclList.index(interp, tmp23, 0);
                if ( tmp23 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp23);
                }
            } // End Invoke: lindex
            tmp22 = interp.getResult();
            setVarScalar(interp, "cond_infostr", tmp22, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set ev1 [...]
            TclObject tmp24;
            { // Invoke: lindex $cond_eval_tuple 1
                TclObject tmp25 = getVarScalar(interp, "cond_eval_tuple", compiledLocals, 8);
                tmp25 = TclList.index(interp, tmp25, 1);
                if ( tmp25 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp25);
                }
            } // End Invoke: lindex
            tmp24 = interp.getResult();
            setVarScalar(interp, "ev1", tmp24, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set cond_ev_types [...]
            TclObject tmp26;
            { // Invoke: lindex $cond_eval_tuple 3 3
                TclObject[] objv27 = TJC.grabObjv(interp, 4);
                TclObject tmp28;
                try {
                    // Arg 0 constant: lindex
                    objv27[0] = const3;
                    // Arg 1 variable: $cond_eval_tuple
                    tmp28 = getVarScalar(interp, "cond_eval_tuple", compiledLocals, 8);
                    tmp28.preserve();
                    objv27[1] = tmp28;
                    // Arg 2 constant: 3
                    objv27[2] = const4;
                    // Arg 3 constant: 3
                    objv27[3] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv27, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp28 = objv27[1];
                    if ( tmp28 != null ) {
                        tmp28.release();
                    }
                    TJC.releaseObjv(interp, objv27, 4);
                }
            } // End Invoke: lindex
            tmp26 = interp.getResult();
            setVarScalar(interp, "cond_ev_types", tmp26, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: append op_buffer [...]
            TclObject[] objv29 = TJC.grabObjv(interp, 1);
            TclObject tmp30;
            try {
                // Arg 2 command: [...]
                { // Invoke: lindex $cond_eval_tuple 2
                    TclObject tmp31 = getVarScalar(interp, "cond_eval_tuple", compiledLocals, 8);
                    tmp31 = TclList.index(interp, tmp31, 2);
                    if ( tmp31 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp31);
                    }
                } // End Invoke: lindex
                tmp30 = interp.getResult();
                tmp30.preserve();
                objv29[0] = tmp30;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv29, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv29, 1);
            }
        } // End Invoke: append
        { // Invoke: set true_tuple [...]
            TclObject tmp32;
            { // Invoke: lindex $values 1
                TclObject tmp33 = getVarScalar(interp, "values", compiledLocals, 6);
                tmp33 = TclList.index(interp, tmp33, 1);
                if ( tmp33 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp33);
                }
            } // End Invoke: lindex
            tmp32 = interp.getResult();
            setVarScalar(interp, "true_tuple", tmp32, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set true_eval_tuple [...]
            TclObject tmp34;
            { // Invoke: ... $true_tuple
                TclObject[] objv35 = TJC.grabObjv(interp, 2);
                TclObject tmp36;
                try {
                    // Arg 0 constant: ...
                    objv35[0] = const2;
                    // Arg 1 variable: $true_tuple
                    tmp36 = getVarScalar(interp, "true_tuple", compiledLocals, 12);
                    tmp36.preserve();
                    objv35[1] = tmp36;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv35, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp36 = objv35[1];
                    if ( tmp36 != null ) {
                        tmp36.release();
                    }
                    TJC.releaseObjv(interp, objv35, 2);
                }
            } // End Invoke: ...
            tmp34 = interp.getResult();
            setVarScalar(interp, "true_eval_tuple", tmp34, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set true_infostr [...]
            TclObject tmp37;
            { // Invoke: lindex $true_eval_tuple 0
                TclObject tmp38 = getVarScalar(interp, "true_eval_tuple", compiledLocals, 13);
                tmp38 = TclList.index(interp, tmp38, 0);
                if ( tmp38 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp38);
                }
            } // End Invoke: lindex
            tmp37 = interp.getResult();
            setVarScalar(interp, "true_infostr", tmp37, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set ev2 [...]
            TclObject tmp39;
            { // Invoke: lindex $true_eval_tuple 1
                TclObject tmp40 = getVarScalar(interp, "true_eval_tuple", compiledLocals, 13);
                tmp40 = TclList.index(interp, tmp40, 1);
                if ( tmp40 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp40);
                }
            } // End Invoke: lindex
            tmp39 = interp.getResult();
            setVarScalar(interp, "ev2", tmp39, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set true_ev_types [...]
            TclObject tmp41;
            { // Invoke: lindex $true_eval_tuple 3 3
                TclObject[] objv42 = TJC.grabObjv(interp, 4);
                TclObject tmp43;
                try {
                    // Arg 0 constant: lindex
                    objv42[0] = const3;
                    // Arg 1 variable: $true_eval_tuple
                    tmp43 = getVarScalar(interp, "true_eval_tuple", compiledLocals, 13);
                    tmp43.preserve();
                    objv42[1] = tmp43;
                    // Arg 2 constant: 3
                    objv42[2] = const4;
                    // Arg 3 constant: 3
                    objv42[3] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv42, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp43 = objv42[1];
                    if ( tmp43 != null ) {
                        tmp43.release();
                    }
                    TJC.releaseObjv(interp, objv42, 4);
                }
            } // End Invoke: lindex
            tmp41 = interp.getResult();
            setVarScalar(interp, "true_ev_types", tmp41, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: append op_buffer [...] "if (" $ev1 ... [...]
            TclObject[] objv44 = TJC.grabObjv(interp, 5);
            TclObject tmp45;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv46 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv46[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv46, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv46, 1);
                    }
                } // End Invoke: emitter_indent
                tmp45 = interp.getResult();
                tmp45.preserve();
                objv44[0] = tmp45;
                // Arg 3 constant: "if ("
                objv44[1] = const6;
                // Arg 4 variable: $ev1
                tmp45 = getVarScalar(interp, "ev1", compiledLocals, 10);
                tmp45.preserve();
                objv44[2] = tmp45;
                // Arg 5 constant: ...
                objv44[3] = const7;
                // Arg 6 command: [...]
                { // Invoke: lindex $true_eval_tuple 2
                    TclObject tmp47 = getVarScalar(interp, "true_eval_tuple", compiledLocals, 13);
                    tmp47 = TclList.index(interp, tmp47, 2);
                    if ( tmp47 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp47);
                    }
                } // End Invoke: lindex
                tmp45 = interp.getResult();
                tmp45.preserve();
                objv44[4] = tmp45;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv44, compiledLocals, 3);
            } finally {
                tmp45 = objv44[0];
                if ( tmp45 != null ) {
                    tmp45.release();
                }
                tmp45 = objv44[2];
                if ( tmp45 != null ) {
                    tmp45.release();
                }
                tmp45 = objv44[4];
                if ( tmp45 != null ) {
                    tmp45.release();
                }
                TJC.releaseObjv(interp, objv44, 5);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            TclObject tmp48 = getVarArray(interp, "_compileproc", "options,expr_value_stack", compiledLocals, 1);
            ExprValue tmp49 = evs0;
            TJC.exprInitValue(interp, tmp49, tmp48);
            boolean tmp50 = tmp49.getBooleanValue(interp);
            if ( tmp50 ) {
                { // Invoke: append op_buffer [...] $ev1 ".setValue(" $ev2 ")" ... [...]
                    TclObject[] objv51 = TJC.grabObjv(interp, 7);
                    TclObject tmp52;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv53 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv53[0] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv53, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv53, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp52 = interp.getResult();
                        tmp52.preserve();
                        objv51[0] = tmp52;
                        // Arg 3 variable: $ev1
                        tmp52 = getVarScalar(interp, "ev1", compiledLocals, 10);
                        tmp52.preserve();
                        objv51[1] = tmp52;
                        // Arg 4 constant: ".setValue("
                        objv51[2] = const8;
                        // Arg 5 variable: $ev2
                        tmp52 = getVarScalar(interp, "ev2", compiledLocals, 15);
                        tmp52.preserve();
                        objv51[3] = tmp52;
                        // Arg 6 constant: ")"
                        objv51[4] = const9;
                        // Arg 7 constant: ...
                        objv51[5] = const10;
                        // Arg 8 command: [...]
                        { // Invoke: ... $ev2
                            TclObject[] objv54 = TJC.grabObjv(interp, 2);
                            TclObject tmp55;
                            try {
                                // Arg 0 constant: ...
                                objv54[0] = const11;
                                // Arg 1 variable: $ev2
                                tmp55 = getVarScalar(interp, "ev2", compiledLocals, 15);
                                tmp55.preserve();
                                objv54[1] = tmp55;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv54, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp55 = objv54[1];
                                if ( tmp55 != null ) {
                                    tmp55.release();
                                }
                                TJC.releaseObjv(interp, objv54, 2);
                            }
                        } // End Invoke: ...
                        tmp52 = interp.getResult();
                        tmp52.preserve();
                        objv51[6] = tmp52;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv51, compiledLocals, 3);
                    } finally {
                        tmp52 = objv51[0];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        tmp52 = objv51[1];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        tmp52 = objv51[3];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        tmp52 = objv51[6];
                        if ( tmp52 != null ) {
                            tmp52.release();
                        }
                        TJC.releaseObjv(interp, objv51, 7);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append op_buffer [...] [...] $ev1 " = " $ev2 ...
                    TclObject[] objv56 = TJC.grabObjv(interp, 6);
                    TclObject tmp57;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $ev1
                            TclObject[] objv58 = TJC.grabObjv(interp, 2);
                            TclObject tmp59;
                            try {
                                // Arg 0 constant: ...
                                objv58[0] = const11;
                                // Arg 1 variable: $ev1
                                tmp59 = getVarScalar(interp, "ev1", compiledLocals, 10);
                                tmp59.preserve();
                                objv58[1] = tmp59;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv58, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp59 = objv58[1];
                                if ( tmp59 != null ) {
                                    tmp59.release();
                                }
                                TJC.releaseObjv(interp, objv58, 2);
                            }
                        } // End Invoke: ...
                        tmp57 = interp.getResult();
                        tmp57.preserve();
                        objv56[0] = tmp57;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv60 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv60[0] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv60, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv60, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp57 = interp.getResult();
                        tmp57.preserve();
                        objv56[1] = tmp57;
                        // Arg 4 variable: $ev1
                        tmp57 = getVarScalar(interp, "ev1", compiledLocals, 10);
                        tmp57.preserve();
                        objv56[2] = tmp57;
                        // Arg 5 constant: " = "
                        objv56[3] = const12;
                        // Arg 6 variable: $ev2
                        tmp57 = getVarScalar(interp, "ev2", compiledLocals, 15);
                        tmp57.preserve();
                        objv56[4] = tmp57;
                        // Arg 7 constant: ...
                        objv56[5] = const10;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv56, compiledLocals, 3);
                    } finally {
                        tmp57 = objv56[0];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[1];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[2];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        tmp57 = objv56[4];
                        if ( tmp57 != null ) {
                            tmp57.release();
                        }
                        TJC.releaseObjv(interp, objv56, 6);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append op_buffer [...] ...
            TclObject[] objv61 = TJC.grabObjv(interp, 2);
            TclObject tmp62;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv63 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv63[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv63, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv63, 1);
                    }
                } // End Invoke: emitter_indent
                tmp62 = interp.getResult();
                tmp62.preserve();
                objv61[0] = tmp62;
                // Arg 3 constant: ...
                objv61[1] = const13;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv61, compiledLocals, 3);
            } finally {
                tmp62 = objv61[0];
                if ( tmp62 != null ) {
                    tmp62.release();
                }
                TJC.releaseObjv(interp, objv61, 2);
            }
        } // End Invoke: append
        { // Invoke: set false_tuple [...]
            TclObject tmp64;
            { // Invoke: lindex $values 2
                TclObject tmp65 = getVarScalar(interp, "values", compiledLocals, 6);
                tmp65 = TclList.index(interp, tmp65, 2);
                if ( tmp65 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp65);
                }
            } // End Invoke: lindex
            tmp64 = interp.getResult();
            setVarScalar(interp, "false_tuple", tmp64, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: set false_eval_tuple [...]
            TclObject tmp66;
            { // Invoke: ... $false_tuple
                TclObject[] objv67 = TJC.grabObjv(interp, 2);
                TclObject tmp68;
                try {
                    // Arg 0 constant: ...
                    objv67[0] = const2;
                    // Arg 1 variable: $false_tuple
                    tmp68 = getVarScalar(interp, "false_tuple", compiledLocals, 17);
                    tmp68.preserve();
                    objv67[1] = tmp68;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv67, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp68 = objv67[1];
                    if ( tmp68 != null ) {
                        tmp68.release();
                    }
                    TJC.releaseObjv(interp, objv67, 2);
                }
            } // End Invoke: ...
            tmp66 = interp.getResult();
            setVarScalar(interp, "false_eval_tuple", tmp66, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set false_infostr [...]
            TclObject tmp69;
            { // Invoke: lindex $false_eval_tuple 0
                TclObject tmp70 = getVarScalar(interp, "false_eval_tuple", compiledLocals, 18);
                tmp70 = TclList.index(interp, tmp70, 0);
                if ( tmp70 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp70);
                }
            } // End Invoke: lindex
            tmp69 = interp.getResult();
            setVarScalar(interp, "false_infostr", tmp69, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set ev3 [...]
            TclObject tmp71;
            { // Invoke: lindex $false_eval_tuple 1
                TclObject tmp72 = getVarScalar(interp, "false_eval_tuple", compiledLocals, 18);
                tmp72 = TclList.index(interp, tmp72, 1);
                if ( tmp72 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp72);
                }
            } // End Invoke: lindex
            tmp71 = interp.getResult();
            setVarScalar(interp, "ev3", tmp71, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: set false_ev_types [...]
            TclObject tmp73;
            { // Invoke: lindex $false_eval_tuple 3 3
                TclObject[] objv74 = TJC.grabObjv(interp, 4);
                TclObject tmp75;
                try {
                    // Arg 0 constant: lindex
                    objv74[0] = const3;
                    // Arg 1 variable: $false_eval_tuple
                    tmp75 = getVarScalar(interp, "false_eval_tuple", compiledLocals, 18);
                    tmp75.preserve();
                    objv74[1] = tmp75;
                    // Arg 2 constant: 3
                    objv74[2] = const4;
                    // Arg 3 constant: 3
                    objv74[3] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv74, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp75 = objv74[1];
                    if ( tmp75 != null ) {
                        tmp75.release();
                    }
                    TJC.releaseObjv(interp, objv74, 4);
                }
            } // End Invoke: lindex
            tmp73 = interp.getResult();
            setVarScalar(interp, "false_ev_types", tmp73, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: append op_buffer [...]
            TclObject[] objv76 = TJC.grabObjv(interp, 1);
            TclObject tmp77;
            try {
                // Arg 2 command: [...]
                { // Invoke: lindex $false_eval_tuple 2
                    TclObject tmp78 = getVarScalar(interp, "false_eval_tuple", compiledLocals, 18);
                    tmp78 = TclList.index(interp, tmp78, 2);
                    if ( tmp78 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp78);
                    }
                } // End Invoke: lindex
                tmp77 = interp.getResult();
                tmp77.preserve();
                objv76[0] = tmp77;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv76, compiledLocals, 3);
            } finally {
                TJC.releaseObjvElems(interp, objv76, 1);
            }
        } // End Invoke: append
        { // Invoke: if ... ... else ...
            TclObject tmp79 = getVarArray(interp, "_compileproc", "options,expr_value_stack", compiledLocals, 1);
            ExprValue tmp80 = evs0;
            TJC.exprInitValue(interp, tmp80, tmp79);
            boolean tmp81 = tmp80.getBooleanValue(interp);
            if ( tmp81 ) {
                { // Invoke: append op_buffer [...] $ev1 ".setValue(" $ev3 ")" ... [...]
                    TclObject[] objv82 = TJC.grabObjv(interp, 7);
                    TclObject tmp83;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv84 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv84[0] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv84, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv84, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp83 = interp.getResult();
                        tmp83.preserve();
                        objv82[0] = tmp83;
                        // Arg 3 variable: $ev1
                        tmp83 = getVarScalar(interp, "ev1", compiledLocals, 10);
                        tmp83.preserve();
                        objv82[1] = tmp83;
                        // Arg 4 constant: ".setValue("
                        objv82[2] = const8;
                        // Arg 5 variable: $ev3
                        tmp83 = getVarScalar(interp, "ev3", compiledLocals, 20);
                        tmp83.preserve();
                        objv82[3] = tmp83;
                        // Arg 6 constant: ")"
                        objv82[4] = const9;
                        // Arg 7 constant: ...
                        objv82[5] = const10;
                        // Arg 8 command: [...]
                        { // Invoke: ... $ev3
                            TclObject[] objv85 = TJC.grabObjv(interp, 2);
                            TclObject tmp86;
                            try {
                                // Arg 0 constant: ...
                                objv85[0] = const11;
                                // Arg 1 variable: $ev3
                                tmp86 = getVarScalar(interp, "ev3", compiledLocals, 20);
                                tmp86.preserve();
                                objv85[1] = tmp86;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv85, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp86 = objv85[1];
                                if ( tmp86 != null ) {
                                    tmp86.release();
                                }
                                TJC.releaseObjv(interp, objv85, 2);
                            }
                        } // End Invoke: ...
                        tmp83 = interp.getResult();
                        tmp83.preserve();
                        objv82[6] = tmp83;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv82, compiledLocals, 3);
                    } finally {
                        tmp83 = objv82[0];
                        if ( tmp83 != null ) {
                            tmp83.release();
                        }
                        tmp83 = objv82[1];
                        if ( tmp83 != null ) {
                            tmp83.release();
                        }
                        tmp83 = objv82[3];
                        if ( tmp83 != null ) {
                            tmp83.release();
                        }
                        tmp83 = objv82[6];
                        if ( tmp83 != null ) {
                            tmp83.release();
                        }
                        TJC.releaseObjv(interp, objv82, 7);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: append op_buffer [...] [...] $ev1 " = " $ev3 ...
                    TclObject[] objv87 = TJC.grabObjv(interp, 6);
                    TclObject tmp88;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $ev1
                            TclObject[] objv89 = TJC.grabObjv(interp, 2);
                            TclObject tmp90;
                            try {
                                // Arg 0 constant: ...
                                objv89[0] = const11;
                                // Arg 1 variable: $ev1
                                tmp90 = getVarScalar(interp, "ev1", compiledLocals, 10);
                                tmp90.preserve();
                                objv89[1] = tmp90;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv89, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp90 = objv89[1];
                                if ( tmp90 != null ) {
                                    tmp90.release();
                                }
                                TJC.releaseObjv(interp, objv89, 2);
                            }
                        } // End Invoke: ...
                        tmp88 = interp.getResult();
                        tmp88.preserve();
                        objv87[0] = tmp88;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv91 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv91[0] = const5;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv91, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv91, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp88 = interp.getResult();
                        tmp88.preserve();
                        objv87[1] = tmp88;
                        // Arg 4 variable: $ev1
                        tmp88 = getVarScalar(interp, "ev1", compiledLocals, 10);
                        tmp88.preserve();
                        objv87[2] = tmp88;
                        // Arg 5 constant: " = "
                        objv87[3] = const12;
                        // Arg 6 variable: $ev3
                        tmp88 = getVarScalar(interp, "ev3", compiledLocals, 20);
                        tmp88.preserve();
                        objv87[4] = tmp88;
                        // Arg 7 constant: ...
                        objv87[5] = const10;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv87, compiledLocals, 3);
                    } finally {
                        tmp88 = objv87[0];
                        if ( tmp88 != null ) {
                            tmp88.release();
                        }
                        tmp88 = objv87[1];
                        if ( tmp88 != null ) {
                            tmp88.release();
                        }
                        tmp88 = objv87[2];
                        if ( tmp88 != null ) {
                            tmp88.release();
                        }
                        tmp88 = objv87[4];
                        if ( tmp88 != null ) {
                            tmp88.release();
                        }
                        TJC.releaseObjv(interp, objv87, 6);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append op_buffer [...] ...
            TclObject[] objv92 = TJC.grabObjv(interp, 2);
            TclObject tmp93;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv94 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv94[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv94, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv94, 1);
                    }
                } // End Invoke: emitter_indent
                tmp93 = interp.getResult();
                tmp93.preserve();
                objv92[0] = tmp93;
                // Arg 3 constant: ...
                objv92[1] = const14;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv92, compiledLocals, 3);
            } finally {
                tmp93 = objv92[0];
                if ( tmp93 != null ) {
                    tmp93.release();
                }
                TJC.releaseObjv(interp, objv92, 2);
            }
        } // End Invoke: append
        { // Invoke: append buffer [...] ... $cond_infostr " ? " $true_infostr " : " $false_infostr ... $op_buffer [...] ...
            TclObject[] objv95 = TJC.grabObjv(interp, 11);
            TclObject tmp96;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv97 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv97[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv97, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv97, 1);
                    }
                } // End Invoke: emitter_indent
                tmp96 = interp.getResult();
                tmp96.preserve();
                objv95[0] = tmp96;
                // Arg 3 constant: ...
                objv95[1] = const15;
                // Arg 4 variable: $cond_infostr
                tmp96 = getVarScalar(interp, "cond_infostr", compiledLocals, 9);
                tmp96.preserve();
                objv95[2] = tmp96;
                // Arg 5 constant: " ? "
                objv95[3] = const16;
                // Arg 6 variable: $true_infostr
                tmp96 = getVarScalar(interp, "true_infostr", compiledLocals, 14);
                tmp96.preserve();
                objv95[4] = tmp96;
                // Arg 7 constant: " : "
                objv95[5] = const17;
                // Arg 8 variable: $false_infostr
                tmp96 = getVarScalar(interp, "false_infostr", compiledLocals, 19);
                tmp96.preserve();
                objv95[6] = tmp96;
                // Arg 9 constant: ...
                objv95[7] = const18;
                // Arg 10 variable: $op_buffer
                tmp96 = getVarScalar(interp, "op_buffer", compiledLocals, 3);
                tmp96.preserve();
                objv95[8] = tmp96;
                // Arg 11 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv98 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv98[0] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv98, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv98, 1);
                    }
                } // End Invoke: emitter_indent
                tmp96 = interp.getResult();
                tmp96.preserve();
                objv95[9] = tmp96;
                // Arg 12 constant: ...
                objv95[10] = const19;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv95, compiledLocals, 2);
            } finally {
                objv95[1] = null;
                objv95[3] = null;
                objv95[5] = null;
                objv95[7] = null;
                objv95[10] = null;
                TJC.releaseObjvElems(interp, objv95, 11);
            }
        } // End Invoke: append
        { // Invoke: set true_size [...]
            TclObject tmp99;
            { // Invoke: llength $true_ev_types
                TclObject tmp100 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
                int tmp101 = TclList.getLength(interp, tmp100);
                interp.setResult(tmp101);
            } // End Invoke: llength
            tmp99 = interp.getResult();
            setVarScalar(interp, "true_size", tmp99, compiledLocals, 22);
        } // End Invoke: set
        { // Invoke: set false_size [...]
            TclObject tmp102;
            { // Invoke: llength $false_ev_types
                TclObject tmp103 = getVarScalar(interp, "false_ev_types", compiledLocals, 21);
                int tmp104 = TclList.getLength(interp, tmp103);
                interp.setResult(tmp104);
            } // End Invoke: llength
            tmp102 = interp.getResult();
            setVarScalar(interp, "false_size", tmp102, compiledLocals, 23);
        } // End Invoke: set
        { // Invoke: set true_is_int [...]
            TclObject tmp105;
            { // Invoke: expr ...
                // Binary operator: () && ()
                // Binary operator: $true_size == 1
                TclObject tmp106 = getVarScalar(interp, "true_size", compiledLocals, 22);
                ExprValue tmp107 = evs0;
                TJC.exprInitValue(interp, tmp107, tmp106);
                ExprValue tmp108 = evs1;
                tmp108.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp107, tmp108);
                // End Binary operator: ==
                if (tmp107.getBooleanValue(interp)) {
                // Binary operator: $true_ev_types == "int"
                TclObject tmp109 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
                boolean tmp110 = tmp109.toString().equals("int");
                ExprValue tmp111 = evs1;
                tmp111.setIntValue(tmp110);
                // End Binary operator: ==
                tmp107.setIntValue(tmp111.getBooleanValue(interp));
                } else {
                tmp107.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                interp.setResult( tmp107.getIntValue() != 0 );
            } // End Invoke: expr
            tmp105 = interp.getResult();
            setVarScalar(interp, "true_is_int", tmp105, compiledLocals, 24);
        } // End Invoke: set
        { // Invoke: set true_is_double [...]
            TclObject tmp112;
            { // Invoke: expr ...
                // Binary operator: () && ()
                // Binary operator: $true_size == 1
                TclObject tmp113 = getVarScalar(interp, "true_size", compiledLocals, 22);
                ExprValue tmp114 = evs0;
                TJC.exprInitValue(interp, tmp114, tmp113);
                ExprValue tmp115 = evs1;
                tmp115.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp114, tmp115);
                // End Binary operator: ==
                if (tmp114.getBooleanValue(interp)) {
                // Binary operator: $true_ev_types == "double"
                TclObject tmp116 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
                boolean tmp117 = tmp116.toString().equals("double");
                ExprValue tmp118 = evs1;
                tmp118.setIntValue(tmp117);
                // End Binary operator: ==
                tmp114.setIntValue(tmp118.getBooleanValue(interp));
                } else {
                tmp114.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                interp.setResult( tmp114.getIntValue() != 0 );
            } // End Invoke: expr
            tmp112 = interp.getResult();
            setVarScalar(interp, "true_is_double", tmp112, compiledLocals, 25);
        } // End Invoke: set
        { // Invoke: set true_is_int_double [...]
            TclObject tmp119;
            { // Invoke: expr ...
                // Binary operator: $true_ev_types == "int double"
                TclObject tmp120 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
                boolean tmp121 = tmp120.toString().equals("int double");
                ExprValue tmp122 = evs0;
                tmp122.setIntValue(tmp121);
                // End Binary operator: ==
                interp.setResult( tmp122.getIntValue() != 0 );
            } // End Invoke: expr
            tmp119 = interp.getResult();
            setVarScalar(interp, "true_is_int_double", tmp119, compiledLocals, 26);
        } // End Invoke: set
        { // Invoke: set false_is_int [...]
            TclObject tmp123;
            { // Invoke: expr ...
                // Binary operator: () && ()
                // Binary operator: $false_size == 1
                TclObject tmp124 = getVarScalar(interp, "false_size", compiledLocals, 23);
                ExprValue tmp125 = evs0;
                TJC.exprInitValue(interp, tmp125, tmp124);
                ExprValue tmp126 = evs1;
                tmp126.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp125, tmp126);
                // End Binary operator: ==
                if (tmp125.getBooleanValue(interp)) {
                // Binary operator: $false_ev_types == "int"
                TclObject tmp127 = getVarScalar(interp, "false_ev_types", compiledLocals, 21);
                boolean tmp128 = tmp127.toString().equals("int");
                ExprValue tmp129 = evs1;
                tmp129.setIntValue(tmp128);
                // End Binary operator: ==
                tmp125.setIntValue(tmp129.getBooleanValue(interp));
                } else {
                tmp125.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                interp.setResult( tmp125.getIntValue() != 0 );
            } // End Invoke: expr
            tmp123 = interp.getResult();
            setVarScalar(interp, "false_is_int", tmp123, compiledLocals, 27);
        } // End Invoke: set
        { // Invoke: set false_is_double [...]
            TclObject tmp130;
            { // Invoke: expr ...
                // Binary operator: () && ()
                // Binary operator: $false_size == 1
                TclObject tmp131 = getVarScalar(interp, "false_size", compiledLocals, 23);
                ExprValue tmp132 = evs0;
                TJC.exprInitValue(interp, tmp132, tmp131);
                ExprValue tmp133 = evs1;
                tmp133.setIntValue(1);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp132, tmp133);
                // End Binary operator: ==
                if (tmp132.getBooleanValue(interp)) {
                // Binary operator: $false_ev_types == "double"
                TclObject tmp134 = getVarScalar(interp, "false_ev_types", compiledLocals, 21);
                boolean tmp135 = tmp134.toString().equals("double");
                ExprValue tmp136 = evs1;
                tmp136.setIntValue(tmp135);
                // End Binary operator: ==
                tmp132.setIntValue(tmp136.getBooleanValue(interp));
                } else {
                tmp132.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                interp.setResult( tmp132.getIntValue() != 0 );
            } // End Invoke: expr
            tmp130 = interp.getResult();
            setVarScalar(interp, "false_is_double", tmp130, compiledLocals, 28);
        } // End Invoke: set
        { // Invoke: set false_is_int_double [...]
            TclObject tmp137;
            { // Invoke: expr ...
                // Binary operator: $false_ev_types == "int double"
                TclObject tmp138 = getVarScalar(interp, "false_ev_types", compiledLocals, 21);
                boolean tmp139 = tmp138.toString().equals("int double");
                ExprValue tmp140 = evs0;
                tmp140.setIntValue(tmp139);
                // End Binary operator: ==
                interp.setResult( tmp140.getIntValue() != 0 );
            } // End Invoke: expr
            tmp137 = interp.getResult();
            setVarScalar(interp, "false_is_int_double", tmp137, compiledLocals, 29);
        } // End Invoke: set
        { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
            // Binary operator: () && ()
            // Binary operator: () && ()
            // Binary operator: $true_size == 1
            TclObject tmp141 = getVarScalar(interp, "true_size", compiledLocals, 22);
            ExprValue tmp142 = evs0;
            TJC.exprInitValue(interp, tmp142, tmp141);
            ExprValue tmp143 = evs1;
            tmp143.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp142, tmp143);
            // End Binary operator: ==
            if (tmp142.getBooleanValue(interp)) {
            // Binary operator: $false_size == 1
            TclObject tmp144 = getVarScalar(interp, "false_size", compiledLocals, 23);
            ExprValue tmp145 = evs1;
            TJC.exprInitValue(interp, tmp145, tmp144);
            ExprValue tmp146 = evs2;
            tmp146.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp145, tmp146);
            // End Binary operator: ==
            tmp142.setIntValue(tmp145.getBooleanValue(interp));
            } else {
            tmp142.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp142.getBooleanValue(interp)) {
            // Binary operator: $true_ev_types eq $false_ev_types
            TclObject tmp147 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
            String tmp148 = tmp147.toString();
            TclObject tmp149 = getVarScalar(interp, "false_ev_types", compiledLocals, 21);
            String tmp150 = tmp149.toString();
            boolean tmp151 = tmp148.equals(tmp150);
            ExprValue tmp152 = evs1;
            tmp152.setIntValue(tmp151);
            // End Binary operator: eq
            tmp142.setIntValue(tmp152.getBooleanValue(interp));
            } else {
            tmp142.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp153 = ( tmp142.getIntValue() != 0 );
            if ( tmp153 ) {
                { // Invoke: set ev_types $true_ev_types
                    TclObject tmp154;
                    tmp154 = getVarScalar(interp, "true_ev_types", compiledLocals, 16);
                    setVarScalar(interp, "ev_types", tmp154, compiledLocals, 30);
                } // End Invoke: set
            } else {
                // Binary operator: () || ()
                // Binary operator: $true_is_int && $false_is_double
                TclObject tmp155 = getVarScalar(interp, "true_is_int", compiledLocals, 24);
                ExprValue tmp156 = evs0;
                TJC.exprInitValue(interp, tmp156, tmp155);
                if (tmp156.getBooleanValue(interp)) {
                TclObject tmp157 = getVarScalar(interp, "false_is_double", compiledLocals, 28);
                ExprValue tmp158 = evs1;
                TJC.exprInitValue(interp, tmp158, tmp157);
                tmp156.setIntValue(tmp158.getBooleanValue(interp));
                } else {
                tmp156.setIntValue(0);
                } // End if: $true_is_int
                // End Binary operator: &&
                if (!tmp156.getBooleanValue(interp)) {
                // Binary operator: $true_is_double && $false_is_int
                TclObject tmp159 = getVarScalar(interp, "true_is_double", compiledLocals, 25);
                ExprValue tmp160 = evs1;
                TJC.exprInitValue(interp, tmp160, tmp159);
                if (tmp160.getBooleanValue(interp)) {
                TclObject tmp161 = getVarScalar(interp, "false_is_int", compiledLocals, 27);
                ExprValue tmp162 = evs2;
                TJC.exprInitValue(interp, tmp162, tmp161);
                tmp160.setIntValue(tmp162.getBooleanValue(interp));
                } else {
                tmp160.setIntValue(0);
                } // End if: $true_is_double
                // End Binary operator: &&
                tmp156.setIntValue(tmp160.getBooleanValue(interp));
                } else {
                tmp156.setIntValue(1);
                } // End if: !()
                // End Binary operator: ||
                boolean tmp163 = ( tmp156.getIntValue() != 0 );
                if ( tmp163 ) {
                    { // Invoke: set ev_types {int double}
                        setVarScalar(interp, "ev_types", const20, compiledLocals, 30);
                    } // End Invoke: set
                } else {
                    // Binary operator: () || ()
                    // Binary operator: () || ()
                    // Binary operator: $true_is_int_double && ()
                    TclObject tmp164 = getVarScalar(interp, "true_is_int_double", compiledLocals, 26);
                    ExprValue tmp165 = evs0;
                    TJC.exprInitValue(interp, tmp165, tmp164);
                    if (tmp165.getBooleanValue(interp)) {
                    // Binary operator: $false_is_int || $false_is_double
                    TclObject tmp166 = getVarScalar(interp, "false_is_int", compiledLocals, 27);
                    ExprValue tmp167 = evs1;
                    TJC.exprInitValue(interp, tmp167, tmp166);
                    if (!tmp167.getBooleanValue(interp)) {
                    TclObject tmp168 = getVarScalar(interp, "false_is_double", compiledLocals, 28);
                    ExprValue tmp169 = evs2;
                    TJC.exprInitValue(interp, tmp169, tmp168);
                    tmp167.setIntValue(tmp169.getBooleanValue(interp));
                    } else {
                    tmp167.setIntValue(1);
                    } // End if: !$false_is_int
                    // End Binary operator: ||
                    tmp165.setIntValue(tmp167.getBooleanValue(interp));
                    } else {
                    tmp165.setIntValue(0);
                    } // End if: $true_is_int_double
                    // End Binary operator: &&
                    if (!tmp165.getBooleanValue(interp)) {
                    // Binary operator: $false_is_int_double && ()
                    TclObject tmp170 = getVarScalar(interp, "false_is_int_double", compiledLocals, 29);
                    ExprValue tmp171 = evs1;
                    TJC.exprInitValue(interp, tmp171, tmp170);
                    if (tmp171.getBooleanValue(interp)) {
                    // Binary operator: $true_is_int || $true_is_double
                    TclObject tmp172 = getVarScalar(interp, "true_is_int", compiledLocals, 24);
                    ExprValue tmp173 = evs2;
                    TJC.exprInitValue(interp, tmp173, tmp172);
                    if (!tmp173.getBooleanValue(interp)) {
                    TclObject tmp174 = getVarScalar(interp, "true_is_double", compiledLocals, 25);
                    ExprValue tmp175 = evs3;
                    TJC.exprInitValue(interp, tmp175, tmp174);
                    tmp173.setIntValue(tmp175.getBooleanValue(interp));
                    } else {
                    tmp173.setIntValue(1);
                    } // End if: !$true_is_int
                    // End Binary operator: ||
                    tmp171.setIntValue(tmp173.getBooleanValue(interp));
                    } else {
                    tmp171.setIntValue(0);
                    } // End if: $false_is_int_double
                    // End Binary operator: &&
                    tmp165.setIntValue(tmp171.getBooleanValue(interp));
                    } else {
                    tmp165.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    if (!tmp165.getBooleanValue(interp)) {
                    // Binary operator: $true_is_int_double && $false_is_int_double
                    TclObject tmp176 = getVarScalar(interp, "true_is_int_double", compiledLocals, 26);
                    ExprValue tmp177 = evs1;
                    TJC.exprInitValue(interp, tmp177, tmp176);
                    if (tmp177.getBooleanValue(interp)) {
                    TclObject tmp178 = getVarScalar(interp, "false_is_int_double", compiledLocals, 29);
                    ExprValue tmp179 = evs2;
                    TJC.exprInitValue(interp, tmp179, tmp178);
                    tmp177.setIntValue(tmp179.getBooleanValue(interp));
                    } else {
                    tmp177.setIntValue(0);
                    } // End if: $true_is_int_double
                    // End Binary operator: &&
                    tmp165.setIntValue(tmp177.getBooleanValue(interp));
                    } else {
                    tmp165.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp180 = ( tmp165.getIntValue() != 0 );
                    if ( tmp180 ) {
                        { // Invoke: set ev_types {int double}
                            setVarScalar(interp, "ev_types", const20, compiledLocals, 30);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set ev_types {}
                            setVarScalar(interp, "ev_types", const0, compiledLocals, 30);
                        } // End Invoke: set
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $ev1 $buffer $ev_types
                TclObject tmp181 = TclList.newInstance();
                TclObject tmp182;
                try {
                    tmp182 = getVarScalar(interp, "ev1", compiledLocals, 10);
                    TclList.append(interp, tmp181, tmp182);
                    tmp182 = getVarScalar(interp, "buffer", compiledLocals, 2);
                    TclList.append(interp, tmp181, tmp182);
                    tmp182 = getVarScalar(interp, "ev_types", compiledLocals, 30);
                    TclList.append(interp, tmp181, tmp182);
                } catch (TclException ex) {
                    tmp181.release();
                    throw ex;
                }
                interp.setResult(tmp181);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_ternary_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("lindex");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(3);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_indent");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("if (");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(".getBooleanValue(interp)) {\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(".setValue(");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(")");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance(";\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance(" = ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("} else {\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("}\n");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("// Ternary operator: ");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(" ? ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(" : ");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("\n");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("// End Ternary operator: ?\n");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("int double");
        const20.preserve(); const20.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op_tuple",
        "_compileproc",
        "buffer",
        "op_buffer",
        "vtuple",
        "op",
        "values",
        "cond_tuple",
        "cond_eval_tuple",
        "cond_infostr",
        "ev1",
        "cond_ev_types",
        "true_tuple",
        "true_eval_tuple",
        "true_infostr",
        "ev2",
        "true_ev_types",
        "false_tuple",
        "false_eval_tuple",
        "false_infostr",
        "ev3",
        "false_ev_types",
        "true_size",
        "false_size",
        "true_is_int",
        "true_is_double",
        "true_is_int_double",
        "false_is_int",
        "false_is_double",
        "false_is_int_double",
        "ev_types"
    };
} // end class CompileprocExprEvaluateEmitTernaryOperatorCmd

