// TJC implementation of procedure compileproc_init
package tjc;
import tcl.lang.*;

public class CompileprocInitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _compileproc _compileproc_ckeys ...
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 0);
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 1);
            TJC.makeGlobalLinkVar(interp, "_compileproc_key_info", "_compileproc_key_info", 2);
        } // End Invoke: global
        { // Invoke: global ... ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_command_cache", "_compileproc_command_cache", 3);
            TJC.makeGlobalLinkVar(interp, "_compileproc_variable_cache", "_compileproc_variable_cache", 4);
        } // End Invoke: global
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_expr_value_stack", "_compileproc_expr_value_stack", 5);
        } // End Invoke: global
        { // Invoke: if ... ...
            { // Invoke: info exists _compileproc
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: _compileproc
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            boolean tmp3 = tmp2.getBooleanValue(interp);
            if ( tmp3 ) {
                { // Invoke: unset _compileproc
                    TclObject[] objv4 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv4[0] = const3;
                        // Arg 1 constant: _compileproc
                        objv4[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv4, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv4, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists _compileproc_ckeys
                TclObject[] objv5 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv5[0] = const0;
                    // Arg 1 constant: exists
                    objv5[1] = const1;
                    // Arg 2 constant: _compileproc_ckeys
                    objv5[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv5, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv5, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            TJC.exprInitValue(interp, tmp7, tmp6);
            boolean tmp8 = tmp7.getBooleanValue(interp);
            if ( tmp8 ) {
                { // Invoke: unset _compileproc_ckeys
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv9[0] = const3;
                        // Arg 1 constant: _compileproc_ckeys
                        objv9[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv9, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv10 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv10[0] = const0;
                    // Arg 1 constant: exists
                    objv10[1] = const1;
                    // Arg 2 constant: ...
                    objv10[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv10, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv10, 3);
                }
            } // End Invoke: info
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            TJC.exprInitValue(interp, tmp12, tmp11);
            boolean tmp13 = tmp12.getBooleanValue(interp);
            if ( tmp13 ) {
                { // Invoke: unset ...
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv14[0] = const3;
                        // Arg 1 constant: ...
                        objv14[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv14, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv15[0] = const0;
                    // Arg 1 constant: exists
                    objv15[1] = const1;
                    // Arg 2 constant: ...
                    objv15[2] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv15, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: info
            TclObject tmp16 = interp.getResult();
            ExprValue tmp17 = evs0;
            TJC.exprInitValue(interp, tmp17, tmp16);
            boolean tmp18 = tmp17.getBooleanValue(interp);
            if ( tmp18 ) {
                { // Invoke: unset ...
                    TclObject[] objv19 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv19[0] = const3;
                        // Arg 1 constant: ...
                        objv19[1] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv19, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv19, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv20 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv20[0] = const0;
                    // Arg 1 constant: exists
                    objv20[1] = const1;
                    // Arg 2 constant: ...
                    objv20[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv20, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv20, 3);
                }
            } // End Invoke: info
            TclObject tmp21 = interp.getResult();
            ExprValue tmp22 = evs0;
            TJC.exprInitValue(interp, tmp22, tmp21);
            boolean tmp23 = tmp22.getBooleanValue(interp);
            if ( tmp23 ) {
                { // Invoke: unset ...
                    TclObject[] objv24 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv24[0] = const3;
                        // Arg 1 constant: ...
                        objv24[1] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv24, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv24, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv25 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv25[0] = const0;
                    // Arg 1 constant: exists
                    objv25[1] = const1;
                    // Arg 2 constant: ...
                    objv25[2] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv25, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv25, 3);
                }
            } // End Invoke: info
            TclObject tmp26 = interp.getResult();
            ExprValue tmp27 = evs0;
            TJC.exprInitValue(interp, tmp27, tmp26);
            boolean tmp28 = tmp27.getBooleanValue(interp);
            if ( tmp28 ) {
                { // Invoke: unset ...
                    TclObject[] objv29 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv29[0] = const3;
                        // Arg 1 constant: ...
                        objv29[1] = const8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv29, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: ...
            TclObject[] objv30 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv30[0] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv30, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv30, 1);
            }
        } // End Invoke: ...
        { // Invoke: descend_init
            TclObject[] objv31 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: descend_init
                objv31[0] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv31, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv31, 1);
            }
        } // End Invoke: descend_init
        { // Invoke: ...
            TclObject[] objv32 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv32[0] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv32, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv32, 1);
            }
        } // End Invoke: ...
        { // Invoke: emitter_indent_level zero
            TclObject[] objv33 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv33[0] = const12;
                // Arg 1 constant: zero
                objv33[1] = const13;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv33, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                TJC.releaseObjv(interp, objv33, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "var_scan_key", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "var_scan_results", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "word_scan_key", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "word_scan_results", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "expr_eval_key", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "expr_eval_buffer", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "expr_eval_expressions", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "options,inline_containers", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,inline_controls", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {}
            setVarArray(interp, "_compileproc", "options,controls_stack", const14, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: ... proc 0 0 1
            TclObject[] objv34 = TJC.grabObjv(interp, 5);
            try {
                // Arg 0 constant: ...
                objv34[0] = const16;
                // Arg 1 constant: proc
                objv34[1] = const17;
                // Arg 2 constant: 0
                objv34[2] = const15;
                // Arg 3 constant: 0
                objv34[3] = const15;
                // Arg 4 constant: 1
                objv34[4] = const18;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv34, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv34, 5);
            }
        } // End Invoke: ...
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,cache_commands", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,skip_constant_increment", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,cache_variables", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,inline_commands", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,omit_results", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,expr_inline_operators", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,expr_value_stack", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,expr_value_stack_null", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc", "options,expr_inline_set_result", const15, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc_key_info", "cmd_needs_init", const15, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarArray(interp, "_compileproc_key_info", "constants_found", const15, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set ... 0
            TclObject tmp35;
            tmp35 = setVarArray(interp, "_compileproc_key_info", "generated", const15, compiledLocals, 2);
            interp.setResult(tmp35);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_init");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("unset");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("_compileproc_ckeys");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("_compileproc_key_info");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("_compileproc_command_cache");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_compileproc_variable_cache");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("_compileproc_expr_value_stack");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_tmpvar_reset");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_init");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_constant_cache_init");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("emitter_indent_level");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("zero");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("");
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(0);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("compileproc_push_controls_context");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("proc");
        const17.preserve(); const17.preserve();
        const18 = TclInteger.newInstance(1);
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "unset";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_reset";
                break;
            }
            case 4: {
                cmdName = "descend_init";
                break;
            }
            case 5: {
                cmdName = "compileproc_constant_cache_init";
                break;
            }
            case 6: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 7: {
                cmdName = "compileproc_push_controls_context";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc",
        "_compileproc_ckeys",
        "_compileproc_key_info",
        "_compileproc_command_cache",
        "_compileproc_variable_cache",
        "_compileproc_expr_value_stack"
    };
} // end class CompileprocInitCmd

