// TJC implementation of procedure compileproc_set_variable
package tjc;
import tcl.lang.*;

public class CompileprocSetVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname varname_is_string value value_is_string");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "varname_is_string", objv[3], compiledLocals, 2);
        setVarScalar(interp, "value", objv[4], compiledLocals, 3);
        setVarScalar(interp, "value_is_string", objv[5], compiledLocals, 4);
        { // Invoke: if {$value_is_string} ...
            TclObject tmp0 = getVarScalar(interp, "value_is_string", compiledLocals, 4);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set value [...]
                    TclObject tmp2;
                    { // Invoke: ... $value
                        TclObject[] objv3 = TJC.grabObjv(interp, 2);
                        TclObject tmp4;
                        try {
                            // Arg 0 constant: ...
                            objv3[0] = const0;
                            // Arg 1 variable: $value
                            tmp4 = getVarScalar(interp, "value", compiledLocals, 3);
                            tmp4.preserve();
                            objv3[1] = tmp4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp4 = objv3[1];
                            if ( tmp4 != null ) {
                                tmp4.release();
                            }
                            TJC.releaseObjv(interp, objv3, 2);
                        }
                    } // End Invoke: ...
                    tmp2 = interp.getResult();
                    setVarScalar(interp, "value", tmp2, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$varname_is_string} ... else ...
            TclObject tmp5 = getVarScalar(interp, "varname_is_string", compiledLocals, 2);
            boolean tmp6 = TJC.getBoolean(interp, tmp5);
            if ( tmp6 ) {
                { // Invoke: set vinfo [...]
                    TclObject tmp7;
                    { // Invoke: ... $varname
                        TclObject[] objv8 = TJC.grabObjv(interp, 2);
                        TclObject tmp9;
                        try {
                            // Arg 0 constant: ...
                            objv8[0] = const1;
                            // Arg 1 variable: $varname
                            tmp9 = getVarScalar(interp, "varname", compiledLocals, 1);
                            tmp9.preserve();
                            objv8[1] = tmp9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv8, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp9 = objv8[1];
                            if ( tmp9 != null ) {
                                tmp9.release();
                            }
                            TJC.releaseObjv(interp, objv8, 2);
                        }
                    } // End Invoke: ...
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "vinfo", tmp7, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: [...] == "array"
                    { // Invoke: lindex $vinfo 0
                        TclObject tmp10 = getVarScalar(interp, "vinfo", compiledLocals, 5);
                        tmp10 = TclList.index(interp, tmp10, 0);
                        if ( tmp10 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp10);
                        }
                    } // End Invoke: lindex
                    TclObject tmp11 = interp.getResult();
                    boolean tmp12 = tmp11.toString().equals("array");
                    ExprValue tmp13 = evs0;
                    tmp13.setIntValue(tmp12);
                    // End Binary operator: ==
                    boolean tmp14 = ( tmp13.getIntValue() != 0 );
                    if ( tmp14 ) {
                        { // Invoke: set p1 [...]
                            TclObject tmp15;
                            { // Invoke: lindex $vinfo 1
                                TclObject tmp16 = getVarScalar(interp, "vinfo", compiledLocals, 5);
                                tmp16 = TclList.index(interp, tmp16, 1);
                                if ( tmp16 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp16);
                                }
                            } // End Invoke: lindex
                            tmp15 = interp.getResult();
                            setVarScalar(interp, "p1", tmp15, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: set p2 [...]
                            TclObject tmp17;
                            { // Invoke: lindex $vinfo 2
                                TclObject tmp18 = getVarScalar(interp, "vinfo", compiledLocals, 5);
                                tmp18 = TclList.index(interp, tmp18, 2);
                                if ( tmp18 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp18);
                                }
                            } // End Invoke: lindex
                            tmp17 = interp.getResult();
                            setVarScalar(interp, "p2", tmp17, compiledLocals, 7);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: ... $tmpsymbol $p1 $p2 true $value
                                TclObject[] objv19 = TJC.grabObjv(interp, 6);
                                TclObject tmp20;
                                try {
                                    // Arg 0 constant: ...
                                    objv19[0] = const2;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp20 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                    tmp20.preserve();
                                    objv19[1] = tmp20;
                                    // Arg 2 variable: $p1
                                    tmp20 = getVarScalar(interp, "p1", compiledLocals, 6);
                                    tmp20.preserve();
                                    objv19[2] = tmp20;
                                    // Arg 3 variable: $p2
                                    tmp20 = getVarScalar(interp, "p2", compiledLocals, 7);
                                    tmp20.preserve();
                                    objv19[3] = tmp20;
                                    // Arg 4 constant: true
                                    objv19[4] = const3;
                                    // Arg 5 variable: $value
                                    tmp20 = getVarScalar(interp, "value", compiledLocals, 3);
                                    tmp20.preserve();
                                    objv19[5] = tmp20;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv19, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp20 = objv19[1];
                                    if ( tmp20 != null ) {
                                        tmp20.release();
                                    }
                                    tmp20 = objv19[2];
                                    if ( tmp20 != null ) {
                                        tmp20.release();
                                    }
                                    tmp20 = objv19[3];
                                    if ( tmp20 != null ) {
                                        tmp20.release();
                                    }
                                    tmp20 = objv19[5];
                                    if ( tmp20 != null ) {
                                        tmp20.release();
                                    }
                                    TJC.releaseObjv(interp, objv19, 6);
                                }
                            } // End Invoke: ...
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        // Binary operator: [...] == "scalar"
                        { // Invoke: lindex $vinfo 0
                            TclObject tmp21 = getVarScalar(interp, "vinfo", compiledLocals, 5);
                            tmp21 = TclList.index(interp, tmp21, 0);
                            if ( tmp21 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp21);
                            }
                        } // End Invoke: lindex
                        TclObject tmp22 = interp.getResult();
                        boolean tmp23 = tmp22.toString().equals("scalar");
                        ExprValue tmp24 = evs0;
                        tmp24.setIntValue(tmp23);
                        // End Binary operator: ==
                        boolean tmp25 = ( tmp24.getIntValue() != 0 );
                        if ( tmp25 ) {
                            { // Invoke: return [...]
                                { // Invoke: ... $tmpsymbol $varname $value
                                    TclObject[] objv26 = TJC.grabObjv(interp, 4);
                                    TclObject tmp27;
                                    try {
                                        // Arg 0 constant: ...
                                        objv26[0] = const4;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp27 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                                        tmp27.preserve();
                                        objv26[1] = tmp27;
                                        // Arg 2 variable: $varname
                                        tmp27 = getVarScalar(interp, "varname", compiledLocals, 1);
                                        tmp27.preserve();
                                        objv26[2] = tmp27;
                                        // Arg 3 variable: $value
                                        tmp27 = getVarScalar(interp, "value", compiledLocals, 3);
                                        tmp27.preserve();
                                        objv26[3] = tmp27;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv26, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp27 = objv26[1];
                                        if ( tmp27 != null ) {
                                            tmp27.release();
                                        }
                                        tmp27 = objv26[2];
                                        if ( tmp27 != null ) {
                                            tmp27.release();
                                        }
                                        tmp27 = objv26[3];
                                        if ( tmp27 != null ) {
                                            tmp27.release();
                                        }
                                        TJC.releaseObjv(interp, objv26, 4);
                                    }
                                } // End Invoke: ...
                                if ( true ) { return; }
                            } // End Invoke: return
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv28 = TJC.grabObjv(interp, 2);
                                TclObject tmp29;
                                try {
                                    // Arg 0 constant: error
                                    objv28[0] = const5;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp30 = new StringBuffer(64);
                                    sbtmp30.append("unexpected result ");
                                    sbtmp30.append("{");
                                    tmp29 = getVarScalar(interp, "vinfo", compiledLocals, 5);
                                    sbtmp30.append(tmp29.toString());
                                    sbtmp30.append("}");
                                    sbtmp30.append(" from descend_simple_variable");
                                    tmp29 = TclString.newInstance(sbtmp30);
                                    tmp29.preserve();
                                    objv28[1] = tmp29;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv28, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp29 = objv28[1];
                                    if ( tmp29 != null ) {
                                        tmp29.release();
                                    }
                                    TJC.releaseObjv(interp, objv28, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                } // End Invoke: if
            } else {
                { // Invoke: return [...]
                    { // Invoke: emitter_set_var $tmpsymbol $varname false null false $value 0
                        TclObject[] objv31 = TJC.grabObjv(interp, 8);
                        TclObject tmp32;
                        try {
                            // Arg 0 constant: emitter_set_var
                            objv31[0] = const6;
                            // Arg 1 variable: $tmpsymbol
                            tmp32 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            // Arg 2 variable: $varname
                            tmp32 = getVarScalar(interp, "varname", compiledLocals, 1);
                            tmp32.preserve();
                            objv31[2] = tmp32;
                            // Arg 3 constant: false
                            objv31[3] = const7;
                            // Arg 4 constant: null
                            objv31[4] = const8;
                            // Arg 5 constant: false
                            objv31[5] = const7;
                            // Arg 6 variable: $value
                            tmp32 = getVarScalar(interp, "value", compiledLocals, 3);
                            tmp32.preserve();
                            objv31[6] = tmp32;
                            // Arg 7 constant: 0
                            objv31[7] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv31, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp32 = objv31[1];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            tmp32 = objv31[2];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            tmp32 = objv31[6];
                            if ( tmp32 != null ) {
                                tmp32.release();
                            }
                            TJC.releaseObjv(interp, objv31, 8);
                        }
                    } // End Invoke: emitter_set_var
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_set_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_double_quote_tcl_string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_simple_variable");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_emit_array_variable_set");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("true");
        TclBoolean.get(interp, const3);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_emit_scalar_variable_set");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("error");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_set_var");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("false");
        TclBoolean.get(interp, const7);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("null");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(0);
        const9.preserve(); const9.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 2: {
                cmdName = "descend_simple_variable";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_array_variable_set";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_scalar_variable_set";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "emitter_set_var";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "varname_is_string",
        "value",
        "value_is_string",
        "vinfo",
        "p1",
        "p2"
    };
} // end class CompileprocSetVariableCmd

