// TJC implementation of procedure compileproc_variable_cache_names_array
package tjc;
import tcl.lang.*;

public class CompileprocVariableCacheNamesArrayCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_variable_cache", "_compileproc_variable_cache", 0);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: emitter_indent_level +1
            TclObject[] objv0 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv0[0] = const1;
                // Arg 1 constant: +1
                objv0[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv0, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv0, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv1 = TJC.grabObjv(interp, 2);
            TclObject tmp2;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv3 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv3[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv3, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 1);
                    }
                } // End Invoke: emitter_indent
                tmp2 = interp.getResult();
                tmp2.preserve();
                objv1[0] = tmp2;
                // Arg 3 constant: ...
                objv1[1] = const4;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv1, compiledLocals, 1);
            } finally {
                tmp2 = objv1[0];
                if ( tmp2 != null ) {
                    tmp2.release();
                }
                TJC.releaseObjv(interp, objv1, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv4 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv4[0] = const1;
                // Arg 1 constant: +1
                objv4[1] = const2;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv4, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv4, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: set max [...]
            TclObject tmp5;
            { // Invoke: llength $...
                TclObject tmp6 = getVarArray(interp, "_compileproc_variable_cache", "ordered_vars", compiledLocals, 0);
                int tmp7 = TclList.getLength(interp, tmp6);
                interp.setResult(tmp7);
            } // End Invoke: llength
            tmp5 = interp.getResult();
            setVarScalar(interp, "max", tmp5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $max} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const5, compiledLocals, 3);
            } // End Invoke: set
            for ( boolean skip13 = true ; true ; ) {
                if ( skip13 ) {
                    skip13 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 3);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $max
                TclObject tmp8 = getVarScalar(interp, "i", compiledLocals, 3);
                ExprValue tmp9 = evs0;
                TJC.exprInitValue(interp, tmp9, tmp8);
                TclObject tmp10 = getVarScalar(interp, "max", compiledLocals, 2);
                ExprValue tmp11 = evs1;
                TJC.exprInitValue(interp, tmp11, tmp10);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp9, tmp11);
                // End Binary operator: <
                boolean tmp12 = ( tmp9.getIntValue() != 0 );
                if ( ! tmp12 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set varname [...]
                    TclObject tmp14;
                    { // Invoke: lindex $... $i
                        TclObject tmp15 = null;
                        TclObject tmp16;
                        try {
                            tmp15 = getVarArray(interp, "_compileproc_variable_cache", "ordered_vars", compiledLocals, 0);
                            tmp15.preserve();
                            tmp16 = getVarScalar(interp, "i", compiledLocals, 3);
                            TJC.lindexNonconst(interp, tmp15, tmp16);
                        } finally {
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp14 = interp.getResult();
                    setVarScalar(interp, "varname", tmp14, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: append buffer [...] [...]
                    TclObject[] objv17 = TJC.grabObjv(interp, 2);
                    TclObject tmp18;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv19 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv19[0] = const3;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                    ? cmdcache2.cmd : null), objv19, 0);
                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                    updateCmdCache(interp, 2);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv19, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp18 = interp.getResult();
                        tmp18.preserve();
                        objv17[0] = tmp18;
                        // Arg 3 command: [...]
                        { // Invoke: ... $varname
                            TclObject[] objv20 = TJC.grabObjv(interp, 2);
                            TclObject tmp21;
                            try {
                                // Arg 0 constant: ...
                                objv20[0] = const6;
                                // Arg 1 variable: $varname
                                tmp21 = getVarScalar(interp, "varname", compiledLocals, 4);
                                tmp21.preserve();
                                objv20[1] = tmp21;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv20, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp21 = objv20[1];
                                if ( tmp21 != null ) {
                                    tmp21.release();
                                }
                                TJC.releaseObjv(interp, objv20, 2);
                            }
                        } // End Invoke: ...
                        tmp18 = interp.getResult();
                        tmp18.preserve();
                        objv17[1] = tmp18;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv17, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv17, 2);
                    }
                } // End Invoke: append
                { // Invoke: if {$i == ($max - 1)} ... else ...
                    // Binary operator: $i == ()
                    TclObject tmp22 = getVarScalar(interp, "i", compiledLocals, 3);
                    ExprValue tmp23 = evs0;
                    TJC.exprInitValue(interp, tmp23, tmp22);
                    // Binary operator: $max - 1
                    TclObject tmp24 = getVarScalar(interp, "max", compiledLocals, 2);
                    ExprValue tmp25 = evs1;
                    TJC.exprInitValue(interp, tmp25, tmp24);
                    ExprValue tmp26 = evs2;
                    tmp26.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp25, tmp26);
                    // End Binary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp23, tmp25);
                    // End Binary operator: ==
                    boolean tmp27 = ( tmp23.getIntValue() != 0 );
                    if ( tmp27 ) {
                        { // Invoke: append buffer ...
                            TclObject[] objv28 = TJC.grabObjv(interp, 1);
                            TclObject tmp29;
                            try {
                                // Arg 2 constant: ...
                                objv28[0] = const7;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv28, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv28, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer ...
                            TclObject[] objv30 = TJC.grabObjv(interp, 1);
                            TclObject tmp31;
                            try {
                                // Arg 2 constant: ...
                                objv30[0] = const8;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv30, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjv(interp, objv30, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: emitter_indent_level -1
            TclObject[] objv32 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv32[0] = const1;
                // Arg 1 constant: -1
                objv32[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv32, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv32, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv33 = TJC.grabObjv(interp, 2);
            TclObject tmp34;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv35 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv35[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv35, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv35, 1);
                    }
                } // End Invoke: emitter_indent
                tmp34 = interp.getResult();
                tmp34.preserve();
                objv33[0] = tmp34;
                // Arg 3 constant: ...
                objv33[1] = const10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv33, compiledLocals, 1);
            } finally {
                tmp34 = objv33[0];
                if ( tmp34 != null ) {
                    tmp34.release();
                }
                TJC.releaseObjv(interp, objv33, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv36 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv36[0] = const1;
                // Arg 1 constant: -1
                objv36[1] = const9;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv36, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv36, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: return $buffer
            TclObject tmp37 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp37);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_variable_cache_names_array");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent_level");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("+1");
        TclInteger.get(interp, const2);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_indent");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("String[] compiledLocalsNames = {\n");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(0);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_double_quote_tcl_string");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(",\n");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("};\n");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            case 3: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_compileproc_variable_cache",
        "buffer",
        "max",
        "i",
        "varname"
    };
} // end class CompileprocVariableCacheNamesArrayCmd

