// TJC implementation of procedure descend_commands
package tjc;
import tcl.lang.*;

public class DescendCommandsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "?key? ?type?");
        }
        setVarScalar(interp, "key", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        setVarScalar(interp, "type", 
            ((objv.length <= 2) ? const1 : objv[2]), compiledLocals, 1);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 2);
        } // End Invoke: global
        { // Invoke: if {$type == "nested"} ... elseif ... ... else ...
            // Binary operator: $type == "nested"
            TclObject tmp0 = getVarScalar(interp, "type", compiledLocals, 1);
            boolean tmp1 = tmp0.toString().equals("nested");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set tkey commands
                    setVarScalar(interp, "tkey", const2, compiledLocals, 3);
                } // End Invoke: set
            } else {
                // Binary operator: $type == "container"
                TclObject tmp4 = getVarScalar(interp, "type", compiledLocals, 1);
                boolean tmp5 = tmp4.toString().equals("container");
                ExprValue tmp6 = evs0;
                tmp6.setIntValue(tmp5);
                // End Binary operator: ==
                boolean tmp7 = ( tmp6.getIntValue() != 0 );
                if ( tmp7 ) {
                    { // Invoke: set tkey container_commands
                        setVarScalar(interp, "tkey", const3, compiledLocals, 3);
                    } // End Invoke: set
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv8 = TJC.grabObjv(interp, 2);
                        TclObject tmp9;
                        try {
                            // Arg 0 constant: error
                            objv8[0] = const4;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp10 = new StringBuffer(64);
                            sbtmp10.append("unnown type ");
                            sbtmp10.append("\"");
                            tmp9 = getVarScalar(interp, "type", compiledLocals, 1);
                            sbtmp10.append(tmp9.toString());
                            sbtmp10.append("\"");
                            tmp9 = TclString.newInstance(sbtmp10);
                            tmp9.preserve();
                            objv8[1] = tmp9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv8, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp9 = objv8[1];
                            if ( tmp9 != null ) {
                                tmp9.release();
                            }
                            TJC.releaseObjv(interp, objv8, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: if {$key == {}} ... else ...
            // Binary operator: $key == ""
            TclObject tmp11 = getVarScalar(interp, "key", compiledLocals, 0);
            ExprValue tmp12 = evs0;
            TJC.exprEqualsEmptyString(tmp12, tmp11, false);
            // End Binary operator: ==
            boolean tmp13 = ( tmp12.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: return $...
                    TclObject tmp14 = getVarArray(interp, "_descend", "commands,outermost", compiledLocals, 2);
                    interp.resetResult();
                    interp.setResult(tmp14);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return [...]
                    { // Invoke: descend_get_data $key $tkey
                        TclObject[] objv15 = TJC.grabObjv(interp, 3);
                        TclObject tmp16;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv15[0] = const5;
                            // Arg 1 variable: $key
                            tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp16.preserve();
                            objv15[1] = tmp16;
                            // Arg 2 variable: $tkey
                            tmp16 = getVarScalar(interp, "tkey", compiledLocals, 3);
                            tmp16.preserve();
                            objv15[2] = tmp16;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv15, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp16 = objv15[1];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            tmp16 = objv15[2];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            TJC.releaseObjv(interp, objv15, 3);
                        }
                    } // End Invoke: descend_get_data
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_commands");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("nested");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("commands");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("container_commands");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_get_data");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "type",
        "_descend",
        "tkey"
    };
} // end class DescendCommandsCmd

