// TJC implementation of procedure descend_container_after_validate
package tjc;
import tcl.lang.*;

public class DescendContainerAfterValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 13, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args < 2} ...
            // Binary operator: $num_args < 2
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp10, tmp11);
            // End Binary operator: <
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp13;
                    String tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp15.append(tmp13.toString());
                    sbtmp15.append(",usage");
                    tmp14 = sbtmp15.toString();
                    setVarArray(interp, "_descend", tmp14, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "after" $num_args "2 or more"
                        TclObject tmp16 = TclList.newInstance();
                        TclObject tmp17;
                        try {
                            TclList.append(interp, tmp16, const4);
                            TclList.append(interp, tmp16, const5);
                            tmp17 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp16, tmp17);
                            TclList.append(interp, tmp16, const6);
                        } catch (TclException ex) {
                            tmp16.release();
                            throw ex;
                        }
                        interp.setResult(tmp16);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set type "unknown"
            setVarScalar(interp, "type", const7, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set type_args {}
            setVarScalar(interp, "type_args", const8, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set cmd_indexes {}
            setVarScalar(interp, "cmd_indexes", const8, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp18;
            { // Invoke: lindex $tree 1
                TclObject tmp19 = getVarScalar(interp, "tree", compiledLocals, 3);
                tmp19 = TclList.index(interp, tmp19, 1);
                if ( tmp19 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp19);
                }
            } // End Invoke: lindex
            tmp18 = interp.getResult();
            setVarScalar(interp, "subtree", tmp18, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                TclObject tmp21;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv20[0] = const9;
                    // Arg 1 variable: $subtree
                    tmp21 = getVarScalar(interp, "subtree", compiledLocals, 8);
                    tmp21.preserve();
                    objv20[1] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv20, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp21 = objv20[1];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp22 = interp.getResult();
            ExprValue tmp23 = evs0;
            TJC.exprInitValue(interp, tmp23, tmp22);
            boolean tmp24 = tmp23.getBooleanValue(interp);
            if ( tmp24 ) {
                { // Invoke: set text [...]
                    TclObject tmp25;
                    { // Invoke: ... $script $subtree text
                        TclObject[] objv26 = TJC.grabObjv(interp, 4);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const10;
                            // Arg 1 variable: $script
                            tmp27 = getVarScalar(interp, "script", compiledLocals, 2);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            // Arg 2 variable: $subtree
                            tmp27 = getVarScalar(interp, "subtree", compiledLocals, 8);
                            tmp27.preserve();
                            objv26[2] = tmp27;
                            // Arg 3 constant: text
                            objv26[3] = const11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv26, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            tmp27 = objv26[2];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 4);
                        }
                    } // End Invoke: ...
                    tmp25 = interp.getResult();
                    setVarScalar(interp, "text", tmp25, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: switch -regexp -- $text {^[0-9]+$} ... {^idle$} ... {^cancel$} ... {^info$} ... default ...
                    TclObject tmp28 = getVarScalar(interp, "text", compiledLocals, 9);
                    String tmp29 = tmp28.toString();
                    int tmp30;
                    TclObject[] objv31 = TJC.grabObjv(interp, 10);
                    try {
                        TclObject tmp32;
                        // Pattern {^[0-9]+$}
                        tmp32 = const12;
                        tmp32.preserve();
                        objv31[0] = tmp32;
                        // Pattern {^idle$}
                        tmp32 = const13;
                        tmp32.preserve();
                        objv31[2] = tmp32;
                        // Pattern {^cancel$}
                        tmp32 = const14;
                        tmp32.preserve();
                        objv31[4] = tmp32;
                        // Pattern {^info$}
                        tmp32 = const15;
                        tmp32.preserve();
                        objv31[6] = tmp32;
                        // Pattern default
                        tmp32 = const16;
                        tmp32.preserve();
                        objv31[8] = tmp32;
                        tmp30 = TJC.invokeSwitch(interp, objv31, 0,
                            tmp29, TJC.SWITCH_MODE_REGEXP);
                    } finally {
                        TJC.releaseObjvElems(interp, objv31, 10);
                    }
                    interp.resetResult();
                    if ( tmp30 == -1 ) {
                        // No match
                    } else if ( tmp30 == 1 ) {
                        // Pattern {^[0-9]+$}
                        { // Invoke: if {$num_args == 2} ... else ...
                            // Binary operator: $num_args == 2
                            TclObject tmp33 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            ExprValue tmp34 = evs0;
                            TJC.exprInitValue(interp, tmp34, tmp33);
                            ExprValue tmp35 = evs1;
                            tmp35.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp34, tmp35);
                            // End Binary operator: ==
                            boolean tmp36 = ( tmp34.getIntValue() != 0 );
                            if ( tmp36 ) {
                                { // Invoke: set type "ms_sleep"
                                    setVarScalar(interp, "type", const17, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set type_args $text
                                    TclObject tmp37;
                                    tmp37 = getVarScalar(interp, "text", compiledLocals, 9);
                                    setVarScalar(interp, "type_args", tmp37, compiledLocals, 6);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set type "ms"
                                    setVarScalar(interp, "type", const18, compiledLocals, 5);
                                } // End Invoke: set
                                { // Invoke: set type_args $text
                                    TclObject tmp38;
                                    tmp38 = getVarScalar(interp, "text", compiledLocals, 9);
                                    setVarScalar(interp, "type_args", tmp38, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: for {set i 2} {$i < $num_args} {incr i} ...
                                    { // Invoke: set i 2
                                        setVarScalar(interp, "i", const19, compiledLocals, 10);
                                    } // End Invoke: set
                                    for ( boolean skip44 = true ; true ; ) {
                                        if ( skip44 ) {
                                            skip44 = false;
                                        } else {
                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: incr i
                                                interp.resetResult();
                                                incrVarScalar(interp, "i", 1, compiledLocals, 10);
                                            } // End Invoke: incr
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }

                                        // Binary operator: $i < $num_args
                                        TclObject tmp39 = getVarScalar(interp, "i", compiledLocals, 10);
                                        ExprValue tmp40 = evs0;
                                        TJC.exprInitValue(interp, tmp40, tmp39);
                                        TclObject tmp41 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                        ExprValue tmp42 = evs1;
                                        TJC.exprInitValue(interp, tmp42, tmp41);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp40, tmp42);
                                        // End Binary operator: <
                                        boolean tmp43 = ( tmp40.getIntValue() != 0 );
                                        if ( ! tmp43 ) { break; }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: lappend cmd_indexes $i
                                            TclObject[] objv45 = TJC.grabObjv(interp, 1);
                                            TclObject tmp46;
                                            try {
                                                // Arg 2 variable: $i
                                                tmp46 = getVarScalar(interp, "i", compiledLocals, 10);
                                                tmp46.preserve();
                                                objv45[0] = tmp46;
                                                interp.resetResult();
                                                lappendVarScalar(interp, "cmd_indexes", objv45, compiledLocals, 7);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv45, 1);
                                            }
                                        } // End Invoke: lappend
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } // End Invoke: for
                            }
                        } // End Invoke: if
                    } else if ( tmp30 == 3 ) {
                        // Pattern {^idle$}
                        { // Invoke: set type "idle"
                            setVarScalar(interp, "type", const20, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: if {$num_args == 2} ...
                            // Binary operator: $num_args == 2
                            TclObject tmp47 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            ExprValue tmp48 = evs0;
                            TJC.exprInitValue(interp, tmp48, tmp47);
                            ExprValue tmp49 = evs1;
                            tmp49.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp48, tmp49);
                            // End Binary operator: ==
                            boolean tmp50 = ( tmp48.getIntValue() != 0 );
                            if ( tmp50 ) {
                                { // Invoke: set _descend($key,usage) 1
                                    TclObject tmp51;
                                    String tmp52;
                                    StringBuffer sbtmp53 = new StringBuffer(64);
                                    tmp51 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp53.append(tmp51.toString());
                                    sbtmp53.append(",usage");
                                    tmp52 = sbtmp53.toString();
                                    setVarArray(interp, "_descend", tmp52, const3, compiledLocals, 1);
                                } // End Invoke: set
                                { // Invoke: return [...]
                                    { // Invoke: list numArgs "after" $num_args "3 or more"
                                        TclObject tmp54 = TclList.newInstance();
                                        TclObject tmp55;
                                        try {
                                            TclList.append(interp, tmp54, const4);
                                            TclList.append(interp, tmp54, const5);
                                            tmp55 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                            TclList.append(interp, tmp54, tmp55);
                                            TclList.append(interp, tmp54, const21);
                                        } catch (TclException ex) {
                                            tmp54.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp54);
                                    } // End Invoke: list
                                    if ( true ) { return; }
                                } // End Invoke: return
                            }
                        } // End Invoke: if
                        { // Invoke: for {set i 2} {$i < $num_args} {incr i} ...
                            { // Invoke: set i 2
                                setVarScalar(interp, "i", const19, compiledLocals, 10);
                            } // End Invoke: set
                            for ( boolean skip61 = true ; true ; ) {
                                if ( skip61 ) {
                                    skip61 = false;
                                } else {
                                    try {
                                    if ( false ) { throw (TclException) null; }
                                    { // Invoke: incr i
                                        interp.resetResult();
                                        incrVarScalar(interp, "i", 1, compiledLocals, 10);
                                    } // End Invoke: incr
                                    } catch (TclException ex) {
                                        int type = ex.getCompletionCode();
                                        if (type == TCL.BREAK) {
                                            break;
                                        } else {
                                            throw ex;
                                        }
                                    }
                                }

                                // Binary operator: $i < $num_args
                                TclObject tmp56 = getVarScalar(interp, "i", compiledLocals, 10);
                                ExprValue tmp57 = evs0;
                                TJC.exprInitValue(interp, tmp57, tmp56);
                                TclObject tmp58 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                ExprValue tmp59 = evs1;
                                TJC.exprInitValue(interp, tmp59, tmp58);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp57, tmp59);
                                // End Binary operator: <
                                boolean tmp60 = ( tmp57.getIntValue() != 0 );
                                if ( ! tmp60 ) { break; }

                                try {
                                if ( false ) { throw (TclException) null; }
                                { // Invoke: lappend cmd_indexes $i
                                    TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                    TclObject tmp63;
                                    try {
                                        // Arg 2 variable: $i
                                        tmp63 = getVarScalar(interp, "i", compiledLocals, 10);
                                        tmp63.preserve();
                                        objv62[0] = tmp63;
                                        interp.resetResult();
                                        lappendVarScalar(interp, "cmd_indexes", objv62, compiledLocals, 7);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv62, 1);
                                    }
                                } // End Invoke: lappend
                                } catch (TclException ex) {
                                    int type = ex.getCompletionCode();
                                    if (type == TCL.BREAK) {
                                        break;
                                    } else if (type == TCL.CONTINUE) {
                                        continue;
                                    } else {
                                        throw ex;
                                    }
                                }
                            }
                        } // End Invoke: for
                    } else if ( tmp30 == 5 ) {
                        // Pattern {^cancel$}
                        { // Invoke: set type $text
                            TclObject tmp64;
                            tmp64 = getVarScalar(interp, "text", compiledLocals, 9);
                            setVarScalar(interp, "type", tmp64, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: if {$num_args == 2} ...
                            // Binary operator: $num_args == 2
                            TclObject tmp65 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            ExprValue tmp66 = evs0;
                            TJC.exprInitValue(interp, tmp66, tmp65);
                            ExprValue tmp67 = evs1;
                            tmp67.setIntValue(2);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp66, tmp67);
                            // End Binary operator: ==
                            boolean tmp68 = ( tmp66.getIntValue() != 0 );
                            if ( tmp68 ) {
                                { // Invoke: set _descend($key,usage) 1
                                    TclObject tmp69;
                                    String tmp70;
                                    StringBuffer sbtmp71 = new StringBuffer(64);
                                    tmp69 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp71.append(tmp69.toString());
                                    sbtmp71.append(",usage");
                                    tmp70 = sbtmp71.toString();
                                    setVarArray(interp, "_descend", tmp70, const3, compiledLocals, 1);
                                } // End Invoke: set
                                { // Invoke: return [...]
                                    { // Invoke: list numArgs "after" $num_args "3 or more"
                                        TclObject tmp72 = TclList.newInstance();
                                        TclObject tmp73;
                                        try {
                                            TclList.append(interp, tmp72, const4);
                                            TclList.append(interp, tmp72, const5);
                                            tmp73 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                            TclList.append(interp, tmp72, tmp73);
                                            TclList.append(interp, tmp72, const21);
                                        } catch (TclException ex) {
                                            tmp72.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp72);
                                    } // End Invoke: list
                                    if ( true ) { return; }
                                } // End Invoke: return
                            }
                        } // End Invoke: if
                    } else if ( tmp30 == 7 ) {
                        // Pattern {^info$}
                        { // Invoke: set type $text
                            TclObject tmp74;
                            tmp74 = getVarScalar(interp, "text", compiledLocals, 9);
                            setVarScalar(interp, "type", tmp74, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: if {$num_args > 3} ...
                            // Binary operator: $num_args > 3
                            TclObject tmp75 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            ExprValue tmp76 = evs0;
                            TJC.exprInitValue(interp, tmp76, tmp75);
                            ExprValue tmp77 = evs1;
                            tmp77.setIntValue(3);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp76, tmp77);
                            // End Binary operator: >
                            boolean tmp78 = ( tmp76.getIntValue() != 0 );
                            if ( tmp78 ) {
                                { // Invoke: set _descend($key,usage) 1
                                    TclObject tmp79;
                                    String tmp80;
                                    StringBuffer sbtmp81 = new StringBuffer(64);
                                    tmp79 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp81.append(tmp79.toString());
                                    sbtmp81.append(",usage");
                                    tmp80 = sbtmp81.toString();
                                    setVarArray(interp, "_descend", tmp80, const3, compiledLocals, 1);
                                } // End Invoke: set
                                { // Invoke: return [...]
                                    { // Invoke: list numArgs "after" $num_args "2 or 3"
                                        TclObject tmp82 = TclList.newInstance();
                                        TclObject tmp83;
                                        try {
                                            TclList.append(interp, tmp82, const4);
                                            TclList.append(interp, tmp82, const5);
                                            tmp83 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                            TclList.append(interp, tmp82, tmp83);
                                            TclList.append(interp, tmp82, const22);
                                        } catch (TclException ex) {
                                            tmp82.release();
                                            throw ex;
                                        }
                                        interp.setResult(tmp82);
                                    } // End Invoke: list
                                    if ( true ) { return; }
                                } // End Invoke: return
                            }
                        } // End Invoke: if
                    } else if ( tmp30 == 9 ) {
                        // Pattern default
                        { // Invoke: set _descend($key,usage) 1
                            TclObject tmp84;
                            String tmp85;
                            StringBuffer sbtmp86 = new StringBuffer(64);
                            tmp84 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp86.append(tmp84.toString());
                            sbtmp86.append(",usage");
                            tmp85 = sbtmp86.toString();
                            setVarArray(interp, "_descend", tmp85, const3, compiledLocals, 1);
                        } // End Invoke: set
                        { // Invoke: return [...]
                            { // Invoke: list badOption "after" 1 $text
                                TclObject tmp87 = TclList.newInstance();
                                TclObject tmp88;
                                try {
                                    TclList.append(interp, tmp87, const23);
                                    TclList.append(interp, tmp87, const5);
                                    TclList.append(interp, tmp87, const3);
                                    tmp88 = getVarScalar(interp, "text", compiledLocals, 9);
                                    TclList.append(interp, tmp87, tmp88);
                                } catch (TclException ex) {
                                    tmp87.release();
                                    throw ex;
                                }
                                interp.setResult(tmp87);
                            } // End Invoke: list
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        throw new TclRuntimeError("bad switch body offset " +
                            String.valueOf(tmp30));
                    }
                } // End Invoke: switch
            } else {
                { // Invoke: return [...]
                    { // Invoke: list nonStatic "after" 1
                        TclObject tmp89 = TclList.newInstance();
                        try {
                            TclList.append(interp, tmp89, const24);
                            TclList.append(interp, tmp89, const5);
                            TclList.append(interp, tmp89, const3);
                        } catch (TclException ex) {
                            tmp89.release();
                            throw ex;
                        }
                        interp.setResult(tmp89);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $type == "ms"
            TclObject tmp90 = getVarScalar(interp, "type", compiledLocals, 5);
            boolean tmp91 = tmp90.toString().equals("ms");
            ExprValue tmp92 = evs0;
            tmp92.setIntValue(tmp91);
            // End Binary operator: ==
            if (!tmp92.getBooleanValue(interp)) {
            // Binary operator: $type == "idle"
            TclObject tmp93 = getVarScalar(interp, "type", compiledLocals, 5);
            boolean tmp94 = tmp93.toString().equals("idle");
            ExprValue tmp95 = evs1;
            tmp95.setIntValue(tmp94);
            // End Binary operator: ==
            tmp92.setIntValue(tmp95.getBooleanValue(interp));
            } else {
            tmp92.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp96 = ( tmp92.getIntValue() != 0 );
            if ( tmp96 ) {
                { // Invoke: set static 1
                    setVarScalar(interp, "static", const3, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: foreach index $cmd_indexes ...
                    TclObject tmp97 = null;
                    try {
                        tmp97 = getVarScalar(interp, "cmd_indexes", compiledLocals, 7);
                        tmp97.preserve();
                        final int tmp97_length = TclList.getLength(interp, tmp97);

                        for ( int index98 = 0 ; index98 < tmp97_length ; index98++ ) {
                            TclObject tmp99 = TclList.index(interp, tmp97, index98);
                            try {
                                setVarScalar(interp, "index", tmp99, compiledLocals, 12);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "index");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set subtree [...]
                                TclObject tmp100;
                                { // Invoke: lindex $tree $index
                                    TclObject tmp101 = null;
                                    TclObject tmp102;
                                    try {
                                        tmp101 = getVarScalar(interp, "tree", compiledLocals, 3);
                                        tmp101.preserve();
                                        tmp102 = getVarScalar(interp, "index", compiledLocals, 12);
                                        TJC.lindexNonconst(interp, tmp101, tmp102);
                                    } finally {
                                        if ( tmp101 != null ) {
                                            tmp101.release();
                                        }
                                    }
                                } // End Invoke: lindex
                                tmp100 = interp.getResult();
                                setVarScalar(interp, "subtree", tmp100, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: if ... ...
                                // Unary operator: ! [...]
                                { // Invoke: parse_is_simple_text $subtree
                                    TclObject[] objv103 = TJC.grabObjv(interp, 2);
                                    TclObject tmp104;
                                    try {
                                        // Arg 0 constant: parse_is_simple_text
                                        objv103[0] = const9;
                                        // Arg 1 variable: $subtree
                                        tmp104 = getVarScalar(interp, "subtree", compiledLocals, 8);
                                        tmp104.preserve();
                                        objv103[1] = tmp104;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                            ? cmdcache2.cmd : null), objv103, 0);
                                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                            updateCmdCache(interp, 2);
                                        }
                                    } finally {
                                        tmp104 = objv103[1];
                                        if ( tmp104 != null ) {
                                            tmp104.release();
                                        }
                                        TJC.releaseObjv(interp, objv103, 2);
                                    }
                                } // End Invoke: parse_is_simple_text
                                TclObject tmp105 = interp.getResult();
                                ExprValue tmp106 = evs0;
                                if ( tmp105.isIntType() ) {
                                    TJC.exprUnaryNotOperatorKnownInt(tmp106, tmp105);
                                } else {
                                    TJC.exprUnaryNotOperator(interp, tmp106, tmp105);
                                }
                                // End Unary operator: !
                                boolean tmp107 = ( tmp106.getIntValue() != 0 );
                                if ( tmp107 ) {
                                    { // Invoke: set static 0
                                        setVarScalar(interp, "static", const25, compiledLocals, 11);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp97 != null ) {
                            tmp97.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: if {$static} ...
                    TclObject tmp108 = getVarScalar(interp, "static", compiledLocals, 11);
                    boolean tmp109 = TJC.getBoolean(interp, tmp108);
                    if ( tmp109 ) {
                        { // Invoke: set "..." 1
                            TclObject tmp110;
                            String tmp111;
                            StringBuffer sbtmp112 = new StringBuffer(64);
                            tmp110 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp112.append(tmp110.toString());
                            sbtmp112.append(",static_container");
                            tmp111 = sbtmp112.toString();
                            setVarArray(interp, "_descend", tmp111, const3, compiledLocals, 1);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set "..." [...]
            TclObject tmp113;
            String tmp116;
            StringBuffer sbtmp117 = new StringBuffer(64);
            tmp113 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp117.append(tmp113.toString());
            sbtmp117.append(",validated");
            tmp116 = sbtmp117.toString();
            { // Invoke: list $type $type_args $cmd_indexes
                TclObject tmp114 = TclList.newInstance();
                TclObject tmp115;
                try {
                    tmp115 = getVarScalar(interp, "type", compiledLocals, 5);
                    TclList.append(interp, tmp114, tmp115);
                    tmp115 = getVarScalar(interp, "type_args", compiledLocals, 6);
                    TclList.append(interp, tmp114, tmp115);
                    tmp115 = getVarScalar(interp, "cmd_indexes", compiledLocals, 7);
                    TclList.append(interp, tmp114, tmp115);
                } catch (TclException ex) {
                    tmp114.release();
                    throw ex;
                }
                interp.setResult(tmp114);
            } // End Invoke: list
            tmp113 = interp.getResult();
            tmp113 = setVarArray(interp, "_descend", tmp116, tmp113, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const26);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_after_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("after");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("2 or more");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("unknown");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_is_simple_text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("parse_get_simple_text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("text");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("^[0-9]+$");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("^idle$");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("^cancel$");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("^info$");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("default");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("ms_sleep");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("ms");
        const18.preserve(); const18.preserve();
        const19 = TclInteger.newInstance(2);
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("idle");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("3 or more");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("2 or 3");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("badOption");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("nonStatic");
        const24.preserve(); const24.preserve();
        const25 = TclInteger.newInstance(0);
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("OK");
        const26.preserve(); const26.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "type",
        "type_args",
        "cmd_indexes",
        "subtree",
        "text",
        "i",
        "static",
        "index"
    };
} // end class DescendContainerAfterValidateCmd

