// TJC implementation of procedure descend_container_expr_validate
package tjc;
import tcl.lang.*;

public class DescendContainerExprValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args != 2} ...
            // Binary operator: $num_args != 2
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp11);
            // End Binary operator: !=
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp13;
                    String tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp15.append(tmp13.toString());
                    sbtmp15.append(",usage");
                    tmp14 = sbtmp15.toString();
                    setVarArray(interp, "_descend", tmp14, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "expr" $num_args "1 braced argument"
                        TclObject tmp16 = TclList.newInstance();
                        TclObject tmp17;
                        try {
                            TclList.append(interp, tmp16, const4);
                            TclList.append(interp, tmp16, const5);
                            tmp17 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp16, tmp17);
                            TclList.append(interp, tmp16, const6);
                        } catch (TclException ex) {
                            tmp16.release();
                            throw ex;
                        }
                        interp.setResult(tmp16);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set arg 1
            setVarScalar(interp, "arg", const3, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set valid [...]
            TclObject tmp18;
            { // Invoke: ... $key $arg
                TclObject[] objv19 = TJC.grabObjv(interp, 3);
                TclObject tmp20;
                try {
                    // Arg 0 constant: ...
                    objv19[0] = const7;
                    // Arg 1 variable: $key
                    tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    // Arg 2 variable: $arg
                    tmp20 = getVarScalar(interp, "arg", compiledLocals, 5);
                    tmp20.preserve();
                    objv19[2] = tmp20;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv19, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    tmp20 = objv19[2];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 3);
                }
            } // End Invoke: ...
            tmp18 = interp.getResult();
            setVarScalar(interp, "valid", tmp18, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {!$valid} ...
            // Unary operator: ! $valid
            TclObject tmp21 = getVarScalar(interp, "valid", compiledLocals, 6);
            ExprValue tmp22 = evs0;
            if ( tmp21.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp22, tmp21);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp22, tmp21);
            }
            // End Unary operator: !
            boolean tmp23 = ( tmp22.getIntValue() != 0 );
            if ( tmp23 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp24;
                    String tmp25;
                    StringBuffer sbtmp26 = new StringBuffer(64);
                    tmp24 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp26.append(tmp24.toString());
                    sbtmp26.append(",usage");
                    tmp25 = sbtmp26.toString();
                    setVarArray(interp, "_descend", tmp25, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list invalidArg $arg "expr" ...
                        TclObject tmp27 = TclList.newInstance();
                        TclObject tmp28;
                        try {
                            TclList.append(interp, tmp27, const8);
                            tmp28 = getVarScalar(interp, "arg", compiledLocals, 5);
                            TclList.append(interp, tmp27, tmp28);
                            TclList.append(interp, tmp27, const5);
                            TclList.append(interp, tmp27, const9);
                        } catch (TclException ex) {
                            tmp27.release();
                            throw ex;
                        }
                        interp.setResult(tmp27);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set "..." 1
            TclObject tmp29;
            String tmp30;
            StringBuffer sbtmp31 = new StringBuffer(64);
            tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp31.append(tmp29.toString());
            sbtmp31.append(",static_container");
            tmp30 = sbtmp31.toString();
            setVarArray(interp, "_descend", tmp30, const3, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set "..." {1}
            TclObject tmp32;
            String tmp33;
            StringBuffer sbtmp34 = new StringBuffer(64);
            tmp32 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp34.append(tmp32.toString());
            sbtmp34.append(",validated");
            tmp33 = sbtmp34.toString();
            setVarArray(interp, "_descend", tmp33, const3, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const10);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_expr_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("expr");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("1 braced argument");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_expr_argument_validate");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("invalidArg");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("braced expr argument required");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("OK");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_expr_argument_validate";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "arg",
        "valid"
    };
} // end class DescendContainerExprValidateCmd

