// TJC implementation of procedure descend_container_for_validate
package tjc;
import tcl.lang.*;

public class DescendContainerForValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args != 5} ...
            // Binary operator: $num_args != 5
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(5);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp11);
            // End Binary operator: !=
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp13;
                    String tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp15.append(tmp13.toString());
                    sbtmp15.append(",usage");
                    tmp14 = sbtmp15.toString();
                    setVarArray(interp, "_descend", tmp14, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "for" $num_args 5
                        TclObject tmp16 = TclList.newInstance();
                        TclObject tmp17;
                        try {
                            TclList.append(interp, tmp16, const4);
                            TclList.append(interp, tmp16, const5);
                            tmp17 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp16, tmp17);
                            TclList.append(interp, tmp16, const6);
                        } catch (TclException ex) {
                            tmp16.release();
                            throw ex;
                        }
                        interp.setResult(tmp16);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: ... $key 2
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: ...
                    objv18[0] = const7;
                    // Arg 1 variable: $key
                    tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: 2
                    objv18[2] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv18, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: ...
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            if ( tmp20.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp21, tmp20);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp21, tmp20);
            }
            // End Unary operator: !
            boolean tmp22 = ( tmp21.getIntValue() != 0 );
            if ( tmp22 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp23;
                    String tmp24;
                    StringBuffer sbtmp25 = new StringBuffer(64);
                    tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp25.append(tmp23.toString());
                    sbtmp25.append(",usage");
                    tmp24 = sbtmp25.toString();
                    setVarArray(interp, "_descend", tmp24, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list invalidArg 2 "expr" ...
                        TclObject tmp26 = TclList.newInstance();
                        try {
                            TclList.append(interp, tmp26, const9);
                            TclList.append(interp, tmp26, const8);
                            TclList.append(interp, tmp26, const10);
                            TclList.append(interp, tmp26, const11);
                        } catch (TclException ex) {
                            tmp26.release();
                            throw ex;
                        }
                        interp.setResult(tmp26);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set static 1
            setVarScalar(interp, "static", const3, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: foreach i {1 3 4} ...
            TclObject tmp27 = null;
            try {
                tmp27 = const12;
                tmp27.preserve();
                final int tmp27_length = TclList.getLength(interp, tmp27);

                for ( int index28 = 0 ; index28 < tmp27_length ; index28++ ) {
                    TclObject tmp29 = TclList.index(interp, tmp27, index28);
                    try {
                        setVarScalar(interp, "i", tmp29, compiledLocals, 6);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "i");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if ... ...
                        // Unary operator: ! [...]
                        { // Invoke: ... $key $i
                            TclObject[] objv30 = TJC.grabObjv(interp, 3);
                            TclObject tmp31;
                            try {
                                // Arg 0 constant: ...
                                objv30[0] = const13;
                                // Arg 1 variable: $key
                                tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp31.preserve();
                                objv30[1] = tmp31;
                                // Arg 2 variable: $i
                                tmp31 = getVarScalar(interp, "i", compiledLocals, 6);
                                tmp31.preserve();
                                objv30[2] = tmp31;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv30, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp31 = objv30[1];
                                if ( tmp31 != null ) {
                                    tmp31.release();
                                }
                                tmp31 = objv30[2];
                                if ( tmp31 != null ) {
                                    tmp31.release();
                                }
                                TJC.releaseObjv(interp, objv30, 3);
                            }
                        } // End Invoke: ...
                        TclObject tmp32 = interp.getResult();
                        ExprValue tmp33 = evs0;
                        if ( tmp32.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp33, tmp32);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp33, tmp32);
                        }
                        // End Unary operator: !
                        boolean tmp34 = ( tmp33.getIntValue() != 0 );
                        if ( tmp34 ) {
                            { // Invoke: set static 0
                                setVarScalar(interp, "static", const14, compiledLocals, 5);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp27 != null ) {
                    tmp27.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if {$static} ...
            TclObject tmp35 = getVarScalar(interp, "static", compiledLocals, 5);
            boolean tmp36 = TJC.getBoolean(interp, tmp35);
            if ( tmp36 ) {
                { // Invoke: set "..." 1
                    TclObject tmp37;
                    String tmp38;
                    StringBuffer sbtmp39 = new StringBuffer(64);
                    tmp37 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp39.append(tmp37.toString());
                    sbtmp39.append(",static_container");
                    tmp38 = sbtmp39.toString();
                    setVarArray(interp, "_descend", tmp38, const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set "..." [...]
            TclObject tmp40;
            String tmp42;
            StringBuffer sbtmp43 = new StringBuffer(64);
            tmp40 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp43.append(tmp40.toString());
            sbtmp43.append(",validated");
            tmp42 = sbtmp43.toString();
            { // Invoke: list 1 2 3 4
                TclObject tmp41 = TclList.newInstance();
                try {
                    TclList.append(interp, tmp41, const3);
                    TclList.append(interp, tmp41, const8);
                    TclList.append(interp, tmp41, const15);
                    TclList.append(interp, tmp41, const16);
                } catch (TclException ex) {
                    tmp41.release();
                    throw ex;
                }
                interp.setResult(tmp41);
            } // End Invoke: list
            tmp40 = interp.getResult();
            tmp40 = setVarArray(interp, "_descend", tmp42, tmp40, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const17);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_for_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("for");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(5);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_expr_argument_validate");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(2);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("invalidArg");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("expr");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("braced expr argument required");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("1 3 4");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("descend_container_argument_body_is_static");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(0);
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(3);
        const15.preserve(); const15.preserve();
        const16 = TclInteger.newInstance(4);
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("OK");
        const17.preserve(); const17.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_expr_argument_validate";
                break;
            }
            case 3: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "static",
        "i"
    };
} // end class DescendContainerForValidateCmd

