// TJC implementation of procedure descend_container_foreach_varlist
package tjc;
import tcl.lang.*;

public class DescendContainerForeachVarlistCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key varindex");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varindex", objv[2], compiledLocals, 1);
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set subtree [...]
            TclObject tmp6;
            { // Invoke: lindex $tree $varindex
                TclObject tmp7 = null;
                TclObject tmp8;
                try {
                    tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                    tmp7.preserve();
                    tmp8 = getVarScalar(interp, "varindex", compiledLocals, 1);
                    TJC.lindexNonconst(interp, tmp7, tmp8);
                } finally {
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                }
            } // End Invoke: lindex
            tmp6 = interp.getResult();
            setVarScalar(interp, "subtree", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_simple_text $subtree
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv9[0] = const3;
                    // Arg 1 variable: $subtree
                    tmp10 = getVarScalar(interp, "subtree", compiledLocals, 4);
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv9, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            if ( tmp11.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp12, tmp11);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp12, tmp11);
            }
            // End Unary operator: !
            boolean tmp13 = ( tmp12.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: return "NOT_STATIC"
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set text_range [...]
            TclObject tmp14;
            { // Invoke: lindex $subtree 2 0 1
                TclObject[] objv15 = TJC.grabObjv(interp, 5);
                TclObject tmp16;
                try {
                    // Arg 0 constant: lindex
                    objv15[0] = const5;
                    // Arg 1 variable: $subtree
                    tmp16 = getVarScalar(interp, "subtree", compiledLocals, 4);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: 2
                    objv15[2] = const6;
                    // Arg 3 constant: 0
                    objv15[3] = const7;
                    // Arg 4 constant: 1
                    objv15[4] = const8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv15, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 5);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "text_range", tmp14, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: catch ... list_ranges
                int code17 = TCL.OK;
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: parse list $script $text_range
                    TclObject[] objv18 = TJC.grabObjv(interp, 4);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: parse
                        objv18[0] = const9;
                        // Arg 1 constant: list
                        objv18[1] = const10;
                        // Arg 2 variable: $script
                        tmp19 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp19.preserve();
                        objv18[2] = tmp19;
                        // Arg 3 variable: $text_range
                        tmp19 = getVarScalar(interp, "text_range", compiledLocals, 5);
                        tmp19.preserve();
                        objv18[3] = tmp19;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv18, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp19 = objv18[2];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        tmp19 = objv18[3];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 4);
                    }
                } // End Invoke: parse
                } catch (TclException ex) {
                    code17 = ex.getCompletionCode();
                }
                TclObject result = interp.getResult();
                try {
                    setVarScalar(interp, "list_ranges", result, compiledLocals, 6);
                } catch (TclException ex) {
                    TJC.catchVarErr(interp);
                }
                interp.resetResult();
                interp.setResult(code17);
            } // End Invoke: catch
            TclObject tmp20 = interp.getResult();
            ExprValue tmp21 = evs0;
            TJC.exprInitValue(interp, tmp21, tmp20);
            boolean tmp22 = tmp21.getBooleanValue(interp);
            if ( tmp22 ) {
                { // Invoke: return {}
                    interp.resetResult();
                    interp.setResult(const11);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set var_names [...]
            TclObject tmp23;
            { // Invoke: list
                TclObject tmp24 = TclList.newInstance();
                interp.setResult(tmp24);
            } // End Invoke: list
            tmp23 = interp.getResult();
            setVarScalar(interp, "var_names", tmp23, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: foreach range $list_ranges ...
            TclObject tmp25 = null;
            try {
                tmp25 = getVarScalar(interp, "list_ranges", compiledLocals, 6);
                tmp25.preserve();
                final int tmp25_length = TclList.getLength(interp, tmp25);

                for ( int index26 = 0 ; index26 < tmp25_length ; index26++ ) {
                    TclObject tmp27 = TclList.index(interp, tmp25, index26);
                    try {
                        setVarScalar(interp, "range", tmp27, compiledLocals, 8);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "range");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: lappend var_names [...]
                        TclObject[] objv28 = TJC.grabObjv(interp, 1);
                        TclObject tmp29;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: parse getstring $script $range
                                TclObject[] objv30 = TJC.grabObjv(interp, 4);
                                TclObject tmp31;
                                try {
                                    // Arg 0 constant: parse
                                    objv30[0] = const9;
                                    // Arg 1 constant: getstring
                                    objv30[1] = const12;
                                    // Arg 2 variable: $script
                                    tmp31 = getVarScalar(interp, "script", compiledLocals, 2);
                                    tmp31.preserve();
                                    objv30[2] = tmp31;
                                    // Arg 3 variable: $range
                                    tmp31 = getVarScalar(interp, "range", compiledLocals, 8);
                                    tmp31.preserve();
                                    objv30[3] = tmp31;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv30, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp31 = objv30[2];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    tmp31 = objv30[3];
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                    TJC.releaseObjv(interp, objv30, 4);
                                }
                            } // End Invoke: parse
                            tmp29 = interp.getResult();
                            tmp29.preserve();
                            objv28[0] = tmp29;
                            interp.resetResult();
                            lappendVarScalar(interp, "var_names", objv28, compiledLocals, 7);
                        } finally {
                            TJC.releaseObjvElems(interp, objv28, 1);
                        }
                    } // End Invoke: lappend
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp25 != null ) {
                    tmp25.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: return $var_names
            TclObject tmp32 = getVarScalar(interp, "var_names", compiledLocals, 7);
            interp.resetResult();
            interp.setResult(tmp32);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_foreach_varlist");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_is_simple_text");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("NOT_STATIC");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lindex");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(2);
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(0);
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(1);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("list");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("getstring");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "lindex";
                break;
            }
            case 4: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "varindex",
        "script",
        "tree",
        "subtree",
        "text_range",
        "list_ranges",
        "var_names",
        "range"
    };
} // end class DescendContainerForeachVarlistCmd

