// TJC implementation of procedure descend_container_lsort
package tjc;
import tcl.lang.*;

public class DescendContainerLsortCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: ... $key
                TclObject[] objv1 = TJC.grabObjv(interp, 2);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp3 = getVarScalar(interp, "result", compiledLocals, 2);
            boolean tmp4 = ! tmp3.toString().equals("OK");
            ExprValue tmp5 = evs0;
            tmp5.setIntValue(tmp4);
            // End Binary operator: !=
            boolean tmp6 = ( tmp5.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv7 = TJC.grabObjv(interp, 3);
                        TclObject tmp8;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv7[0] = const1;
                            // Arg 1 variable: $key
                            tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp8.preserve();
                            objv7[1] = tmp8;
                            // Arg 2 constant: usage
                            objv7[2] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv7, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp8 = objv7[1];
                            if ( tmp8 != null ) {
                                tmp8.release();
                            }
                            TJC.releaseObjv(interp, objv7, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp9 = interp.getResult();
                    ExprValue tmp10 = evs0;
                    TJC.exprInitValue(interp, tmp10, tmp9);
                    boolean tmp11 = tmp10.getBooleanValue(interp);
                    if ( tmp11 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv12 = TJC.grabObjv(interp, 3);
                            TclObject tmp13;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv12[0] = const3;
                                // Arg 1 variable: $key
                                tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp13.preserve();
                                objv12[1] = tmp13;
                                // Arg 2 variable: $result
                                tmp13 = getVarScalar(interp, "result", compiledLocals, 2);
                                tmp13.preserve();
                                objv12[2] = tmp13;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv12, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp13 = objv12[1];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                tmp13 = objv12[2];
                                if ( tmp13 != null ) {
                                    tmp13.release();
                                }
                                TJC.releaseObjv(interp, objv12, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set script [...]
            TclObject tmp14;
            { // Invoke: descend_get_data $key script
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: descend_get_data
                    objv15[0] = const1;
                    // Arg 1 variable: $key
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp16.preserve();
                    objv15[1] = tmp16;
                    // Arg 2 constant: script
                    objv15[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv15, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp16 = objv15[1];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: descend_get_data
            tmp14 = interp.getResult();
            setVarScalar(interp, "script", tmp14, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp17;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv18 = TJC.grabObjv(interp, 3);
                TclObject tmp19;
                try {
                    // Arg 0 constant: descend_get_data
                    objv18[0] = const1;
                    // Arg 1 variable: $key
                    tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp19.preserve();
                    objv18[1] = tmp19;
                    // Arg 2 constant: tree
                    objv18[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv18, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp19 = objv18[1];
                    if ( tmp19 != null ) {
                        tmp19.release();
                    }
                    TJC.releaseObjv(interp, objv18, 3);
                }
            } // End Invoke: descend_get_data
            tmp17 = interp.getResult();
            setVarScalar(interp, "tree", tmp17, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && [...]
            { // Invoke: ... $key
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                TclObject tmp21;
                try {
                    // Arg 0 constant: ...
                    objv20[0] = const6;
                    // Arg 1 variable: $key
                    tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp21.preserve();
                    objv20[1] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv20, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp21 = objv20[1];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: ...
            TclObject tmp22 = interp.getResult();
            ExprValue tmp23 = evs0;
            TJC.exprInitValue(interp, tmp23, tmp22);
            if (tmp23.getBooleanValue(interp)) {
            { // Invoke: ... $key
                TclObject[] objv24 = TJC.grabObjv(interp, 2);
                TclObject tmp25;
                try {
                    // Arg 0 constant: ...
                    objv24[0] = const7;
                    // Arg 1 variable: $key
                    tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp25.preserve();
                    objv24[1] = tmp25;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv24, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp25 = objv24[1];
                    if ( tmp25 != null ) {
                        tmp25.release();
                    }
                    TJC.releaseObjv(interp, objv24, 2);
                }
            } // End Invoke: ...
            TclObject tmp26 = interp.getResult();
            ExprValue tmp27 = evs1;
            TJC.exprInitValue(interp, tmp27, tmp26);
            tmp23.setIntValue(tmp27.getBooleanValue(interp));
            } else {
            tmp23.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp28 = ( tmp23.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: set command_index [...]
                    TclObject tmp29;
                    { // Invoke: ... $key
                        TclObject[] objv30 = TJC.grabObjv(interp, 2);
                        TclObject tmp31;
                        try {
                            // Arg 0 constant: ...
                            objv30[0] = const8;
                            // Arg 1 variable: $key
                            tmp31 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp31.preserve();
                            objv30[1] = tmp31;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv30, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp31 = objv30[1];
                            if ( tmp31 != null ) {
                                tmp31.release();
                            }
                            TJC.releaseObjv(interp, objv30, 2);
                        }
                    } // End Invoke: ...
                    tmp29 = interp.getResult();
                    setVarScalar(interp, "command_index", tmp29, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    { // Invoke: ... $key $command_index
                        TclObject[] objv32 = TJC.grabObjv(interp, 3);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: ...
                            objv32[0] = const9;
                            // Arg 1 variable: $key
                            tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            // Arg 2 variable: $command_index
                            tmp33 = getVarScalar(interp, "command_index", compiledLocals, 5);
                            tmp33.preserve();
                            objv32[2] = tmp33;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv32, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            tmp33 = objv32[2];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp34 = interp.getResult();
                    ExprValue tmp35 = evs0;
                    TJC.exprInitValue(interp, tmp35, tmp34);
                    boolean tmp36 = tmp35.getBooleanValue(interp);
                    if ( tmp36 ) {
                        { // Invoke: ...
                            TclObject[] objv37 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv37[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                    ? cmdcache8.cmd : null), objv37, 0);
                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                    updateCmdCache(interp, 8);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv37, 1);
                            }
                        } // End Invoke: ...
                        { // Invoke: set undetermined 1
                            setVarScalar(interp, "undetermined", const11, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: ... $key $script $tree $command_index $undetermined
                            TclObject[] objv38 = TJC.grabObjv(interp, 6);
                            TclObject tmp39;
                            try {
                                // Arg 0 constant: ...
                                objv38[0] = const12;
                                // Arg 1 variable: $key
                                tmp39 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp39.preserve();
                                objv38[1] = tmp39;
                                // Arg 2 variable: $script
                                tmp39 = getVarScalar(interp, "script", compiledLocals, 3);
                                tmp39.preserve();
                                objv38[2] = tmp39;
                                // Arg 3 variable: $tree
                                tmp39 = getVarScalar(interp, "tree", compiledLocals, 4);
                                tmp39.preserve();
                                objv38[3] = tmp39;
                                // Arg 4 variable: $command_index
                                tmp39 = getVarScalar(interp, "command_index", compiledLocals, 5);
                                tmp39.preserve();
                                objv38[4] = tmp39;
                                // Arg 5 variable: $undetermined
                                tmp39 = getVarScalar(interp, "undetermined", compiledLocals, 6);
                                tmp39.preserve();
                                objv38[5] = tmp39;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv38, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                objv38[0] = null;
                                TJC.releaseObjvElems(interp, objv38, 6);
                            }
                        } // End Invoke: ...
                        { // Invoke: set "..." [...]
                            TclObject tmp40;
                            String tmp42;
                            StringBuffer sbtmp43 = new StringBuffer(64);
                            tmp40 = getVarScalar(interp, "key", compiledLocals, 0);
                            sbtmp43.append(tmp40.toString());
                            sbtmp43.append(",container_commands");
                            tmp42 = sbtmp43.toString();
                            { // Invoke: ...
                                TclObject[] objv41 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv41[0] = const13;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv41, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv41, 1);
                                }
                            } // End Invoke: ...
                            tmp40 = interp.getResult();
                            tmp40 = setVarArray(interp, "_descend", tmp42, tmp40, compiledLocals, 1);
                            interp.setResult(tmp40);
                        } // End Invoke: set
                    } else {
                        interp.resetResult();
                    }
                } // End Invoke: if
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_lsort");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_container_lsort_validate");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("usage");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_report_usage");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("script");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_container_lsort_has_command");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_is_static");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_lsort_command");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_container_argument_body_is_static");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("_descend_commands_push");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(1);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_container_body_argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("_descend_commands_pop");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_container_lsort_validate";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "descend_container_lsort_has_command";
                break;
            }
            case 5: {
                cmdName = "descend_container_is_static";
                break;
            }
            case 6: {
                cmdName = "descend_container_lsort_command";
                break;
            }
            case 7: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 8: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 9: {
                cmdName = "descend_container_body_argument";
                break;
            }
            case 10: {
                cmdName = "_descend_commands_pop";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "result",
        "script",
        "tree",
        "command_index",
        "undetermined"
    };
} // end class DescendContainerLsortCmd

