// TJC implementation of procedure descend_container_while
package tjc;
import tcl.lang.*;

public class DescendContainerWhileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp6;
            { // Invoke: ... $key
                TclObject[] objv7 = TJC.grabObjv(interp, 2);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 2);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "result", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$result != "OK"} ...
            // Binary operator: $result != "OK"
            TclObject tmp9 = getVarScalar(interp, "result", compiledLocals, 4);
            boolean tmp10 = ! tmp9.toString().equals("OK");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: !=
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: if ... ...
                    { // Invoke: descend_get_data $key usage
                        TclObject[] objv13 = TJC.grabObjv(interp, 3);
                        TclObject tmp14;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv13[0] = const0;
                            // Arg 1 variable: $key
                            tmp14 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp14.preserve();
                            objv13[1] = tmp14;
                            // Arg 2 constant: usage
                            objv13[2] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv13, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp14 = objv13[1];
                            if ( tmp14 != null ) {
                                tmp14.release();
                            }
                            TJC.releaseObjv(interp, objv13, 3);
                        }
                    } // End Invoke: descend_get_data
                    TclObject tmp15 = interp.getResult();
                    ExprValue tmp16 = evs0;
                    TJC.exprInitValue(interp, tmp16, tmp15);
                    boolean tmp17 = tmp16.getBooleanValue(interp);
                    if ( tmp17 ) {
                        { // Invoke: descend_report_usage $key $result
                            TclObject[] objv18 = TJC.grabObjv(interp, 3);
                            TclObject tmp19;
                            try {
                                // Arg 0 constant: descend_report_usage
                                objv18[0] = const5;
                                // Arg 1 variable: $key
                                tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                                tmp19.preserve();
                                objv18[1] = tmp19;
                                // Arg 2 variable: $result
                                tmp19 = getVarScalar(interp, "result", compiledLocals, 4);
                                tmp19.preserve();
                                objv18[2] = tmp19;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv18, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp19 = objv18[1];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                tmp19 = objv18[2];
                                if ( tmp19 != null ) {
                                    tmp19.release();
                                }
                                TJC.releaseObjv(interp, objv18, 3);
                            }
                        } // End Invoke: descend_report_usage
                    }
                } // End Invoke: if
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set container_commands [...]
            TclObject tmp20;
            { // Invoke: list
                TclObject tmp21 = TclList.newInstance();
                interp.setResult(tmp21);
            } // End Invoke: list
            tmp20 = interp.getResult();
            setVarScalar(interp, "container_commands", tmp20, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: ...
            TclObject[] objv22 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: ...
                objv22[0] = const6;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                    ? cmdcache4.cmd : null), objv22, 0);
                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                    updateCmdCache(interp, 4);
                }
            } finally {
                TJC.releaseObjv(interp, objv22, 1);
            }
        } // End Invoke: ...
        { // Invoke: set expr_index [...]
            TclObject tmp23;
            { // Invoke: ... $key
                TclObject[] objv24 = TJC.grabObjv(interp, 2);
                TclObject tmp25;
                try {
                    // Arg 0 constant: ...
                    objv24[0] = const7;
                    // Arg 1 variable: $key
                    tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp25.preserve();
                    objv24[1] = tmp25;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv24, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp25 = objv24[1];
                    if ( tmp25 != null ) {
                        tmp25.release();
                    }
                    TJC.releaseObjv(interp, objv24, 2);
                }
            } // End Invoke: ...
            tmp23 = interp.getResult();
            setVarScalar(interp, "expr_index", tmp23, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: ... $key $expr_index
            TclObject[] objv26 = TJC.grabObjv(interp, 3);
            TclObject tmp27;
            try {
                // Arg 0 constant: ...
                objv26[0] = const8;
                // Arg 1 variable: $key
                tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp27.preserve();
                objv26[1] = tmp27;
                // Arg 2 variable: $expr_index
                tmp27 = getVarScalar(interp, "expr_index", compiledLocals, 6);
                tmp27.preserve();
                objv26[2] = tmp27;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                    ? cmdcache6.cmd : null), objv26, 0);
                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                    updateCmdCache(interp, 6);
                }
            } finally {
                tmp27 = objv26[1];
                if ( tmp27 != null ) {
                    tmp27.release();
                }
                tmp27 = objv26[2];
                if ( tmp27 != null ) {
                    tmp27.release();
                }
                TJC.releaseObjv(interp, objv26, 3);
            }
        } // End Invoke: ...
        { // Invoke: lappend container_commands [...]
            TclObject[] objv28 = TJC.grabObjv(interp, 1);
            TclObject tmp29;
            try {
                // Arg 2 command: [...]
                { // Invoke: ...
                    TclObject[] objv30 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv30[0] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv30, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv30, 1);
                    }
                } // End Invoke: ...
                tmp29 = interp.getResult();
                tmp29.preserve();
                objv28[0] = tmp29;
                interp.resetResult();
                lappendVarScalar(interp, "container_commands", objv28, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv28, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set body_index [...]
            TclObject tmp31;
            { // Invoke: ... $key
                TclObject[] objv32 = TJC.grabObjv(interp, 2);
                TclObject tmp33;
                try {
                    // Arg 0 constant: ...
                    objv32[0] = const10;
                    // Arg 1 variable: $key
                    tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp33.preserve();
                    objv32[1] = tmp33;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                        ? cmdcache8.cmd : null), objv32, 0);
                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                        updateCmdCache(interp, 8);
                    }
                } finally {
                    tmp33 = objv32[1];
                    if ( tmp33 != null ) {
                        tmp33.release();
                    }
                    TJC.releaseObjv(interp, objv32, 2);
                }
            } // End Invoke: ...
            tmp31 = interp.getResult();
            setVarScalar(interp, "body_index", tmp31, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: ... $key $body_index
                TclObject[] objv34 = TJC.grabObjv(interp, 3);
                TclObject tmp35;
                try {
                    // Arg 0 constant: ...
                    objv34[0] = const11;
                    // Arg 1 variable: $key
                    tmp35 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp35.preserve();
                    objv34[1] = tmp35;
                    // Arg 2 variable: $body_index
                    tmp35 = getVarScalar(interp, "body_index", compiledLocals, 7);
                    tmp35.preserve();
                    objv34[2] = tmp35;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                        ? cmdcache9.cmd : null), objv34, 0);
                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                        updateCmdCache(interp, 9);
                    }
                } finally {
                    tmp35 = objv34[1];
                    if ( tmp35 != null ) {
                        tmp35.release();
                    }
                    tmp35 = objv34[2];
                    if ( tmp35 != null ) {
                        tmp35.release();
                    }
                    TJC.releaseObjv(interp, objv34, 3);
                }
            } // End Invoke: ...
            TclObject tmp36 = interp.getResult();
            ExprValue tmp37 = evs0;
            TJC.exprInitValue(interp, tmp37, tmp36);
            boolean tmp38 = tmp37.getBooleanValue(interp);
            if ( tmp38 ) {
                { // Invoke: ...
                    TclObject[] objv39 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv39[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv39, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv39, 1);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key $script $tree $body_index
                    TclObject[] objv40 = TJC.grabObjv(interp, 5);
                    TclObject tmp41;
                    try {
                        // Arg 0 constant: ...
                        objv40[0] = const12;
                        // Arg 1 variable: $key
                        tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp41.preserve();
                        objv40[1] = tmp41;
                        // Arg 2 variable: $script
                        tmp41 = getVarScalar(interp, "script", compiledLocals, 2);
                        tmp41.preserve();
                        objv40[2] = tmp41;
                        // Arg 3 variable: $tree
                        tmp41 = getVarScalar(interp, "tree", compiledLocals, 3);
                        tmp41.preserve();
                        objv40[3] = tmp41;
                        // Arg 4 variable: $body_index
                        tmp41 = getVarScalar(interp, "body_index", compiledLocals, 7);
                        tmp41.preserve();
                        objv40[4] = tmp41;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                            ? cmdcache10.cmd : null), objv40, 0);
                        if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                            updateCmdCache(interp, 10);
                        }
                    } finally {
                        tmp41 = objv40[1];
                        if ( tmp41 != null ) {
                            tmp41.release();
                        }
                        tmp41 = objv40[2];
                        if ( tmp41 != null ) {
                            tmp41.release();
                        }
                        tmp41 = objv40[3];
                        if ( tmp41 != null ) {
                            tmp41.release();
                        }
                        tmp41 = objv40[4];
                        if ( tmp41 != null ) {
                            tmp41.release();
                        }
                        TJC.releaseObjv(interp, objv40, 5);
                    }
                } // End Invoke: ...
                { // Invoke: lappend container_commands [...]
                    TclObject[] objv42 = TJC.grabObjv(interp, 1);
                    TclObject tmp43;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ...
                            TclObject[] objv44 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv44[0] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv44, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv44, 1);
                            }
                        } // End Invoke: ...
                        tmp43 = interp.getResult();
                        tmp43.preserve();
                        objv42[0] = tmp43;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv42, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv42, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: lappend container_commands {}
                    TclObject[] objv45 = TJC.grabObjv(interp, 1);
                    TclObject tmp46;
                    try {
                        // Arg 2 constant: {}
                        objv45[0] = const13;
                        interp.resetResult();
                        lappendVarScalar(interp, "container_commands", objv45, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjv(interp, objv45, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: set "..." $container_commands
            TclObject tmp47;
            String tmp48;
            StringBuffer sbtmp49 = new StringBuffer(64);
            tmp47 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp49.append(tmp47.toString());
            sbtmp49.append(",container_commands");
            tmp48 = sbtmp49.toString();
            tmp47 = getVarScalar(interp, "container_commands", compiledLocals, 5);
            tmp47 = setVarArray(interp, "_descend", tmp48, tmp47, compiledLocals, 1);
            interp.setResult(tmp47);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_while");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("descend_container_while_validate");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("usage");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("descend_report_usage");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("_descend_commands_push");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_while_expr");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_container_expr_argument");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("_descend_commands_pop");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_container_while_body");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("descend_container_argument_body_is_static");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("descend_container_body_argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_while_validate";
                break;
            }
            case 3: {
                cmdName = "descend_report_usage";
                break;
            }
            case 4: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 5: {
                cmdName = "descend_container_while_expr";
                break;
            }
            case 6: {
                cmdName = "descend_container_expr_argument";
                break;
            }
            case 7: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 8: {
                cmdName = "descend_container_while_body";
                break;
            }
            case 9: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            case 10: {
                cmdName = "descend_container_body_argument";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "result",
        "container_commands",
        "expr_index",
        "body_index"
    };
} // end class DescendContainerWhileCmd

