// TJC implementation of procedure descend_next_key
package tjc;
import tcl.lang.*;

public class DescendNextKeyCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 0);
        } // End Invoke: global
        { // Invoke: set key "dkey$_descend(key)"
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("dkey");
            tmp0 = getVarArray(interp, "_descend", "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            tmp0 = TclString.newInstance(sbtmp1);
            setVarScalar(interp, "key", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: incr _descend(key)
            interp.resetResult();
            incrVarArray(interp, "_descend", "key", 1, compiledLocals, 0);
        } // End Invoke: incr
        { // Invoke: return $key
            TclObject tmp2 = getVarScalar(interp, "key", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_next_key");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "_descend",
        "key"
    };
} // end class DescendNextKeyCmd

