// TJC implementation of procedure descend_simple_variable
package tjc;
import tcl.lang.*;

public class DescendSimpleVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "varname");
        }
        setVarScalar(interp, "varname", objv[1], compiledLocals, 0);
        { // Invoke: if ... ... else ...
            { // Invoke: regexp ... $varname whole part1 part2
                TclObject[] objv0 = TJC.grabObjv(interp, 6);
                TclObject tmp1;
                try {
                    // Arg 0 constant: regexp
                    objv0[0] = const0;
                    // Arg 1 constant: ...
                    objv0[1] = const1;
                    // Arg 2 variable: $varname
                    tmp1 = getVarScalar(interp, "varname", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[2] = tmp1;
                    // Arg 3 constant: whole
                    objv0[3] = const2;
                    // Arg 4 constant: part1
                    objv0[4] = const3;
                    // Arg 5 constant: part2
                    objv0[5] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[2];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 6);
                }
            } // End Invoke: regexp
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            TJC.exprInitValue(interp, tmp3, tmp2);
            boolean tmp4 = tmp3.getBooleanValue(interp);
            if ( tmp4 ) {
                { // Invoke: return [...]
                    { // Invoke: list "array" $part1 $part2
                        TclObject tmp5 = TclList.newInstance();
                        TclObject tmp6;
                        try {
                            TclList.append(interp, tmp5, const5);
                            tmp6 = getVarScalar(interp, "part1", compiledLocals, 1);
                            TclList.append(interp, tmp5, tmp6);
                            tmp6 = getVarScalar(interp, "part2", compiledLocals, 2);
                            TclList.append(interp, tmp5, tmp6);
                        } catch (TclException ex) {
                            tmp5.release();
                            throw ex;
                        }
                        interp.setResult(tmp5);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return [...]
                    { // Invoke: list "scalar" $varname
                        TclObject tmp7 = TclList.newInstance();
                        TclObject tmp8;
                        try {
                            TclList.append(interp, tmp7, const6);
                            tmp8 = getVarScalar(interp, "varname", compiledLocals, 0);
                            TclList.append(interp, tmp7, tmp8);
                        } catch (TclException ex) {
                            tmp7.release();
                            throw ex;
                        }
                        interp.setResult(tmp7);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_simple_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("regexp");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("^([^\\(]+)\\((.*)\\)$");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("whole");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("part1");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("part2");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("array");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("scalar");
        const6.preserve(); const6.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "regexp";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "varname",
        "part1",
        "part2"
    };
} // end class DescendSimpleVariableCmd

