// TJC implementation of procedure emitter_double_quote_tcl_string
package tjc;
import tcl.lang.*;

public class EmitterDoubleQuoteTclStringCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tstr");
        }
        setVarScalar(interp, "tstr", objv[1], compiledLocals, 0);
        { // Invoke: return "..."
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            sbtmp1.append("\"");
            { // Invoke: ... $tstr
                TclObject[] objv2 = TJC.grabObjv(interp, 2);
                TclObject tmp3;
                try {
                    // Arg 0 constant: ...
                    objv2[0] = const0;
                    // Arg 1 variable: $tstr
                    tmp3 = getVarScalar(interp, "tstr", compiledLocals, 0);
                    tmp3.preserve();
                    objv2[1] = tmp3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv2, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp3 = objv2[1];
                    if ( tmp3 != null ) {
                        tmp3.release();
                    }
                    TJC.releaseObjv(interp, objv2, 2);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            sbtmp1.append(tmp0.toString());
            sbtmp1.append("\"");
            tmp0 = TclString.newInstance(sbtmp1);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_double_quote_tcl_string");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_backslash_tcl_string");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tstr"
    };
} // end class EmitterDoubleQuoteTclStringCmd

