// TJC implementation of procedure emitter_set_compiled_local_scalar_var
package tjc;
import tcl.lang.*;

public class EmitterSetCompiledLocalScalarVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol varname valsym clocal_array_symbol index");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "varname", objv[2], compiledLocals, 1);
        setVarScalar(interp, "valsym", objv[3], compiledLocals, 2);
        setVarScalar(interp, "clocal_array_symbol", objv[4], compiledLocals, 3);
        setVarScalar(interp, "index", objv[5], compiledLocals, 4);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: append buffer [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 1);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 5);
            } finally {
                TJC.releaseObjvElems(interp, objv0, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$tmpsymbol != {}} ...
            // Binary operator: $tmpsymbol != ""
            TclObject tmp3 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, true);
            // End Binary operator: !=
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: append buffer $tmpsymbol " = "
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 2 variable: $tmpsymbol
                        tmp7 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                        tmp7.preserve();
                        objv6[0] = tmp7;
                        // Arg 3 constant: " = "
                        objv6[1] = const2;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv6, compiledLocals, 5);
                    } finally {
                        tmp7 = objv6[0];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer ... [...] ... $valsym ", " $clocal_array_symbol ", " $index ...
            TclObject[] objv8 = TJC.grabObjv(interp, 9);
            TclObject tmp9;
            try {
                // Arg 2 constant: ...
                objv8[0] = const3;
                // Arg 3 command: [...]
                { // Invoke: ... $varname
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: ...
                        objv10[0] = const4;
                        // Arg 1 variable: $varname
                        tmp11 = getVarScalar(interp, "varname", compiledLocals, 1);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: ...
                tmp9 = interp.getResult();
                tmp9.preserve();
                objv8[1] = tmp9;
                // Arg 4 constant: ...
                objv8[2] = const5;
                // Arg 5 variable: $valsym
                tmp9 = getVarScalar(interp, "valsym", compiledLocals, 2);
                tmp9.preserve();
                objv8[3] = tmp9;
                // Arg 6 constant: ", "
                objv8[4] = const6;
                // Arg 7 variable: $clocal_array_symbol
                tmp9 = getVarScalar(interp, "clocal_array_symbol", compiledLocals, 3);
                tmp9.preserve();
                objv8[5] = tmp9;
                // Arg 8 constant: ", "
                objv8[6] = const6;
                // Arg 9 variable: $index
                tmp9 = getVarScalar(interp, "index", compiledLocals, 4);
                tmp9.preserve();
                objv8[7] = tmp9;
                // Arg 10 constant: ...
                objv8[8] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv8, compiledLocals, 5);
            } finally {
                tmp9 = objv8[1];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                tmp9 = objv8[3];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                tmp9 = objv8[5];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                tmp9 = objv8[7];
                if ( tmp9 != null ) {
                    tmp9.release();
                }
                TJC.releaseObjv(interp, objv8, 9);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp12 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp12);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_set_compiled_local_scalar_var");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" = ");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("setVarScalar(interp, \"");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_backslash_tcl_string");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("\", ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(", ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(");\n");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "varname",
        "valsym",
        "clocal_array_symbol",
        "index",
        "buffer"
    };
} // end class EmitterSetCompiledLocalScalarVarCmd

