// TJC implementation of procedure emitter_set_result
package tjc;
import tcl.lang.*;

public class EmitterSetResultCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "value value_is_string");
        }
        setVarScalar(interp, "value", objv[1], compiledLocals, 0);
        setVarScalar(interp, "value_is_string", objv[2], compiledLocals, 1);
        { // Invoke: if {$value_is_string} ...
            TclObject tmp0 = getVarScalar(interp, "value_is_string", compiledLocals, 1);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set value [...]
                    TclObject tmp2;
                    { // Invoke: ... $value
                        TclObject[] objv3 = TJC.grabObjv(interp, 2);
                        TclObject tmp4;
                        try {
                            // Arg 0 constant: ...
                            objv3[0] = const0;
                            // Arg 1 variable: $value
                            tmp4 = getVarScalar(interp, "value", compiledLocals, 0);
                            tmp4.preserve();
                            objv3[1] = tmp4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv3, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp4 = objv3[1];
                            if ( tmp4 != null ) {
                                tmp4.release();
                            }
                            TJC.releaseObjv(interp, objv3, 2);
                        }
                    } // End Invoke: ...
                    tmp2 = interp.getResult();
                    setVarScalar(interp, "value", tmp2, compiledLocals, 0);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "..."
            TclObject tmp5;
            StringBuffer sbtmp6 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv7 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv7[0] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv7, 1);
                }
            } // End Invoke: emitter_indent
            tmp5 = interp.getResult();
            sbtmp6.append(tmp5.toString());
            sbtmp6.append("interp.setResult(");
            tmp5 = getVarScalar(interp, "value", compiledLocals, 0);
            sbtmp6.append(tmp5.toString());
            sbtmp6.append(")");
            sbtmp6.append(";");
            sbtmp6.append("\n");
            tmp5 = TclString.newInstance(sbtmp6);
            interp.resetResult();
            interp.setResult(tmp5);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_set_result");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_double_quote_tcl_string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "value",
        "value_is_string"
    };
} // end class EmitterSetResultCmd

