// TJC implementation of procedure emitter_set_var
package tjc;
import tcl.lang.*;

public class EmitterSetVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 8) {
            throw new TclNumArgsException(interp, 1, objv, "tmpsymbol p1 is_p1_string p2 is_p2_string value iflags");
        }
        setVarScalar(interp, "tmpsymbol", objv[1], compiledLocals, 0);
        setVarScalar(interp, "p1", objv[2], compiledLocals, 1);
        setVarScalar(interp, "is_p1_string", objv[3], compiledLocals, 2);
        setVarScalar(interp, "p2", objv[4], compiledLocals, 3);
        setVarScalar(interp, "is_p2_string", objv[5], compiledLocals, 4);
        setVarScalar(interp, "value", objv[6], compiledLocals, 5);
        setVarScalar(interp, "iflags", objv[7], compiledLocals, 6);
        { // Invoke: if {$is_p1_string} ...
            TclObject tmp0 = getVarScalar(interp, "is_p1_string", compiledLocals, 2);
            boolean tmp1 = TJC.getBoolean(interp, tmp0);
            if ( tmp1 ) {
                { // Invoke: set p1 "..."
                    TclObject tmp2;
                    StringBuffer sbtmp3 = new StringBuffer(64);
                    sbtmp3.append("\"");
                    { // Invoke: ... $p1
                        TclObject[] objv4 = TJC.grabObjv(interp, 2);
                        TclObject tmp5;
                        try {
                            // Arg 0 constant: ...
                            objv4[0] = const0;
                            // Arg 1 variable: $p1
                            tmp5 = getVarScalar(interp, "p1", compiledLocals, 1);
                            tmp5.preserve();
                            objv4[1] = tmp5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv4, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp5 = objv4[1];
                            if ( tmp5 != null ) {
                                tmp5.release();
                            }
                            TJC.releaseObjv(interp, objv4, 2);
                        }
                    } // End Invoke: ...
                    tmp2 = interp.getResult();
                    sbtmp3.append(tmp2.toString());
                    sbtmp3.append("\"");
                    tmp2 = TclString.newInstance(sbtmp3);
                    setVarScalar(interp, "p1", tmp2, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$is_p2_string} ...
            TclObject tmp6 = getVarScalar(interp, "is_p2_string", compiledLocals, 4);
            boolean tmp7 = TJC.getBoolean(interp, tmp6);
            if ( tmp7 ) {
                { // Invoke: set p2 "..."
                    TclObject tmp8;
                    StringBuffer sbtmp9 = new StringBuffer(64);
                    sbtmp9.append("\"");
                    { // Invoke: ... $p2
                        TclObject[] objv10 = TJC.grabObjv(interp, 2);
                        TclObject tmp11;
                        try {
                            // Arg 0 constant: ...
                            objv10[0] = const0;
                            // Arg 1 variable: $p2
                            tmp11 = getVarScalar(interp, "p2", compiledLocals, 3);
                            tmp11.preserve();
                            objv10[1] = tmp11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv10, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp11 = objv10[1];
                            if ( tmp11 != null ) {
                                tmp11.release();
                            }
                            TJC.releaseObjv(interp, objv10, 2);
                        }
                    } // End Invoke: ...
                    tmp8 = interp.getResult();
                    sbtmp9.append(tmp8.toString());
                    sbtmp9.append("\"");
                    tmp8 = TclString.newInstance(sbtmp9);
                    setVarScalar(interp, "p2", tmp8, compiledLocals, 3);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif {$value == ""} ... else ...
            // Binary operator: () || ()
            // Binary operator: [...] == "\n"
            { // Invoke: string index $value 0
                TclObject tmp12 = getVarScalar(interp, "value", compiledLocals, 5);
                String tmp13 = tmp12.toString();
                TclObject tmp14 = TJC.stringIndex(interp, tmp13, const1);
                interp.setResult(tmp14);
            } // End Invoke: string
            TclObject tmp15 = interp.getResult();
            boolean tmp16 = tmp15.toString().equals("\n");
            ExprValue tmp17 = evs0;
            tmp17.setIntValue(tmp16);
            // End Binary operator: ==
            if (!tmp17.getBooleanValue(interp)) {
            // Binary operator: [...] == " "
            { // Invoke: string index $value 0
                TclObject tmp18 = getVarScalar(interp, "value", compiledLocals, 5);
                String tmp19 = tmp18.toString();
                TclObject tmp20 = TJC.stringIndex(interp, tmp19, const1);
                interp.setResult(tmp20);
            } // End Invoke: string
            TclObject tmp21 = interp.getResult();
            boolean tmp22 = tmp21.toString().equals(" ");
            ExprValue tmp23 = evs1;
            tmp23.setIntValue(tmp22);
            // End Binary operator: ==
            tmp17.setIntValue(tmp23.getBooleanValue(interp));
            } else {
            tmp17.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp24 = ( tmp17.getIntValue() != 0 );
            if ( tmp24 ) {
            } else {
                // Binary operator: $value == ""
                TclObject tmp25 = getVarScalar(interp, "value", compiledLocals, 5);
                ExprValue tmp26 = evs0;
                TJC.exprEqualsEmptyString(tmp26, tmp25, false);
                // End Binary operator: ==
                boolean tmp27 = ( tmp26.getIntValue() != 0 );
                if ( tmp27 ) {
                    { // Invoke: set value ...
                        setVarScalar(interp, "value", const2, compiledLocals, 5);
                    } // End Invoke: set
                } else {
                    { // Invoke: set value " $value"
                        TclObject tmp28;
                        StringBuffer sbtmp29 = new StringBuffer(64);
                        sbtmp29.append(" ");
                        tmp28 = getVarScalar(interp, "value", compiledLocals, 5);
                        sbtmp29.append(tmp28.toString());
                        tmp28 = TclString.newInstance(sbtmp29);
                        setVarScalar(interp, "value", tmp28, compiledLocals, 5);
                    } // End Invoke: set
                }
            }
        } // End Invoke: if
        { // Invoke: if {$tmpsymbol == {}} ... else ...
            // Binary operator: $tmpsymbol == ""
            TclObject tmp30 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
            ExprValue tmp31 = evs0;
            TJC.exprEqualsEmptyString(tmp31, tmp30, false);
            // End Binary operator: ==
            boolean tmp32 = ( tmp31.getIntValue() != 0 );
            if ( tmp32 ) {
                { // Invoke: set assign ""
                    setVarScalar(interp, "assign", const3, compiledLocals, 7);
                } // End Invoke: set
            } else {
                { // Invoke: set assign "$tmpsymbol = "
                    TclObject tmp33;
                    StringBuffer sbtmp34 = new StringBuffer(64);
                    tmp33 = getVarScalar(interp, "tmpsymbol", compiledLocals, 0);
                    sbtmp34.append(tmp33.toString());
                    sbtmp34.append(" = ");
                    tmp33 = TclString.newInstance(sbtmp34);
                    setVarScalar(interp, "assign", tmp33, compiledLocals, 7);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "..."
            TclObject tmp35;
            StringBuffer sbtmp36 = new StringBuffer(64);
            { // Invoke: emitter_indent
                TclObject[] objv37 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent
                    objv37[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv37, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv37, 1);
                }
            } // End Invoke: emitter_indent
            tmp35 = interp.getResult();
            sbtmp36.append(tmp35.toString());
            tmp35 = getVarScalar(interp, "assign", compiledLocals, 7);
            sbtmp36.append(tmp35.toString());
            sbtmp36.append("interp.setVar(");
            tmp35 = getVarScalar(interp, "p1", compiledLocals, 1);
            sbtmp36.append(tmp35.toString());
            sbtmp36.append(", ");
            tmp35 = getVarScalar(interp, "p2", compiledLocals, 3);
            sbtmp36.append(tmp35.toString());
            sbtmp36.append(",");
            tmp35 = getVarScalar(interp, "value", compiledLocals, 5);
            sbtmp36.append(tmp35.toString());
            sbtmp36.append(", ");
            tmp35 = getVarScalar(interp, "iflags", compiledLocals, 6);
            sbtmp36.append(tmp35.toString());
            sbtmp36.append(")");
            sbtmp36.append(";");
            sbtmp36.append("\n");
            tmp35 = TclString.newInstance(sbtmp36);
            interp.resetResult();
            interp.setResult(tmp35);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_set_var");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_backslash_tcl_string");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance(" \"\"");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            case 2: {
                cmdName = "emitter_indent";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tmpsymbol",
        "p1",
        "is_p1_string",
        "p2",
        "is_p2_string",
        "value",
        "iflags",
        "assign"
    };
} // end class EmitterSetVarCmd

