// TJC implementation of procedure jdk_config_var
package tjc;
import tcl.lang.*;

public class JdkConfigVarCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "name");
        }
        setVarScalar(interp, "name", objv[1], compiledLocals, 0);
        { // Invoke: global _jdk_config
            TJC.makeGlobalLinkVar(interp, "_jdk_config", "_jdk_config", 1);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: jdk_config_isvar $name
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: jdk_config_isvar
                    objv0[0] = const0;
                    // Arg 1 variable: $name
                    tmp1 = getVarScalar(interp, "name", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: jdk_config_isvar
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("var ");
                        sbtmp7.append("\"");
                        tmp6 = getVarScalar(interp, "name", compiledLocals, 0);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("\"");
                        sbtmp7.append(" is not a jdk config variable name");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists _jdk_config($name)
                TclObject[] objv8 = TJC.grabObjv(interp, 3);
                TclObject tmp9;
                try {
                    // Arg 0 constant: info
                    objv8[0] = const2;
                    // Arg 1 constant: exists
                    objv8[1] = const3;
                    // Arg 2 word: _jdk_config($name)
                    StringBuffer sbtmp10 = new StringBuffer(64);
                    sbtmp10.append("_jdk_config(");
                    tmp9 = getVarScalar(interp, "name", compiledLocals, 0);
                    sbtmp10.append(tmp9.toString());
                    sbtmp10.append(")");
                    tmp9 = TclString.newInstance(sbtmp10);
                    tmp9.preserve();
                    objv8[2] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv8, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp9 = objv8[2];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 3);
                }
            } // End Invoke: info
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            if ( tmp11.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp12, tmp11);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp12, tmp11);
            }
            // End Unary operator: !
            boolean tmp13 = ( tmp12.getIntValue() != 0 );
            if ( tmp13 ) {
                { // Invoke: return ""
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return $_jdk_config($name)
                    TclObject tmp14 = getVarScalar(interp, "name", compiledLocals, 0);
                    tmp14 = getVarArray(interp, "_jdk_config", tmp14.toString(), compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp14);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_config_var");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("jdk_config_isvar");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("info");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("exists");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "jdk_config_isvar";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "name",
        "_jdk_config"
    };
} // end class JdkConfigVarCmd

