// TJC implementation of procedure module_parse
package tjc;
import tcl.lang.*;

public class ModuleParseCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "data");
        }
        setVarScalar(interp, "data", objv[1], compiledLocals, 0);
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            { // Invoke: info exists _module
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const1;
                    // Arg 1 constant: exists
                    objv0[1] = const2;
                    // Arg 2 constant: _module
                    objv0[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            boolean tmp3 = tmp2.getBooleanValue(interp);
            if ( tmp3 ) {
                { // Invoke: unset _module
                    TclObject[] objv4 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv4[0] = const4;
                        // Arg 1 constant: _module
                        objv4[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv4, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv4, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: set _module(package) ""
            setVarArray(interp, "_module", "package", const5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set _module(options) ""
            setVarArray(interp, "_module", "options", const5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ... ""
            setVarArray(interp, "_module", "include_source", const5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set ... ""
            setVarArray(interp, "_module", "proc_options", const5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set lines [...]
            TclObject tmp5;
            { // Invoke: split $data ...
                TclObject[] objv6 = TJC.grabObjv(interp, 3);
                TclObject tmp7;
                try {
                    // Arg 0 constant: split
                    objv6[0] = const6;
                    // Arg 1 variable: $data
                    tmp7 = getVarScalar(interp, "data", compiledLocals, 0);
                    tmp7.preserve();
                    objv6[1] = tmp7;
                    // Arg 2 constant: ...
                    objv6[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv6, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp7 = objv6[1];
                    if ( tmp7 != null ) {
                        tmp7.release();
                    }
                    TJC.releaseObjv(interp, objv6, 3);
                }
            } // End Invoke: split
            tmp5 = interp.getResult();
            setVarScalar(interp, "lines", tmp5, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_cmds 0
            setVarScalar(interp, "num_cmds", const0, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set max [...]
            TclObject tmp8;
            { // Invoke: llength $lines
                TclObject tmp9 = getVarScalar(interp, "lines", compiledLocals, 3);
                int tmp10 = TclList.getLength(interp, tmp9);
                interp.setResult(tmp10);
            } // End Invoke: llength
            tmp8 = interp.getResult();
            setVarScalar(interp, "max", tmp8, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$debug} ...
            TclObject tmp11 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp12 = TJC.getBoolean(interp, tmp11);
            if ( tmp12 ) {
                { // Invoke: puts "..."
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: puts
                        objv13[0] = const8;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        tmp14 = getVarScalar(interp, "max", compiledLocals, 5);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append(" lines of module data:");
                        tmp14 = TclString.newInstance(sbtmp15);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv13, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: puts
                { // Invoke: foreach line $lines ...
                    TclObject tmp16 = null;
                    try {
                        tmp16 = getVarScalar(interp, "lines", compiledLocals, 3);
                        tmp16.preserve();
                        final int tmp16_length = TclList.getLength(interp, tmp16);

                        for ( int index17 = 0 ; index17 < tmp16_length ; index17++ ) {
                            TclObject tmp18 = TclList.index(interp, tmp16, index17);
                            try {
                                setVarScalar(interp, "line", tmp18, compiledLocals, 6);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "line");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: puts "->$line<-"
                                TclObject[] objv19 = TJC.grabObjv(interp, 2);
                                TclObject tmp20;
                                try {
                                    // Arg 0 constant: puts
                                    objv19[0] = const8;
                                    // Arg 1 word: "->$line<-"
                                    StringBuffer sbtmp21 = new StringBuffer(64);
                                    sbtmp21.append("->");
                                    tmp20 = getVarScalar(interp, "line", compiledLocals, 6);
                                    sbtmp21.append(tmp20.toString());
                                    sbtmp21.append("<-");
                                    tmp20 = TclString.newInstance(sbtmp21);
                                    tmp20.preserve();
                                    objv19[1] = tmp20;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv19, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp20 = objv19[1];
                                    if ( tmp20 != null ) {
                                        tmp20.release();
                                    }
                                    TJC.releaseObjv(interp, objv19, 2);
                                }
                            } // End Invoke: puts
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: for {set i 0} {$i < $max} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const0, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip27 = true ; true ; ) {
                if ( skip27 ) {
                    skip27 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $max
                TclObject tmp22 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp23 = evs0;
                TJC.exprInitValue(interp, tmp23, tmp22);
                TclObject tmp24 = getVarScalar(interp, "max", compiledLocals, 5);
                ExprValue tmp25 = evs1;
                TJC.exprInitValue(interp, tmp25, tmp24);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp23, tmp25);
                // End Binary operator: <
                boolean tmp26 = ( tmp23.getIntValue() != 0 );
                if ( ! tmp26 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set line [...]
                    TclObject tmp28;
                    { // Invoke: string trim [...]
                        TclObject[] objv29 = TJC.grabObjv(interp, 3);
                        TclObject tmp30;
                        try {
                            // Arg 0 constant: string
                            objv29[0] = const9;
                            // Arg 1 constant: trim
                            objv29[1] = const10;
                            // Arg 2 command: [...]
                            { // Invoke: lindex $lines $i
                                TclObject tmp31 = null;
                                TclObject tmp32;
                                try {
                                    tmp31 = getVarScalar(interp, "lines", compiledLocals, 3);
                                    tmp31.preserve();
                                    tmp32 = getVarScalar(interp, "i", compiledLocals, 7);
                                    TJC.lindexNonconst(interp, tmp31, tmp32);
                                } finally {
                                    if ( tmp31 != null ) {
                                        tmp31.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp30 = interp.getResult();
                            tmp30.preserve();
                            objv29[2] = tmp30;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv29, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp30 = objv29[2];
                            if ( tmp30 != null ) {
                                tmp30.release();
                            }
                            TJC.releaseObjv(interp, objv29, 3);
                        }
                    } // End Invoke: string
                    tmp28 = interp.getResult();
                    setVarScalar(interp, "line", tmp28, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... elseif ... ...
                    // Binary operator: [...] == 0
                    { // Invoke: string length $line
                        TclObject tmp33 = getVarScalar(interp, "line", compiledLocals, 6);
                        int tmp34 = tmp33.toString().length();
                        interp.setResult(tmp34);
                    } // End Invoke: string
                    TclObject tmp35 = interp.getResult();
                    ExprValue tmp36 = evs0;
                    TJC.exprInitValue(interp, tmp36, tmp35);
                    ExprValue tmp37 = evs1;
                    tmp37.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp36, tmp37);
                    // End Binary operator: ==
                    boolean tmp38 = ( tmp36.getIntValue() != 0 );
                    if ( tmp38 ) {
                        { // Invoke: continue
                            if ( true ) { continue; }
                        } // End Invoke: continue
                    } else {
                        // Binary operator: [...] == "#"
                        { // Invoke: string index $line 0
                            TclObject tmp39 = getVarScalar(interp, "line", compiledLocals, 6);
                            String tmp40 = tmp39.toString();
                            TclObject tmp41 = TJC.stringIndex(interp, tmp40, const0);
                            interp.setResult(tmp41);
                        } // End Invoke: string
                        TclObject tmp42 = interp.getResult();
                        boolean tmp43 = tmp42.toString().equals("#");
                        ExprValue tmp44 = evs0;
                        tmp44.setIntValue(tmp43);
                        // End Binary operator: ==
                        boolean tmp45 = ( tmp44.getIntValue() != 0 );
                        if ( tmp45 ) {
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        } else {
                            // Binary operator: [...] == "\\"
                            { // Invoke: string index $line end
                                TclObject tmp46 = getVarScalar(interp, "line", compiledLocals, 6);
                                String tmp47 = tmp46.toString();
                                TclObject tmp48 = TJC.stringIndex(interp, tmp47, const11);
                                interp.setResult(tmp48);
                            } // End Invoke: string
                            TclObject tmp49 = interp.getResult();
                            boolean tmp50 = tmp49.toString().equals("\\");
                            ExprValue tmp51 = evs0;
                            tmp51.setIntValue(tmp50);
                            // End Binary operator: ==
                            boolean tmp52 = ( tmp51.getIntValue() != 0 );
                            if ( tmp52 ) {
                                { // Invoke: set line [...]
                                    TclObject tmp53;
                                    { // Invoke: string range $line 0 end-1
                                        TclObject tmp54 = getVarScalar(interp, "line", compiledLocals, 6);
                                        String tmp55 = tmp54.toString();
                                        TclObject tmp56 = const0;
                                        tmp56.preserve();
                                        TclObject tmp57 = const12;
                                        TclObject tmp58 = TJC.stringRange(interp, tmp55, tmp56, tmp57);
                                        interp.setResult(tmp58);
                                    } // End Invoke: string
                                    tmp53 = interp.getResult();
                                    setVarScalar(interp, "line", tmp53, compiledLocals, 6);
                                } // End Invoke: set
                                { // Invoke: if {$debug} ...
                                    TclObject tmp59 = getVarScalar(interp, "debug", compiledLocals, 2);
                                    boolean tmp60 = TJC.getBoolean(interp, tmp59);
                                    if ( tmp60 ) {
                                        { // Invoke: puts ...
                                            TclObject[] objv61 = TJC.grabObjv(interp, 2);
                                            try {
                                                // Arg 0 constant: puts
                                                objv61[0] = const8;
                                                // Arg 1 constant: ...
                                                objv61[1] = const13;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv61, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv61, 2);
                                            }
                                        } // End Invoke: puts
                                        { // Invoke: puts "->$line<-"
                                            TclObject[] objv62 = TJC.grabObjv(interp, 2);
                                            TclObject tmp63;
                                            try {
                                                // Arg 0 constant: puts
                                                objv62[0] = const8;
                                                // Arg 1 word: "->$line<-"
                                                StringBuffer sbtmp64 = new StringBuffer(64);
                                                sbtmp64.append("->");
                                                tmp63 = getVarScalar(interp, "line", compiledLocals, 6);
                                                sbtmp64.append(tmp63.toString());
                                                sbtmp64.append("<-");
                                                tmp63 = TclString.newInstance(sbtmp64);
                                                tmp63.preserve();
                                                objv62[1] = tmp63;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv62, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp63 = objv62[1];
                                                if ( tmp63 != null ) {
                                                    tmp63.release();
                                                }
                                                TJC.releaseObjv(interp, objv62, 2);
                                            }
                                        } // End Invoke: puts
                                    }
                                } // End Invoke: if
                                { // Invoke: for ... {$i < $max} {incr i} ...
                                    { // Invoke: set i [...]
                                        TclObject tmp65;
                                        { // Invoke: expr {$i + 1}
                                            // Binary operator: $i + 1
                                            TclObject tmp66 = getVarScalar(interp, "i", compiledLocals, 7);
                                            ExprValue tmp67 = evs0;
                                            TJC.exprInitValue(interp, tmp67, tmp66);
                                            ExprValue tmp68 = evs1;
                                            tmp68.setIntValue(1);
                                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp67, tmp68);
                                            // End Binary operator: +
                                            TJC.exprSetResult(interp, tmp67);
                                        } // End Invoke: expr
                                        tmp65 = interp.getResult();
                                        setVarScalar(interp, "i", tmp65, compiledLocals, 7);
                                    } // End Invoke: set
                                    for ( boolean skip74 = true ; true ; ) {
                                        if ( skip74 ) {
                                            skip74 = false;
                                        } else {
                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: incr i
                                                interp.resetResult();
                                                incrVarScalar(interp, "i", 1, compiledLocals, 7);
                                            } // End Invoke: incr
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }

                                        // Binary operator: $i < $max
                                        TclObject tmp69 = getVarScalar(interp, "i", compiledLocals, 7);
                                        ExprValue tmp70 = evs0;
                                        TJC.exprInitValue(interp, tmp70, tmp69);
                                        TclObject tmp71 = getVarScalar(interp, "max", compiledLocals, 5);
                                        ExprValue tmp72 = evs1;
                                        TJC.exprInitValue(interp, tmp72, tmp71);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp70, tmp72);
                                        // End Binary operator: <
                                        boolean tmp73 = ( tmp70.getIntValue() != 0 );
                                        if ( ! tmp73 ) { break; }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: set next_line [...]
                                            TclObject tmp75;
                                            { // Invoke: string trim [...]
                                                TclObject[] objv76 = TJC.grabObjv(interp, 3);
                                                TclObject tmp77;
                                                try {
                                                    // Arg 0 constant: string
                                                    objv76[0] = const9;
                                                    // Arg 1 constant: trim
                                                    objv76[1] = const10;
                                                    // Arg 2 command: [...]
                                                    { // Invoke: lindex $lines $i
                                                        TclObject tmp78 = null;
                                                        TclObject tmp79;
                                                        try {
                                                            tmp78 = getVarScalar(interp, "lines", compiledLocals, 3);
                                                            tmp78.preserve();
                                                            tmp79 = getVarScalar(interp, "i", compiledLocals, 7);
                                                            TJC.lindexNonconst(interp, tmp78, tmp79);
                                                        } finally {
                                                            if ( tmp78 != null ) {
                                                                tmp78.release();
                                                            }
                                                        }
                                                    } // End Invoke: lindex
                                                    tmp77 = interp.getResult();
                                                    tmp77.preserve();
                                                    objv76[2] = tmp77;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                                        ? cmdcache5.cmd : null), objv76, 0);
                                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                                        updateCmdCache(interp, 5);
                                                    }
                                                } finally {
                                                    tmp77 = objv76[2];
                                                    if ( tmp77 != null ) {
                                                        tmp77.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv76, 3);
                                                }
                                            } // End Invoke: string
                                            tmp75 = interp.getResult();
                                            setVarScalar(interp, "next_line", tmp75, compiledLocals, 8);
                                        } // End Invoke: set
                                        { // Invoke: if ... ...
                                            // Binary operator: [...] == "#"
                                            { // Invoke: string index $next_line 0
                                                TclObject tmp80 = getVarScalar(interp, "next_line", compiledLocals, 8);
                                                String tmp81 = tmp80.toString();
                                                TclObject tmp82 = TJC.stringIndex(interp, tmp81, const0);
                                                interp.setResult(tmp82);
                                            } // End Invoke: string
                                            TclObject tmp83 = interp.getResult();
                                            boolean tmp84 = tmp83.toString().equals("#");
                                            ExprValue tmp85 = evs0;
                                            tmp85.setIntValue(tmp84);
                                            // End Binary operator: ==
                                            boolean tmp86 = ( tmp85.getIntValue() != 0 );
                                            if ( tmp86 ) {
                                                { // Invoke: continue
                                                    if ( true ) { continue; }
                                                } // End Invoke: continue
                                            }
                                        } // End Invoke: if
                                        { // Invoke: if ... ... else ...
                                            // Binary operator: [...] == "\\"
                                            { // Invoke: string index $next_line end
                                                TclObject tmp87 = getVarScalar(interp, "next_line", compiledLocals, 8);
                                                String tmp88 = tmp87.toString();
                                                TclObject tmp89 = TJC.stringIndex(interp, tmp88, const11);
                                                interp.setResult(tmp89);
                                            } // End Invoke: string
                                            TclObject tmp90 = interp.getResult();
                                            boolean tmp91 = tmp90.toString().equals("\\");
                                            ExprValue tmp92 = evs0;
                                            tmp92.setIntValue(tmp91);
                                            // End Binary operator: ==
                                            boolean tmp93 = ( tmp92.getIntValue() != 0 );
                                            if ( tmp93 ) {
                                                { // Invoke: set next_line [...]
                                                    TclObject tmp94;
                                                    { // Invoke: string range $next_line 0 end-1
                                                        TclObject tmp95 = getVarScalar(interp, "next_line", compiledLocals, 8);
                                                        String tmp96 = tmp95.toString();
                                                        TclObject tmp97 = const0;
                                                        tmp97.preserve();
                                                        TclObject tmp98 = const12;
                                                        TclObject tmp99 = TJC.stringRange(interp, tmp96, tmp97, tmp98);
                                                        interp.setResult(tmp99);
                                                    } // End Invoke: string
                                                    tmp94 = interp.getResult();
                                                    setVarScalar(interp, "next_line", tmp94, compiledLocals, 8);
                                                } // End Invoke: set
                                                { // Invoke: set continued 1
                                                    setVarScalar(interp, "continued", const14, compiledLocals, 9);
                                                } // End Invoke: set
                                            } else {
                                                { // Invoke: set continued 0
                                                    setVarScalar(interp, "continued", const0, compiledLocals, 9);
                                                } // End Invoke: set
                                            }
                                        } // End Invoke: if
                                        { // Invoke: append line $next_line
                                            TclObject[] objv100 = TJC.grabObjv(interp, 1);
                                            TclObject tmp101;
                                            try {
                                                // Arg 2 variable: $next_line
                                                tmp101 = getVarScalar(interp, "next_line", compiledLocals, 8);
                                                tmp101.preserve();
                                                objv100[0] = tmp101;
                                                interp.resetResult();
                                                appendVarScalar(interp, "line", objv100, compiledLocals, 6);
                                            } finally {
                                                TJC.releaseObjvElems(interp, objv100, 1);
                                            }
                                        } // End Invoke: append
                                        { // Invoke: if {$debug} ...
                                            TclObject tmp102 = getVarScalar(interp, "debug", compiledLocals, 2);
                                            boolean tmp103 = TJC.getBoolean(interp, tmp102);
                                            if ( tmp103 ) {
                                                { // Invoke: puts "appending:"
                                                    TclObject[] objv104 = TJC.grabObjv(interp, 2);
                                                    try {
                                                        // Arg 0 constant: puts
                                                        objv104[0] = const8;
                                                        // Arg 1 constant: "appending:"
                                                        objv104[1] = const15;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                            ? cmdcache4.cmd : null), objv104, 0);
                                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                            updateCmdCache(interp, 4);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv104, 2);
                                                    }
                                                } // End Invoke: puts
                                                { // Invoke: puts "->$next_line<-"
                                                    TclObject[] objv105 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp106;
                                                    try {
                                                        // Arg 0 constant: puts
                                                        objv105[0] = const8;
                                                        // Arg 1 word: "->$next_line<-"
                                                        StringBuffer sbtmp107 = new StringBuffer(64);
                                                        sbtmp107.append("->");
                                                        tmp106 = getVarScalar(interp, "next_line", compiledLocals, 8);
                                                        sbtmp107.append(tmp106.toString());
                                                        sbtmp107.append("<-");
                                                        tmp106 = TclString.newInstance(sbtmp107);
                                                        tmp106.preserve();
                                                        objv105[1] = tmp106;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                            ? cmdcache4.cmd : null), objv105, 0);
                                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                            updateCmdCache(interp, 4);
                                                        }
                                                    } finally {
                                                        tmp106 = objv105[1];
                                                        if ( tmp106 != null ) {
                                                            tmp106.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv105, 2);
                                                    }
                                                } // End Invoke: puts
                                                { // Invoke: puts ...
                                                    TclObject[] objv108 = TJC.grabObjv(interp, 2);
                                                    try {
                                                        // Arg 0 constant: puts
                                                        objv108[0] = const8;
                                                        // Arg 1 constant: ...
                                                        objv108[1] = const16;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                            ? cmdcache4.cmd : null), objv108, 0);
                                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                            updateCmdCache(interp, 4);
                                                        }
                                                    } finally {
                                                        TJC.releaseObjv(interp, objv108, 2);
                                                    }
                                                } // End Invoke: puts
                                                { // Invoke: puts "->$line<-"
                                                    TclObject[] objv109 = TJC.grabObjv(interp, 2);
                                                    TclObject tmp110;
                                                    try {
                                                        // Arg 0 constant: puts
                                                        objv109[0] = const8;
                                                        // Arg 1 word: "->$line<-"
                                                        StringBuffer sbtmp111 = new StringBuffer(64);
                                                        sbtmp111.append("->");
                                                        tmp110 = getVarScalar(interp, "line", compiledLocals, 6);
                                                        sbtmp111.append(tmp110.toString());
                                                        sbtmp111.append("<-");
                                                        tmp110 = TclString.newInstance(sbtmp111);
                                                        tmp110.preserve();
                                                        objv109[1] = tmp110;
                                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                            updateCmdCache(interp, 0);
                                                        }
                                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                            ? cmdcache4.cmd : null), objv109, 0);
                                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                            updateCmdCache(interp, 4);
                                                        }
                                                    } finally {
                                                        tmp110 = objv109[1];
                                                        if ( tmp110 != null ) {
                                                            tmp110.release();
                                                        }
                                                        TJC.releaseObjv(interp, objv109, 2);
                                                    }
                                                } // End Invoke: puts
                                            }
                                        } // End Invoke: if
                                        { // Invoke: if {!$continued} ...
                                            // Unary operator: ! $continued
                                            TclObject tmp112 = getVarScalar(interp, "continued", compiledLocals, 9);
                                            ExprValue tmp113 = evs0;
                                            if ( tmp112.isIntType() ) {
                                                TJC.exprUnaryNotOperatorKnownInt(tmp113, tmp112);
                                            } else {
                                                TJC.exprUnaryNotOperator(interp, tmp113, tmp112);
                                            }
                                            // End Unary operator: !
                                            boolean tmp114 = ( tmp113.getIntValue() != 0 );
                                            if ( tmp114 ) {
                                                { // Invoke: break
                                                    if ( true ) { break; }
                                                } // End Invoke: break
                                            }
                                        } // End Invoke: if
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } // End Invoke: for
                            }
                        }
                    }
                } // End Invoke: if
                { // Invoke: if {$debug} ...
                    TclObject tmp115 = getVarScalar(interp, "debug", compiledLocals, 2);
                    boolean tmp116 = TJC.getBoolean(interp, tmp115);
                    if ( tmp116 ) {
                        { // Invoke: puts "parsed command:"
                            TclObject[] objv117 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: puts
                                objv117[0] = const8;
                                // Arg 1 constant: "parsed command:"
                                objv117[1] = const17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv117, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv117, 2);
                            }
                        } // End Invoke: puts
                        { // Invoke: puts "->$line<-"
                            TclObject[] objv118 = TJC.grabObjv(interp, 2);
                            TclObject tmp119;
                            try {
                                // Arg 0 constant: puts
                                objv118[0] = const8;
                                // Arg 1 word: "->$line<-"
                                StringBuffer sbtmp120 = new StringBuffer(64);
                                sbtmp120.append("->");
                                tmp119 = getVarScalar(interp, "line", compiledLocals, 6);
                                sbtmp120.append(tmp119.toString());
                                sbtmp120.append("<-");
                                tmp119 = TclString.newInstance(sbtmp120);
                                tmp119.preserve();
                                objv118[1] = tmp119;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv118, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp119 = objv118[1];
                                if ( tmp119 != null ) {
                                    tmp119.release();
                                }
                                TJC.releaseObjv(interp, objv118, 2);
                            }
                        } // End Invoke: puts
                    }
                } // End Invoke: if
                { // Invoke: module_parse_command $line [...]
                    TclObject[] objv121 = TJC.grabObjv(interp, 3);
                    TclObject tmp122;
                    try {
                        // Arg 0 constant: module_parse_command
                        objv121[0] = const18;
                        // Arg 1 variable: $line
                        tmp122 = getVarScalar(interp, "line", compiledLocals, 6);
                        tmp122.preserve();
                        objv121[1] = tmp122;
                        // Arg 2 command: [...]
                        { // Invoke: expr {$i + 1}
                            // Binary operator: $i + 1
                            TclObject tmp123 = getVarScalar(interp, "i", compiledLocals, 7);
                            ExprValue tmp124 = evs0;
                            TJC.exprInitValue(interp, tmp124, tmp123);
                            ExprValue tmp125 = evs1;
                            tmp125.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp124, tmp125);
                            // End Binary operator: +
                            TJC.exprSetResult(interp, tmp124);
                        } // End Invoke: expr
                        tmp122 = interp.getResult();
                        tmp122.preserve();
                        objv121[2] = tmp122;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv121, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp122 = objv121[1];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        tmp122 = objv121[2];
                        if ( tmp122 != null ) {
                            tmp122.release();
                        }
                        TJC.releaseObjv(interp, objv121, 3);
                    }
                } // End Invoke: module_parse_command
                { // Invoke: incr num_cmds
                    interp.resetResult();
                    incrVarScalar(interp, "num_cmds", 1, compiledLocals, 4);
                } // End Invoke: incr
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $num_cmds
            TclObject tmp126 = getVarScalar(interp, "num_cmds", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp126);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_parse");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_module");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("unset");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("split");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("puts");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("string");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("trim");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("end");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("end-1");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("continued line starts as:");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(1);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("appending:");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("continued line is now:");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("parsed command:");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("module_parse_command");
        const18.preserve(); const18.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "unset";
                break;
            }
            case 3: {
                cmdName = "split";
                break;
            }
            case 4: {
                cmdName = "puts";
                break;
            }
            case 5: {
                cmdName = "string";
                break;
            }
            case 6: {
                cmdName = "module_parse_command";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "data",
        "_module",
        "debug",
        "lines",
        "num_cmds",
        "max",
        "line",
        "i",
        "next_line",
        "continued"
    };
} // end class ModuleParseCmd

