// TJC implementation of procedure module_parse_file
package tjc;
import tcl.lang.*;

public class ModuleParseFileCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "file");
        }
        setVarScalar(interp, "file", objv[1], compiledLocals, 0);
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 1);
        } // End Invoke: global
        { // Invoke: set _module(fileename) [...]
            TclObject tmp0;
            { // Invoke: file tail $file
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: file
                    objv1[0] = const0;
                    // Arg 1 constant: tail
                    objv1[1] = const1;
                    // Arg 2 variable: $file
                    tmp2 = getVarScalar(interp, "file", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: file
            tmp0 = interp.getResult();
            setVarArray(interp, "_module", "fileename", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: module_parse [...]
                TclObject[] objv3 = TJC.grabObjv(interp, 2);
                TclObject tmp4;
                try {
                    // Arg 0 constant: module_parse
                    objv3[0] = const2;
                    // Arg 1 command: [...]
                    { // Invoke: tjc_util_file_read $file
                        TclObject[] objv5 = TJC.grabObjv(interp, 2);
                        TclObject tmp6;
                        try {
                            // Arg 0 constant: tjc_util_file_read
                            objv5[0] = const3;
                            // Arg 1 variable: $file
                            tmp6 = getVarScalar(interp, "file", compiledLocals, 0);
                            tmp6.preserve();
                            objv5[1] = tmp6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv5, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp6 = objv5[1];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            TJC.releaseObjv(interp, objv5, 2);
                        }
                    } // End Invoke: tjc_util_file_read
                    tmp4 = interp.getResult();
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv3, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 2);
                }
            } // End Invoke: module_parse
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_parse_file");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("file");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("tail");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("module_parse");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("tjc_util_file_read");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "file";
                break;
            }
            case 2: {
                cmdName = "tjc_util_file_read";
                break;
            }
            case 3: {
                cmdName = "module_parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "file",
        "_module"
    };
} // end class ModuleParseFileCmd

