// TJC implementation of procedure module_query
package tjc;
import tcl.lang.*;

public class ModuleQueryCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "cmd");
        }
        setVarScalar(interp, "cmd", objv[1], compiledLocals, 0);
        { // Invoke: global _module
            TJC.makeGlobalLinkVar(interp, "_module", "_module", 1);
        } // End Invoke: global
        { // Invoke: switch -exact -- $cmd {PACKAGE} ... {OPTIONS} ... {SOURCE} ... {INCLUDE_SOURCE} ... {INIT_SOURCE} ... {PROC_OPTIONS} ... default ...
            TclObject tmp0 = getVarScalar(interp, "cmd", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( tmp1_length == 7 && tmp1_first == 'P'
                    && tmp1.compareTo("PACKAGE") == 0 ) {
                // Pattern {PACKAGE}
                { // Invoke: return $_module(package)
                    TclObject tmp2 = getVarArray(interp, "_module", "package", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp2);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 7 && tmp1_first == 'O'
                    && tmp1.compareTo("OPTIONS") == 0 ) {
                // Pattern {OPTIONS}
                { // Invoke: return $_module(options)
                    TclObject tmp3 = getVarArray(interp, "_module", "options", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp3);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 6 && tmp1_first == 'S'
                    && tmp1.compareTo("SOURCE") == 0 ) {
                // Pattern {SOURCE}
                { // Invoke: return $_module(source)
                    TclObject tmp4 = getVarArray(interp, "_module", "source", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp4);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 14 && tmp1_first == 'I'
                    && tmp1.compareTo("INCLUDE_SOURCE") == 0 ) {
                // Pattern {INCLUDE_SOURCE}
                { // Invoke: return $...
                    TclObject tmp5 = getVarArray(interp, "_module", "include_source", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp5);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 11 && tmp1_first == 'I'
                    && tmp1.compareTo("INIT_SOURCE") == 0 ) {
                // Pattern {INIT_SOURCE}
                { // Invoke: return $...
                    TclObject tmp6 = getVarArray(interp, "_module", "init_source", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp6);
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp1_length == 12 && tmp1_first == 'P'
                    && tmp1.compareTo("PROC_OPTIONS") == 0 ) {
                // Pattern {PROC_OPTIONS}
                { // Invoke: return $...
                    TclObject tmp7 = getVarArray(interp, "_module", "proc_options", compiledLocals, 1);
                    interp.resetResult();
                    interp.setResult(tmp7);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv8 = TJC.grabObjv(interp, 2);
                    TclObject tmp9;
                    try {
                        // Arg 0 constant: error
                        objv8[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp10 = new StringBuffer(64);
                        sbtmp10.append("unsupported cmd ");
                        sbtmp10.append("\"");
                        tmp9 = getVarScalar(interp, "cmd", compiledLocals, 0);
                        sbtmp10.append(tmp9.toString());
                        sbtmp10.append("\"");
                        tmp9 = TclString.newInstance(sbtmp10);
                        tmp9.preserve();
                        objv8[1] = tmp9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv8, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp9 = objv8[1];
                        if ( tmp9 != null ) {
                            tmp9.release();
                        }
                        TJC.releaseObjv(interp, objv8, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_query");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cmd",
        "_module"
    };
} // end class ModuleQueryCmd

