// TJC implementation of procedure _parse_expr_iterate_is_math_function
package tjc;
import tcl.lang.*;

public class ParseExprIterateIsMathFunctionCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "operator");
        }
        setVarScalar(interp, "operator", objv[1], compiledLocals, 0);
        { // Invoke: switch -exact -- $operator {abs} - {acos} - {asin} - {atan} - {atan2} - {ceil} - {cos} - {cosh} - {double} - {exp} - {floor} - {fmod} - {hypot} - {int} - {log} - {log10} - {pow} - {rand} - {round} - {sin} - {sinh} - {sqrt} - {srand} - {tan} - {tanh} - {wide} ... default ...
            TclObject tmp0 = getVarScalar(interp, "operator", compiledLocals, 0);
            String tmp1 = tmp0.toString();
            int tmp1_length = tmp1.length();
            char tmp1_first = '\n';
            if ( tmp1_length > 0 ) {
                tmp1_first = tmp1.charAt(0);
            }
            interp.resetResult();
            if ( ( tmp1_length == 3 && tmp1_first == 'a'
                    && tmp1.compareTo("abs") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'a'
                    && tmp1.compareTo("acos") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'a'
                    && tmp1.compareTo("asin") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'a'
                    && tmp1.compareTo("atan") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'a'
                    && tmp1.compareTo("atan2") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'c'
                    && tmp1.compareTo("ceil") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'c'
                    && tmp1.compareTo("cos") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'c'
                    && tmp1.compareTo("cosh") == 0 ) ||
                ( tmp1_length == 6 && tmp1_first == 'd'
                    && tmp1.compareTo("double") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'e'
                    && tmp1.compareTo("exp") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'f'
                    && tmp1.compareTo("floor") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'f'
                    && tmp1.compareTo("fmod") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'h'
                    && tmp1.compareTo("hypot") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'i'
                    && tmp1.compareTo("int") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'l'
                    && tmp1.compareTo("log") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'l'
                    && tmp1.compareTo("log10") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 'p'
                    && tmp1.compareTo("pow") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'r'
                    && tmp1.compareTo("rand") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 'r'
                    && tmp1.compareTo("round") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 's'
                    && tmp1.compareTo("sin") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 's'
                    && tmp1.compareTo("sinh") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 's'
                    && tmp1.compareTo("sqrt") == 0 ) ||
                ( tmp1_length == 5 && tmp1_first == 's'
                    && tmp1.compareTo("srand") == 0 ) ||
                ( tmp1_length == 3 && tmp1_first == 't'
                    && tmp1.compareTo("tan") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 't'
                    && tmp1.compareTo("tanh") == 0 ) ||
                ( tmp1_length == 4 && tmp1_first == 'w'
                    && tmp1.compareTo("wide") == 0 ) ) {
                // Pattern {wide}
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_expr_iterate_is_math_function");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    String[] compiledLocalsNames = {
        "operator"
    };
} // end class ParseExprIterateIsMathFunctionCmd

