// TJC implementation of procedure parse_get_text
package tjc;
import tcl.lang.*;

public class ParseGetTextCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script stree");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: parse_is_text $stree
                TclObject[] objv0 = TJC.grabObjv(interp, 2);
                TclObject tmp1;
                try {
                    // Arg 0 constant: parse_is_text
                    objv0[0] = const0;
                    // Arg 1 variable: $stree
                    tmp1 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp1.preserve();
                    objv0[1] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[1];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 2);
                }
            } // End Invoke: parse_is_text
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("not a text type stree : ");
                        sbtmp7.append("{");
                        tmp6 = getVarScalar(interp, "stree", compiledLocals, 1);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("}");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp8;
            { // Invoke: lindex $stree 1
                TclObject tmp9 = getVarScalar(interp, "stree", compiledLocals, 1);
                tmp9 = TclList.index(interp, tmp9, 1);
                if ( tmp9 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp9);
                }
            } // End Invoke: lindex
            tmp8 = interp.getResult();
            setVarScalar(interp, "range", tmp8, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: parse getstring $script $range
                TclObject[] objv10 = TJC.grabObjv(interp, 4);
                TclObject tmp11;
                try {
                    // Arg 0 constant: parse
                    objv10[0] = const2;
                    // Arg 1 constant: getstring
                    objv10[1] = const3;
                    // Arg 2 variable: $script
                    tmp11 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp11.preserve();
                    objv10[2] = tmp11;
                    // Arg 3 variable: $range
                    tmp11 = getVarScalar(interp, "range", compiledLocals, 2);
                    tmp11.preserve();
                    objv10[3] = tmp11;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv10, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp11 = objv10[2];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    tmp11 = objv10[3];
                    if ( tmp11 != null ) {
                        tmp11.release();
                    }
                    TJC.releaseObjv(interp, objv10, 4);
                }
            } // End Invoke: parse
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_text");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse_is_text");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("parse");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("getstring");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse_is_text";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "parse";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "range"
    };
} // end class ParseGetTextCmd

