// TJC implementation of procedure parse_is_variable
package tjc;
import tcl.lang.*;

public class ParseIsVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Binary operator: [...] ne "variable"
            { // Invoke: lindex $stree 0
                TclObject tmp0 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp0 = TclList.index(interp, tmp0, 0);
                if ( tmp0 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp0);
                }
            } // End Invoke: lindex
            TclObject tmp1 = interp.getResult();
            boolean tmp2 = ! tmp1.toString().equals("variable");
            ExprValue tmp3 = evs0;
            tmp3.setIntValue(tmp2);
            // End Binary operator: ne
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set range [...]
            TclObject tmp5;
            { // Invoke: lindex $stree 1
                TclObject tmp6 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp6 = TclList.index(interp, tmp6, 1);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "range", tmp5, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != 2
            { // Invoke: llength $range
                TclObject tmp7 = getVarScalar(interp, "range", compiledLocals, 1);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            TclObject tmp9 = interp.getResult();
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp10, tmp11);
            // End Binary operator: !=
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: error "..."
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: error
                        objv13[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        sbtmp15.append("unexpected range ");
                        sbtmp15.append("{");
                        tmp14 = getVarScalar(interp, "range", compiledLocals, 1);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append("}");
                        sbtmp15.append(" for variable subtree ");
                        sbtmp15.append("{");
                        tmp14 = getVarScalar(interp, "stree", compiledLocals, 0);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append("}");
                        tmp14 = TclString.newInstance(sbtmp15);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] == ""
            { // Invoke: lindex $stree 2
                TclObject tmp16 = getVarScalar(interp, "stree", compiledLocals, 0);
                tmp16 = TclList.index(interp, tmp16, 2);
                if ( tmp16 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp16);
                }
            } // End Invoke: lindex
            TclObject tmp17 = interp.getResult();
            ExprValue tmp18 = evs0;
            TJC.exprEqualsEmptyString(tmp18, tmp17, false);
            // End Binary operator: ==
            boolean tmp19 = ( tmp18.getIntValue() != 0 );
            if ( tmp19 ) {
                { // Invoke: error "..."
                    TclObject[] objv20 = TJC.grabObjv(interp, 2);
                    TclObject tmp21;
                    try {
                        // Arg 0 constant: error
                        objv20[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp22 = new StringBuffer(64);
                        sbtmp22.append("unexpected empty inner_tree for variable subtree ");
                        sbtmp22.append("{");
                        tmp21 = getVarScalar(interp, "stree", compiledLocals, 0);
                        sbtmp22.append(tmp21.toString());
                        sbtmp22.append("}");
                        tmp21 = TclString.newInstance(sbtmp22);
                        tmp21.preserve();
                        objv20[1] = tmp21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv20, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp21 = objv20[1];
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                        TJC.releaseObjv(interp, objv20, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const2);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "stree",
        "range"
    };
} // end class ParseIsVariableCmd

