// TJC implementation of procedure parseproc_init
package tjc;
import tcl.lang.*;

public class ParseprocInitCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _parseproc
            TJC.makeGlobalLinkVar(interp, "_parseproc", "_parseproc", 0);
        } // End Invoke: global
        { // Invoke: if ... ...
            { // Invoke: info exists _parseproc
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: _parseproc
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            boolean tmp3 = tmp2.getBooleanValue(interp);
            if ( tmp3 ) {
                { // Invoke: unset _parseproc
                    TclObject[] objv4 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: unset
                        objv4[0] = const3;
                        // Arg 1 constant: _parseproc
                        objv4[1] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv4, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv4, 2);
                    }
                } // End Invoke: unset
            }
        } // End Invoke: if
        { // Invoke: set ... 0
            setVarArray(interp, "_parseproc", "procs_parsed", const4, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... {0 0}
            setVarArray(interp, "_parseproc", "inscript_range", const5, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set _parseproc(inscript) ""
            setVarArray(interp, "_parseproc", "inscript", const6, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set ... ""
            setVarArray(interp, "_parseproc", "outscript", const6, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set _parseproc(proclist) [...]
            TclObject tmp5;
            { // Invoke: list
                TclObject tmp6 = TclList.newInstance();
                interp.setResult(tmp6);
            } // End Invoke: list
            tmp5 = interp.getResult();
            setVarArray(interp, "_parseproc", "proclist", tmp5, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set _parseproc(debug) 0
            setVarArray(interp, "_parseproc", "debug", const4, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: set _parseproc(filename) ""
            setVarArray(interp, "_parseproc", "filename", const6, compiledLocals, 0);
        } // End Invoke: set
        { // Invoke: descend_init
            TclObject[] objv7 = TJC.grabObjv(interp, 1);
            try {
                // Arg 0 constant: descend_init
                objv7[0] = const7;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                    ? cmdcache3.cmd : null), objv7, 0);
                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                    updateCmdCache(interp, 3);
                }
            } finally {
                TJC.releaseObjv(interp, objv7, 1);
            }
        } // End Invoke: descend_init
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parseproc_init");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_parseproc");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("unset");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(0);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("0 0");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_init");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "unset";
                break;
            }
            case 3: {
                cmdName = "descend_init";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_parseproc"
    };
} // end class ParseprocInitCmd

